* gsvexe.s
* version 0.22

	.include	iocscall.mac
	.include	doscall.mac
	.include	gm_internal.mac

*-------------------------------------------------------------------------------
* IR[h̒`

	.offset	0
EXIT_NO_ERROR		.ds.b	1
EXIT_HELP		.ds.b	1
EXIT_ERROR_SETBLOCK	.ds.b	1
EXIT_ERROR_MALLOC	.ds.b	1
EXIT_ERROR_MFREE	.ds.b	1
EXIT_ERROR_FILE_SEARCH	.ds.b	1
EXIT_ERROR_FILE_EXECUTE	.ds.b	1
	.text

*-------------------------------------------------------------------------------
* }N`

_TO_SUPER	.macro
* X[p[oCU[[h
	clr.l	-(sp)
	DOS	_SUPER
	addq.l	#4,sp
	move.l	d0,-(sp)
	.endm

_TO_USER	.macro
		.local	super_end
* [U[[h
	move.l	(sp)+,d0
	bmi	super_end
	move.l	d0,-(sp)
	DOS	_SUPER
	addq.l	#4,sp
super_end:
	.endm

*-------------------------------------------------------------------------------
* 烁CvO

	.bss
environment_pointer:
	.ds.l	1
filename:
	.ds.b	256
command_line:
	.ds.b	256

	.text
program_start:
	lea	$10(a0),a0
	sub.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK
	addq.l	#8,sp
	tst.l	d0
	bmi	error_setblock

	move.l	a3,environment_pointer
	lea	filename(pc),a4
	lea	command_line(pc),a5

	tst.b	(a2)+
	beq	help

	clr.b	hi_speed_mode_flag
	clr.b	screen_off_flag
	clr.b	key_buffer_flush_flag
switch:
	move.b	(a2),d0
	beq	help
	cmp.b	#'-',d0
	bne	switch_end
	addq.l	#1,a2
switch_loop:
	move.b	(a2)+,d0
	beq	help
	cmp.b	#' ',d0
	beq	switch
	cmp.b	#'s',d0
	beq	opt_s
	cmp.b	#'o',d0
	beq	opt_o
	cmp.b	#'k',d0
	beq	opt_k
	bra	help
opt_s:
	move.b	#$ff,hi_speed_mode_flag
	bra	switch_loop
opt_o:
	move.b	#$ff,screen_off_flag
	bra	switch_loop
opt_k:
	move.b	#$ff,key_buffer_flush_flag
	bra	switch_loop

switch_end:

*-----------------------------------------------------------------------------
* p[^󂯎
	move.l	a4,a0
@@:
	move.b	(a2)+,(a0)+
	bne	@b

*-----------------------------------------------------------------------------
* s

	bsr	key_buffer_flush
	bsr	graphic_push

	clr.l	-(sp)
	pea	(a5)
	pea	(a4)
	move.w	#2,-(sp)
	DOS	_EXEC			* vOpathT[`
	lea	14(sp),sp
	tst.l	d0
	bmi	error_file_search	* Ȃ

	movem.l	d1-d7/a0-a6,-(sp)
	clr.l	-(sp)
	pea	(a5)
	pea	(a4)
	clr.w	-(sp)
	DOS	_EXEC			* vOs
	lea	14(sp),sp
	movem.l	(sp)+,d1-d7/a0-a6
	tst.l	d0
	bmi	error_file_execute

	bsr	graphic_pop

	move.w	d0,-(sp)
	DOS	_EXIT2

*-------------------------------------------------------------------------------
* L[obt@NA.

	.bss
key_buffer_flush_flag:
	.ds.b	1

	.text
key_buffer_flush:
	tst.b	key_buffer_flush_flag
	beq	key_buffer_flush_end

	move.w	#10000,d4		* [vMAX
					* obt@񂾂Ƃ̈
key_buffer_flush_loop:
	subq.w	#1,d4
	bmi	key_buffer_flush_end

	move.w	#$ff,-(sp)
	move.w	#6,-(sp)
	DOS	_KFLUSH
	addq.l	#4,sp

	moveq.l	#$e,d2
	clr.b	d3
@@:
	move.w	d2,d1
	IOCS	_BITSNS
	or.b	d0,d3
	dbra	d2,@b
	tst.b	d3
	bne	key_buffer_flush_loop

	move.w	#$ff,-(sp)
	move.w	#6,-(sp)
	DOS	_KFLUSH
	addq.l	#4,sp
key_buffer_flush_end:
	rts

*-------------------------------------------------------------------------------
* }N`

_HSYNC_WAIT2	.macro
		.local	_HSYNC_WAIT2_loop
_HSYNC_WAIT2_loop:
	tst.b	$e88001
	bpl	_HSYNC_WAIT2_loop
	.endm

_HSYNC_WAIT	.macro
		.local	_HSYNC_WAIT_loop
_HSYNC_WAIT_loop:
	tst.b	$e88001
	bmi	_HSYNC_WAIT_loop
	_HSYNC_WAIT2
	.endm

*-------------------------------------------------------------------------------
* V-DISP݂Đ\Ԃ͑҂

	.text
vdisp_wait:
	btst.b	#4,$e88001
	beq	vdisp_wait
vdisp_wait2:
	btst.b	#4,$e88001
	bne	vdisp_wait2
	rts

*-------------------------------------------------------------------------------
* OtBbNۑ

	.bss
gpalette_keep_flag:
	.ds.b	1
hi_speed_mode_flag:
	.ds.b	1
screen_off_flag:
	.ds.b	1
	.even
iocs_mode:
	.ds.w	1
malloc_pointer:
	.ds.l	1
gpalette:
	.ds.w	256
gpalette_keep:
	.ds.w	16
crtc_r20:
	.ds.w	1
crtc_r21:
	.ds.w	1
videoc_r1:
	.ds.w	1
videoc_r2:
	.ds.w	1
videoc_r3:
	.ds.w	1

	.text
	.xdef	graphic_push
graphic_push:
	movem.l	d0-d7/a0-a6,-(sp)

	clr.b	gpalette_keep_flag
	clr.l	malloc_pointer

	move.l	#512*1024,-(sp)
	move.w	#2,-(sp)		* ʂm
	DOS	_MALLOC2
	addq.l	#6,sp
	tst.l	d0
	bmi	graphic_push_end
	move.l	d0,malloc_pointer

	moveq.l	#-1,d1
	IOCS	_CRTMOD
	move.w	d0,iocs_mode

	_TO_SUPER
	move.w	$e80028,d0
	move.w	d0,crtc_r20
	lsr.w	#8,d0
	and.w	#%111,d0
	move.w	$e8002a,crtc_r21
	move.w	$e82400,videoc_r1
	move.w	$e82500,videoc_r2
	move.w	$e82600,videoc_r3

	tst.b	screen_off_flag
	beq	@f
	clr.w	$e82600
@@:

	move.l	malloc_pointer,a1
	lea	$c00000,a0

	btst.b	#3,crtc_r20
	beq	@f
	btst.l	#2,d0
	bne	graphic_push_16_off
	tst.b	d0
	beq	graphic_push_16_off
	bra	graphic_push_64k
@@:
	btst.l	#2,d0
	bne	graphic_push_16_1024
	tst.b	d0
	beq	graphic_push_16
	cmp.b	#%11,d0
	beq	graphic_push_64k
	bra	graphic_push_256

graphic_push_16_1024:
	tst.b	hi_speed_mode_flag
	bne	graphic_push_16_1024_hi_speed

	move.l	#(512/4)*1024-1,d7
	moveq.l	#4,d5
@@:
	movem.l	(a0)+,d0-d3
	lsl.l	d5,d0
	or.l	d1,d0
	lsl.l	d5,d0
	or.l	d2,d0
	lsl.l	d5,d0
	or.l	d3,d0
	move.l	d0,(a1)+

	subq.l	#1,d7
	bpl	@b
	moveq.l	#0,d0
	bra	graphic_push_gpalette

graphic_push_16_1024_hi_speed:
	bset.b	#3,$e80028
	clr.w	$e82600

graphic_push_16_off:
	move.l	#(512/4)*(1024/8)-1-1,d7
	add.l	#512*1024,a1
@@:
	movem.l	(a0)+,d0-d6/a2
	movem.l	d0-d6/a2,-(a1)

	subq.l	#1,d7
	bpl	@b

	movem.l	(a0)+,d0-d6
	move.l	(a0)+,a2
	movem.l	d0-d6/a2,-(a1)

	move.w	crtc_r20,$e80028
	moveq.l	#0,d0
	bra	graphic_push_gpalette

graphic_push_16:
	bra	graphic_push_16_1024		* ^^;

graphic_push_256:
	move.l	#(512/4)*1024-1-1,d7
	moveq.l	#8,d5
@@:
	movem.l	(a0)+,d0-d3
	lsl.l	d5,d0
	or.l	d1,d0
	lsl.l	d5,d2
	or.l	d3,d2
	move.l	d0,(a1)+
	move.l	d2,(a1)+

	subq.l	#1,d7
	bpl	@b

	movem.l	(a0)+,d0-d2
	move.l	(a0)+,d3
	lsl.l	d5,d0
	or.l	d1,d0
	lsl.l	d5,d2
	or.l	d3,d2
	move.l	d0,(a1)+
	move.l	d2,(a1)+

	moveq.l	#0,d1
	bra	graphic_push_gpalette

graphic_push_64k:
	move.l	#(512/4)*(1024/8)-1-1,d7
	add.l	#512*1024,a1
@@:
	movem.l	(a0)+,d0-d6/a2
	movem.l	d0-d6/a2,-(a1)

	subq.l	#1,d7
	bpl	@b

	movem.l	(a0)+,d0-d6
	move.l	(a0)+,a2
	movem.l	d0-d6/a2,-(a1)

	moveq.l	#2,d0

graphic_push_gpalette:
	lea	$e82000,a0
	lea	gpalette,a1
	move.w	#256-1,d7
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.w	(a0)+,(a1)+
	dbra	d7,@b

	tst.l	d0
	bne	graphic_push_gpalette_not_keep_palette
	move.w	#_GM_KEEP_PALETTE_GET,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	cmp.l	d2,d0
	beq	graphic_push_gpalette_not_keep_palette
	cmp.w	#_GM_INTERNAL_MODE,d0
	bne	graphic_push_gpalette_not_keep_palette
	swap.w	d0
	tst.w	d0
	beq	graphic_push_gpalette_not_keep_palette
	lea	gpalette_keep,a0
	moveq.l	#16-1,d7
@@:
	move.w	(a1)+,(a0)+
	dbra	d7,@b
	move.b	#1,gpalette_keep_flag

graphic_push_gpalette_not_keep_palette:
	_TO_USER

graphic_push_end:
	movem.l	(sp)+,d0-d7/a0-a6
	rts

*-------------------------------------------------------------------------------
* OtBbNA

	.text
	.xdef	graphic_pop
graphic_pop:
	movem.l	d0-d7/a0-a6,-(sp)

	move.l	malloc_pointer,d0
	tst.l	d0
	beq	graphic_pop_end

	move.w	iocs_mode,d1
	or.w	#$0100,d1
	IOCS	_CRTMOD

	_TO_SUPER
	move.w	crtc_r20,d0
	move.w	d0,$e80028
	lsr.w	#8,d0
	and.w	#%111,d0
	move.w	crtc_r21,$e8002a
	move.w	videoc_r1,$e82400
	move.w	videoc_r2,$e82500
	move.w	videoc_r3,d1
	and.w	#$ffe0,d1
	move.w	d1,$e82600

	move.l	malloc_pointer,a1
	lea	$c00000,a0

	btst.b	#3,crtc_r20
	beq	@f
	btst.l	#2,d0
	bne	graphic_pop_16_off
	tst.b	d0
	beq	graphic_pop_16_off
	bra	graphic_pop_64k
@@:
	btst.l	#2,d0
	bne	graphic_pop_16_1024
	tst.b	d0
	beq	graphic_pop_16
	cmp.b	#%11,d0
	beq	graphic_pop_64k
	bra	graphic_pop_256

graphic_pop_16_1024:
	tst.b	hi_speed_mode_flag
	bne	graphic_pop_16_1024_hi_speed

	move.l	#(512/4)*1024-1,d7
	moveq.l	#4,d5
	add.l	#512*1024*4,a0
	add.l	#512*1024,a1
@@:
	move.l	-(a1),d0
	move.l	d0,d3
	lsr.l	d5,d0
	move.l	d0,d2
	lsr.l	d5,d0
	move.l	d0,d1
	lsr.l	d5,d0
	movem.l	d0-d3,-(a0)

	subq.l	#1,d7
	bpl	@b
	moveq.l	#0,d0
	bra	graphic_pop_gpalette

graphic_pop_16_1024_hi_speed:
	bset.b	#3,$e80028

graphic_pop_16_off:
	move.l	#(512/4)*(1024/8)-1,d7
	add.l	#512*1024,a0
@@:
	movem.l	(a1)+,d0-d6/a2
	movem.l	d0-d6/a2,-(a0)

	subq.l	#1,d7
	bpl	@b
	move.w	crtc_r20,$e80028
	moveq.l	#0,d0
	bra	graphic_pop_gpalette

graphic_pop_16:
	bra	graphic_pop_16_1024		* ^^;

graphic_pop_256:
	move.l	#(512/4)*1024-1,d7
	moveq.l	#4,d5
	add.l	#512*1024*4,a0
	add.l	#512*1024,a1
@@:
	move.l	-(a1),d0
	move.l	d0,d3
	lsr.l	d5,d0
	move.l	d0,d2
	lsr.l	d5,d0
	move.l	d0,d1
	lsr.l	d5,d0
	movem.l	d0-d3,-(a0)

	subq.l	#1,d7
	bpl	@b

	moveq.l	#1,d0
	bra	graphic_pop_gpalette

graphic_pop_64k:
	move.l	#(512/4)*(1024/8)-1,d7
	add.l	#512*1024,a0
@@:
	movem.l	(a1)+,d0-d6/a2
	movem.l	d0-d6/a2,-(a0)

	subq.l	#1,d7
	bpl	@b
	moveq.l	#2,d0

graphic_pop_gpalette:
	lea	$e82000,a0
	lea	gpalette,a1
	move.w	#256-1,d7
	_HSYNC_WAIT
@@:
	_HSYNC_WAIT2
	move.w	(a1)+,(a0)+
	dbra	d7,@b

	tst.l	d0
	bne	graphic_pop_gpalette_256
	tst.b	gpalette_keep_flag
	beq	graphic_pop_gpalette_not_keep_palette
	move.w	#_GM_KEEP_PALETTE_GET,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	swap.w	d0
	lea	gpalette_keep,a0
	moveq.l	#16-1,d7
@@:
	move.w	(a0)+,(a1)+
	dbra	d7,@b

graphic_pop_gpalette_not_keep_palette:
	bclr.b	#3,$e80028
	move.w	#_GM_GVRAM_SAVE,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	move.w	crtc_r20,$e80028

	move.w	#_GM_MASK_CLEAR,d1
	bsr	_gm_internal_tgusemd
	lea	$e80018,a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	bra	graphic_pop_on

graphic_pop_gpalette_256:
	cmp.b	#1,d0
	bne	graphic_pop_gpalette_64k
	move.w	#_GM_MASK_CLEAR,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	lea	$e80018,a0
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	bra	graphic_pop_on

graphic_pop_gpalette_64k:
	cmp.b	#2,d0
	bne	graphic_pop_on
	move.w	#_GM_AUTO_STATE,d1
	moveq.l	#-1,d2
	bsr	_gm_internal_tgusemd
	cmp.l	d2,d0
	beq	graphic_pop_no_gm
	cmp.w	#_GM_INTERNAL_MODE,d0
	bne	graphic_pop_no_gm
	swap.w	d0
	move.w	#_GM_MASK_CLEAR,d1
	btst.l	#0,d0
	bne	@f			* }XN֎~
	btst.l	#1,d0
	beq	@f			* }XNȂ
	move.w	#_GM_MASK_SET,d1
@@:
	bsr	_gm_internal_tgusemd
graphic_pop_no_gm:
	clr.l	d0
	cmp.w	#$0316,$e80028
	bne	@f
	move.l	#$ff80_0000,d0
@@:
	lea	$e80018,a0
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+
	move.l	d0,(a0)+

graphic_pop_on:
	bsr	vdisp_wait
	move.w	videoc_r3,$e82600
	_TO_USER

graphic_pop_end:
	movem.l	(sp)+,d0-d7/a0-a6
	rts

*-------------------------------------------------------------------------------
* [h TGUSEMD R[

	.text
_gm_internal_tgusemd:
	swap.w	d1
	move.w	#_GM_INTERNAL_MODE,d1
	swap.w	d1
	IOCS	_TGUSEMD
	rts

*-------------------------------------------------------------------------------
* wvI

	.data
message_help:
	.dc.b	'Graphic Saving Execute v0.22 (c)JACK',13,10
	.dc.b	'usage: gsvexe [-so] <command>',13,10
	.dc.b	'	-s	hi speed mode(16 colors only)',13,10
	.dc.b	'	-o	screen off',13,10
	.dc.b	'	-k	key-buffer flush',13,10
	.dc.b	13,10
	.dc.b	0

	.text
help:
	pea	message_help
	DOS	_PRINT
	addq.l	#4,sp
	move.w	#EXIT_HELP,-(sp)
	DOS	_EXIT2

*-------------------------------------------------------------------------------
* G[

	.data
message_error_setblock:
	.dc.b	'ubN̕ύXł܂B',13,10
	.dc.b	0
message_error_file_search:
	.dc.b	'܂B',13,10
	.dc.b	0
message_error_file_execute:
	.dc.b	'sł܂B',13,10
	.dc.b	0
message_error_file:
	.dc.b	't@C'
	.dc.b	0

	.text
error_setblock:
	lea	message_error_setblock(pc),a0
	move.w	#EXIT_ERROR_SETBLOCK,d0
	bra	error_exit

error_file_search:
	lea	message_error_file_search(pc),a0
	move.w	#EXIT_ERROR_FILE_SEARCH,d0
	bra	error_file

error_file_execute:
	lea	message_error_file_execute(pc),a0
	move.w	#EXIT_ERROR_FILE_EXECUTE,d0
	bra	error_file

error_file:
	exg.l	d0,d1
	pea	message_error_file(pc)
	DOS	_PRINT
	addq.l	#4,sp
	exg.l	d0,d1

error_exit:
	move.w	d0,-(sp)
	move.l	a0,-(sp)
	DOS	_PRINT
	addq.l	#4,sp
	DOS	_ALLCLOSE
	DOS	_EXIT2

*-------------------------------------------------------------------------------

	.end	program_start
