# cmdhis.s - command history
# Copyright (C) 2003 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Include File -------------------------------- *

		.include	mrl.mac
		.include	mint.mac
		.include	window.mac
		.include	message.mac
		.include	sysval.def

		.include	doscall.mac


* Global Symbol ------------------------------- *

* help.s
		.xref	help_menu_getarg
		.xref	help_menu
* madoka3.s
		.xref	execute_quick,free_token_buf
		.xref	open_rl_win
		.xref	CMD_SW_SIZE
* mint.s
		.xref	malloc_mode
* outside.s
		.xref	break_check1


* Constant ------------------------------------ *

MAX_LINE:	.equ	23

RL_MAX:		.equ	$ffff


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even


* &command-history-menu  ---------------- *
* in	d0.hw	$0000:ҏWɎs $ffff:ҏWĂs
*	d0.lw	qXgԍ(1`)
*	d7.l	̐
*	a0.l	̃AhX
* out	d0.l	0:s -1:LZ
*	ccr	<tst.l d0> ̌

command_history::
		PUSH	d1-d7/a0-a5

.ifdef PRINT_CMD_HIS
		bsr	print_cmd_his
.endif
		move.l	d0,d6			;ҏW[h | ݂̃qXgԍ
		tst	d0
		beq	cmd_his_error
		bsr	get_cmd_his_num
		move	d0,d5			;qXg
		beq	cmd_his_error
		cmp	d0,d6
		bhi	cmd_his_error

		move.l	#CMD_SW_SIZE+1+RL_MAX+1,-(sp)
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	cmd_his_error

		movea.l	d0,a4
		tst.l	d6
		bpl	cmd_his_direct		;ҏWȂ

		GETMES	MES_CHIST
		bra	cmd_his_arg_next
cmd_his_arg_loop:
		cmpi.b	#'-',(a0)
		bne	cmd_his_arg_skip
		cmpi.b	#'t',(1,a0)
		bne	cmd_his_arg_skip
*cmd_his_opt_t:
		addq.l	#2,a0			;-t"^Cg"
@@:		tst.b	(a0)+
		bne	@f
		subq.l	#1,d7
		bcc	@b
		bra	cmd_his_arg_end
@@:
		subq.l	#1,a0
		move.l	a0,d0
cmd_his_arg_skip:
		tst.b	(a0)+
		bne	cmd_his_arg_skip
cmd_his_arg_next:
		subq.l	#1,d7
		bcc	cmd_his_arg_loop
cmd_his_arg_end:
		jsr	(open_rl_win)
		move	d0,-(sp)
		move	#78,-(sp)		;EBhE
cmd_his_loop:
		move.l	(sp),d0
		moveq	#1,d1
		moveq	#1,d2
		jsr	(WinSetCursor)

		move	d6,d0			;qXgobt@ɓ]
		bsr	get_cmd_his
		movea.l	d0,a0
		lea	(a4),a1
		STRCPY	a0,a1

		lea	(a4),a1			;R}hXCb`΂
@@:		cmpi.b	#TAB,(a1)+
		bne	@b

		move.l	#RL_MAX<<16,d1
		cmp	d5,d6
		beq	@f			;ȏÂqXg͖
		addq	#RL_F_RD,d1
@@:		cmpi	#1,d6
		beq	@f			;ȏVqXg͖
		addq	#RL_F_RU,d1
@@:
		move.l	(sp),d0
		jsr	(MintReadLine)
		move.l	d0,d2
		jsr	(break_check1)		;u[NL[̏ԂXV
		tst.l	d2
		ble	cmd_his_decide

		addq	#1,d6			;ROLL DOWN ŌÂqXgֈړ
		subq.l	#RL_E_PREV,d2
		beq	@f
		subq	#1+1,d6			;ROLL UP ŐVqXgֈړ
@@:		bra	cmd_his_loop

cmd_his_decide:
		move.l	(sp)+,d0
		jsr	(WinClose)
		tst.l	d2
		beq	cmd_his_exec
*cmd_his_cancel:
		pea	(a4)
		DOS	_MFREE
		addq.l	#4,sp
		bra	cmd_his_error

cmd_his_direct:
		move	d6,d0
		bsr	get_cmd_his
		movea.l	d0,a0
		lea	(a4),a1
		STRCPY	a0,a1
cmd_his_exec:
		STRLEN	a4,d0,+1
		move.l	d0,-(sp)
		pea	(a4)
		DOS	_SETBLOCK
		addq.l	#8,sp

		lea	(a4),a1
		moveq	#TAB,d1
@@:		cmp.b	(a1)+,d1
		bne	@b
		clr.b	(-1,a1)			;R}hXCb`ƃR}hC
		lea	(a4),a0			;
		bsr	add_cmd_his
		move.b	d1,-(a1)

		moveq	#%0000_0100,d0
		lea	(a4),a1
		jsr	(free_token_buf)
		jsr	(execute_quick)

		moveq	#0,d0
cmd_his_end:
		POP	d1-d7/a0-a5
		rts
cmd_his_error:
		moveq	#-1,d0
		bra	cmd_his_end


* &command-history  --------------------- *
* in	d7.l	̐
*	a0.l	̃AhX
* out	d0.hw	$0000:mI $ffff:'E'/'V'
*	d0.lw	IsԍqXgԍ(1`)
*		d0.l = 0 ȂLZ
*	ccr	<tst.l d0> ̌

command_history_menu::
		PUSH	d1-d7/a0-a5

* ̂̏ help.s (ext_help_decode_end `)
* Ƃقړ
		moveq	#MES_CHISM,d0
		moveq	#1,d3			;J[\ʒu
		jsr	help_menu_getarg
		lea	(subwin_menu,pc),a0
		move.l	a3,(SUBWIN_TITLE,a0)

		bsr	get_cmd_his_num
		move.l	d0,d7
		beq	cmd_his_menu_error	;qXgo^

		moveq	#MAX_LINE,d0
		cmp	d7,d0
		bls	@f
		move	d7,d0
@@:		move	d0,(SUBWIN_YSIZE,a0)

		moveq	#32,d1
		sub	d0,d1
		lsr	#2,d1
		addq	#1,d1
		move	d1,(SUBWIN_Y,a0)

		move.l	d3,d0			;-l<n>
		move.l	d7,d1			;s
		lea	(get_cmd_his2,pc),a1
		jsr	(help_menu)
		tst.l	d0
cmd_his_menu_end:
		POP	d1-d7/a0-a5
		rts
cmd_his_menu_error:
		moveq	#0,d0
		bra	cmd_his_menu_end


* R}hqXgo^ ------------------------ *
* in	a0.l	XCb`
*	a1.l	R}hC
* out	d0.l	0:o^ -1:s
*	ccr	<tst.l d0> ̌

add_cmd_his::
		PUSH	d1/a0-a5
		lea	(cmd_his_buf_adr,pc),a5
		tst.l	(a5)
		beq	add_ch_error
		cmpi.b	#'-',(a0)
		bne	add_ch_error
		tst.b	(a1)
		beq	add_ch_error

* ̃R}ho^ς݂Ȃ폜
		movea.l	(a5),a2			;cmd_his_buf_adr
add_ch_loop:
		lea	(a2),a4
		lea	(a0),a3
@@:
		cmpm.b	(a3)+,(a4)+
		beq	@b
		tst.b	-(a3)
		bne	add_ch_next		;R}hXCb`Ⴄ
		cmpi.b	#TAB,(-1,a4)
		bne	add_ch_next		;V
		lea	(a1),a3
@@:
		cmpm.b	(a3)+,(a4)+
		bne	add_ch_next		;R}hCႤ
		tst.b	(-1,a4)
		bne	@b
		bra	1f
@@:
		STRCPY	a4,a2
1:		move.b	(a4),(a2)
		bne	@b			;擪 NUL ȂI
		move.l	a2,(cmd_his_buf_ptr-cmd_his_buf_adr,a5)
		bra	@f
add_ch_next:
		tst.b	(a2)+
		bne	add_ch_next
		tst.b	(a2)
		bne	add_ch_loop
@@:
		STRLEN	a0,d0,+1
		STRLEN	a1,d1,+1
		add.l	d0,d1			;ރTCY
		cmp.l	(cmd_his_buf_size,pc),d1
		bcc	add_ch_error		;
add_ch_loop2:
		lea	(a5),a4
		movea.l	(a4)+,a2		;cmd_his_buf_adr
		movea.l	(a4)+,a3		;cmd_his_buf_ptr
		adda.l	(a4),a2			;cmd_his_buf_size
		adda.l	d1,a3
		cmpa.l	a3,a2
		bhi	add_ch_copy

* \Ȏceʂΐ擪̍ڂ폜
		movea.l	(a5),a2			;cmd_his_buf_adr
		lea	(a2),a3
@@:		tst.b	(a2)+
		bne	@b
		bra	1f
@@:
		STRCPY	a2,a3
1:		move.b	(a2),(a3)
		bne	@b			;擪 NUL ȂI

		move.l	a3,-(a4)		;cmd_his_buf_ptr
		bra	add_ch_loop2
add_ch_copy:
		suba.l	d1,a3
		STRCPY	a0,a3
		move.b	#TAB,(-1,a3)
		STRCPY	a1,a3
		clr.b	(a3)

		move.l	a3,-(a4)		;cmd_his_buf_ptr
		moveq	#0,d0
add_ch_end:
		POP	d1/a0-a5
		rts
add_ch_error:
		moveq	#-1,d0
		bra	add_ch_end


* R}hqXgԂ ---------------------- *
* in	d0.w	qXgԍ(1`)
* out	d0.l	qXg̃AhX
* l:
*	R}hXCb`΂AhXԂ.

get_cmd_his2::
		move.l	a0,-(sp)
		bsr	get_cmd_his
		movea.l	d0,a0
@@:
		cmpi.b	#TAB,(a0)+
		bne	@b
		move.l	a0,d0
		movea.l	(sp)+,a0
		rts


* R}hqXgԂ ---------------------- *
* in	d0.w	qXgԍ(1`)
* out	d0.l	qXg̃AhX

get_cmd_his::
		PUSH	d1/a0
		move	d0,d1
		bsr	get_cmd_his_num
		movea.l	(cmd_his_buf_adr,pc),a0
		sub	d1,d0
		beq	get_cmd_his_end
@@:
		tst.b	(a0)+
		bne	@b
		subq	#1,d0
		bne	@b
get_cmd_his_end:
		move.l	a0,d0
		POP	d1/a0
		rts


* R}hqXgo^Ԃ ---------------- *
* out	d0.l	o^(0 Ȃ疢o^)
*		(1`d0.l ̃qXgLAő 65535)
*	ccr	<tst.l d0> ̌

get_cmd_his_num::
		move.l	a0,-(sp)
		move.l	(cmd_his_buf_adr,pc),d0
		beq	9f
		movea.l	d0,a0
		moveq	#0,d0
		bra	1f
@@:
		tst.b	(a0)+			;qXg̐𐔂
		bne	@b
		addq.l	#1,d0
1:		tst.b	(a0)
		bne	@b
9:
		movea.l	(sp)+,a0
		rts


* R}hqXgo^Ă邩ׂ ---- *
* out	d0.l	0:Ȃ '-':
*	ccr	<tst.l d0> ̌

is_exist_cmd_his::
		move.l	(cmd_his_buf_adr,pc),d0
		beq	@f
		move.l	a0,-(sp)
		movea.l	d0,a0
		move.b	(a0),d0
		movea.l	(sp)+,a0
@@:		rts


* obt@m -------------------------------- *

alloc_cmd_his_buf::
		PUSH	d0/d6-d7/a0-a1/a5
		lea	(cmd_his_buf_adr,pc),a5
		moveq	#0,d7
		move	(hist),d7		;obt@e
		beq	alloc_chb_zero		;obt@mۂȂ
		cmp.l	(cmd_his_buf_size,pc),d7
		beq	alloc_chb_end		;TCYύXȂ

		move.l	d7,-(sp)		;Vobt@mۂ
		move	(malloc_mode),-(sp)
		DOS	_MALLOC2
		addq.l	#6,sp
		tst.l	d0
		bmi	alloc_chb_end

		movea.l	d0,a0			;Vobt@
		clr.l	(a0)

		move.l	(a5),d6			;ȑÕobt@
		move.l	a0,(a5)+		;cmd_his_buf_adr
		move.l	a0,(a5)+		;cmd_his_buf_ptr
		move.l	d7,(a5)+		;cmd_his_buf_size
		tst.l	d6
		ble	alloc_chb_end

* ȑÕobt@ɓo^ĂqXg
* Vobt@ɓo^

		movea.l	d6,a1
		moveq	#TAB,d7
alloc_chb_loop:
		tst.b	(a1)
		beq	alloc_chb_free
		lea	(a1),a0
@@:
		cmp.b	(a1)+,d7		;R}hXCb`΂
		bne	@b
		clr.b	(-1,a1)
		bsr	add_cmd_his
@@:
		tst.b	(a1)+
		bne	@b
		bra	alloc_chb_loop
alloc_chb_zero:
		move.l	(a5),d6			;ȑÕobt@
		clr.l	(a5)+			;cmd_his_buf_adr
		clr.l	(a5)+			;cmd_his_buf_ptr
		clr.l	(a5)+			;cmd_his_buf_size
alloc_chb_free:
		move.l	d6,-(sp)		;ȑÕobt@
		ble	@f
		DOS	_MFREE
@@:		addq.l	#4,sp
alloc_chb_end:
		POP	d0/d6-d7/a0-a1/a5
		rts


* qXgo ---------------------------- *
* out	d0.l	obt@TCY(L̂)
*	a0.l	obt@AhX

get_cmd_his_size::
		movea.l	(cmd_his_buf_adr,pc),a0
		move.l	(cmd_his_buf_ptr,pc),d0
		beq	@f
		sub.l	a0,d0
@@:		rts


* qXgǂݍ ---------------------------- *
* in	d0.w	t@Cnh
*	d1.l	TCY

load_cmd_his::
		PUSH	d0-d1/d7/a0-a1
		move	d0,d7
		bmi	load_cmd_his_end
		tst.l	d1
		beq	load_cmd_his_end

		cmp.l	(cmd_his_buf_size,pc),d1
		bcc	load_cmd_his_end

		lea	(cmd_his_buf_adr,pc),a0
		move.l	(a0)+,d0
		beq	load_cmd_his_end
		movea.l	d0,a1			;cmd_his_buf_adr

		move.l	d1,-(sp)
		pea	(a1)
		move	d7,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d1
		beq	@f
		moveq	#0,d1			;ǂݍݎs
@@:
		adda.l	d1,a1
		clr.b	(a1)			; NUL u
		move.l	a1,(a0)			;cmd_his_buf_ptr
load_cmd_his_end:
		POP	d0-d1/d7/a0-a1
		rts


* R}hqXg\ ------------------------ *

.ifdef PRINT_CMD_HIS
print_cmd_his:
		PUSH	d0/a0
		move.l	(cmd_his_buf_adr,pc),d0
		beq	print_cmd_his_end
		movea.l	d0,a0
		bra	1f
print_cmd_his_loop:
		pea	(a0)
		DOS	_PRINT
		addq.l	#4,sp
		jsr	(PrintCrlf)
@@:
		tst.b	(a0)+
		bne	@b
1:		tst.b	(a0)
		bne	print_cmd_his_loop
print_cmd_his_end:
		POP	d0/a0
		rts
.endif


* Data Section -------------------------------- *

**		.data
		.even

subwin_menu:	SUBWIN	8,6,80,0,NULL,NULL


* Block Storage Section ----------------------- *

**		.bss
		.even

cmd_his_buf_adr:
		.ds.l	1
cmd_his_buf_ptr:
		.ds.l	1
cmd_his_buf_size:
		.ds.l	1


		.end

* End of File --------------------------------- *
