/* dos_mvdir.h - DOS _MVDIR function call header
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef	__dos_mvdir_h__
#define	__dos_mvdir_h__

#ifndef __GNUC__
#error You lose. This file can be compiled only by GNU-C compiler.
#endif

#include <cdecl.h>

#define MVDIR_ID	(('M'<<24)|('v'<<16)|('D'<<8)|'i')

#define MVDIR_GETID	0
#define MVDIR_GETVER	1
#define MVDIR_UNHOOK	2
#define MVDIR_MOVE	3

__asm (".ifndef _di_mvdir\n"
       "_di_mvdir:  .equ $ffb1\n"
       "_di_mvdir2: .equ $ffb1\n"
       ".endif");

_EXTERN (__DOSCALL int_ _di_mvdir (short));
_EXTERN (__DOSCALL int_ _di_mvdir2 (short, const char*, const char*));

static __inline int_
_dos_mvdir (int_ mode)
{
    /* call function body */
    return _di_mvdir ((short) mode);
}

static __inline int_
_dos_mvdir2 (int_ mode, const char* src, const char* dst)
{
    /* call function body */
    return _di_mvdir2 ((short) mode, src, dst);
}

#define MvdirGetID()		_dos_mvdir (MVDIR_GETID)
#define MvdirGetVersion()	_dos_mvdir (MVDIR_GETVER)
#define MvdirUnhook()		_dos_mvdir (MVDIR_UNHOOK)
#define MvdirMove(s, d)		_dos_mvdir2 (MVDIR_MOVE, (s), (d))

#endif	/* !__dos_mvdir_h__ */

/* EOF */
