# dos_mvdir.s - DOS _MVDIR function
# Copyright (C) 2000 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Description --------------------------------- *

program:	.reg	'dos_mvdir'
version:	.reg	'0.90'
date:		.reg	'2000/02/29'
author:		.reg	'Ԃq'

N_VERSION:	.equ	$0900			;16bit
*N_MODIFIED:	.equ	0			; 8bit
*N_PATCHLEVEL:	.equ	0			; 8bit

VERSION:	.reg	N_VERSION<<16


* Include File -------------------------------- *

		.include	dos_mvdir.mac

		.include	macro.mac
		.include	dosdef.mac
		.include	console.mac
		.include	doscall.mac


* Structure ----------------------------------- *

;Directory Entry
		.offset	0
DIR_FileName1:	.ds.b	8
DIR_Ext:	.ds.b	3
DIR_Atr:	.ds.b	1
DIR_FileName2:	.ds.b	10
DIR_Time:	.ds	1
DIR_Date:	.ds	1
DIR_Fat:	.ds	1
DIR_FileSize:	.ds.l	1
DIRENT_SIZE:
		.fail	$.ne.32

;Namests Buffer
		.offset	0
NAMESTS_Wild:	.ds.b	1
NAMESTS_Drive:	.ds.b	1
NAMESTS_Path:	.ds.b	65
NAMESTS_Name1:	.ds.b	8
NAMESTS_Ext:	.ds.b	3
NAMESTS_Name2:	.ds.b	10
NAMESTS_SIZE:
		.fail	$.ne.88

DPB_SecByte:	.equ	10


* Text Section -------------------------------- *

		.text

		.cpu	68000


* 풓 -------------------------------------- *

keep_start:
start:
		bra.s	start2
		.dc.b	'#HUPAIR',0
start2:
		bra.w	start3

old_ffb1_vec:	.equ	$-4			;.dc.l 0


* DOS _MVDIR ---------------------------------- *

* V DOS R[ $ffb1(_MVDIR)̏
* in	a6.l	p[^|C^
*	(a6).w	@\ԍ
*		0: hCoʎq̎
*		1: o[W̎
*		2: xN^tbN
*		3: fBNgړs
* out	d0.l	G[R[h(@\ԍ-14)
* break	a6

dos_mvdir:
		move	(a6)+,d0
		beq	get_id
		subq	#2,d0
		bcs	get_version
		beq	unhook
		subq	#2,d0
		bcs	move

		moveq	#-14,d0
		rts


* DOS _MVDIR(0) : hCoʎq̎ -------- *
* out	d0.l	'MvDi'

get_id:
		move.l	#_MVDIR_ID,d0
		rts


* DOS _MVDIR(1) : o[W̎ ------------ *
* out	d0.l	o[W
*		bit 31-16:IWio[W
*		bit 15- 8:\($00)
*		bit  7- 0:\($00)
*		)version 0.90 Ȃ $0900_0000

get_version:
		move.l	#VERSION,d0
		rts


* DOS _MVDIR(2) : xN^tbN ------------ *
* out	d0.l	ubN擪AhX(ȂG[)
*		 0: I
*		-1: G[(s\)

unhook:
		move.l	(old_ffb1_vec,pc),-(sp)
		move	#_MVDIR,-(sp)
		DOS	_INTVCG
		lea	(dos_mvdir,pc),a0
		cmpa.l	d0,a0
		bne	unhook_error		;xN^tbNĂ

		DOS	_INTVCS
		lea	(keep_start-$f0,pc),a0
		move.l	a0,d0
@@:		addq.l	#6,sp
		rts
unhook_error:
		moveq	#-1,d0
		bra	@b


* DOS _MVDIR(3) : fBNgړs -------- *
* in	(a6).l		ړfBNg
*	(4,a6).l	ړfBNg
* out	d0.l	G[R[h

move:
		lea	(-NAMESTS_SIZE*2,sp),sp
		movea.l	(a6)+,a1		;OLD name

		movea.l	sp,a2
		jsr	($b352)
		tst.l	d0			;̃LN^foCX
		bmi	move_end		;݂΃G[

		tst.b	(NAMESTS_Wild,a2)
		bne	move_name_error		;wild/dir w̓G[

		moveq	#0,d0
		move.b	(NAMESTS_Drive,a2),d0
		jsr	($a8be)			;JgfBNg\ DPB Ԃ
		bmi	move_end

		movea.l	a0,a1
		movea.l	d0,a0
		jsr	($b24e)			;zhCu^fBNgWJ
		bmi	move_end
		jsr	($dc02)			;dI[ṽANZX[h
		bmi	move_end

		movea.l	(a6),a1			;NEW name
		lea	(NAMESTS_SIZE,sp),a2
		jsr	($b352)
		tst.l	d0			;̃LN^foCX
		bmi	move_end		;݂΃G[

		tst.b	(NAMESTS_Wild,a2)
		bne	move_name_error		;wild/dir w̓G[

		moveq	#0,d0
		move.b	(NAMESTS_Drive,a2),d0
		jsr	($a8be)			;JgfBNg\ DPB Ԃ
		bmi	move_end

		movea.l	a0,a1
		movea.l	d0,a0
		jsr	($b24e)			;zhCu^fBNgWJ
		bmi	move_end

		move.b	(NAMESTS_Drive,a2),d0
		cmp.b	(NAMESTS_Drive,sp),d0
		bne	move_drive_error

		tst	(DPB_SecByte,a0)
		beq	move_fs_error		;foCX

		jsr	($cbe2)			;fBA݉\ɂȂ܂ő҂
		move.l	a1,d7
		jsr	($bcec)			;fBNgwt@CT
		tst.l	d0
		bpl	move_exist		;ύXt@C݂

		moveq	#-2,d1
		cmp.l	d1,d0
		bne	move_end		;̑̃G[

* NEW ݂ȂΈړ\
		movea.l	a2,a1
		movea.l	sp,a2
.if 0
		pea	(NAMESTS_Path,a2)
		pea	(NAMESTS_Path,a1)
		jsr	($9ea2)			;r
		addq.l	#8,sp
.else
		lea	(2,a2),a4		;NAMESTS_Path
		lea	(2,a1),a5		;NAMESTS_Path
		STRLEN	a4,d0			;roCg-1(NUL ܂Ŕr)
		jsr	($f27c)			;call namecheck_knj_case_cmp
.endif
		beq	move_rename		;pXȂϖ

* ړ({ϖ)
		movea.l	d7,a1
		jsr	($bcec)			;fBNgwt@CT
		tst.l	d0
		bmi	move_end

		moveq	#1<<ATR_DIR+1<<ATR_VOL,d5
		and.b	(DIR_Atr,a1),d5
		eori.b	#1<<ATR_DIR,d5
		bne	move_atr_error		;!DIR || VOL ȂG[

		move	d0,d5			;ItZbg
		move.l	d1,d6			;ZN^ԍ
		move.b	(DIR_FileName1,a1),d4

		jsr	($d0ea)			;rename 
		moveq	#DIRENT_SIZE-1,d0
@@:
		move.b	(a1)+,(a2)+		;fBNgGg]
		dbra	d0,@b

		move.b	#$e5,(-DIRENT_SIZE,a1)	;̃t@C͍폜
		jsr	($b7d2)			;call diskio_readfile/diskio_setflag

		movea.l	d7,a1
		lea	(NAMESTS_SIZE,sp),a2
		jsr	($b848)			;fBNg󂫃GgT
		tst.l	d0
		bmi	move_diskfull

		movea.l	sp,a4
		movea.l	a1,a3
		moveq	#DIRENT_SIZE-1,d2
@@:
		move.b	(a4)+,(a3)+		;fBNgGg]
		dbra	d2,@b
		bra	move_write

* 폜Ggɖ߂
move_diskfull:
		move.l	d0,-(sp)
		move.l	d6,d1
		jsr	($b7d2)			;call diskio_readfile/diskio_setflag
		move.b	d4,(a1,d5.l)
		move.l	(sp)+,d0
		bra	move_end

* ϖ
move_rename:
		movea.l	d7,a1
		jsr	($bcec)			;fBNgwt@CT
		tst.l	d0
		bmi	move_end

		moveq	#1<<ATR_DIR+1<<ATR_VOL,d0
		and.b	(DIR_Atr,a1),d0
		eori.b	#1<<ATR_DIR,d0
		bne	move_atr_error		;!DIR || VOL ȂG[

		jsr	($d0ea)			;rename 
move_write:
		movea.l	a1,a3
		lea	(NAMESTS_SIZE,sp),a2
		lea	(NAMESTS_Name1,a2),a4
		move.b	(a4)+,d0
		cmp.b	#$e5,d0
		bne	@f
		moveq	#$05,d0			;$e5 -> $05
@@:
		move.b	d0,(a3)+
		moveq	#(7+3)-1,d0
@@:
		move.b	(a4)+,(a3)+		;filename1/ext ]
		dbra	d0,@b
		addq.l	#1,a3
		moveq	#10-1,d0
@@:
		move.b	(a4)+,(a3)+		;filename2 ]
		dbra	d0,@b

		move	(DIR_Fat,a1),d6
		jsr	($b7d2)			;call diskio_readfile/diskio_setflag

* fBNg ".."  FAT ԍ
		move	d6,d1
		rol	#8,d1
		jsr	($b22e)			;FAT ZN^ԍvZ
		jsr	($b71a)			;call diskio_readdir

		lea	(a1),a2
		move	(DPB_SecByte,a0),d3
		lsr	#5,d3
		subq	#1,d3			;/32-1
move_dd_loop:
		move.b	(a2),d0
		beq	move_dd_end		;fBNg̏I
		lea	(a2),a3
		cmpi.l	#'..  ',(a3)+		;DIR_FileName1
		bne	move_dd_next
		cmpi.l	#'    ',(a3)+		;V
		bne	move_dd_next
		cmpi.l	#'   '<<8+$10,(a3)+	;DIR_Ext/Atr
		bne	move_dd_next
		tst.b	(a3)+			;DIR_FileName2
		bne	move_dd_next

		movem.l	a1-a2,-(sp)
		movea.l	d7,a1
		lea	(8+NAMESTS_SIZE,sp),a2
		jsr	($b38a)			;fBNg̐擪ZN^𓾂
		jsr	($b372)			;ZN^ԍNX^ԍ߂
		movem.l	(sp)+,a1-a2
		rol	#8,d1
		move	d1,(DIR_Fat,a2)

		jsr	($b808)			;call diskio_setflag
		bra	move_dd_end
move_dd_next:
		lea	(DIRENT_SIZE,a2),a2
		dbra	d3,move_dd_loop
move_dd_end:
		moveq	#0,d0
		jsr	($b6d8)			;call fseek(12)/diskio_flush
		bra	move_end

move_fs_error:
		moveq	#-40,d0			;w[gt@CVXełx
		bra	move_end		;(ƎG[R[h)
move_exist:
		moveq	#-22,d0			;wt@ĈŃl[łȂx
		bra	move_end
move_atr_error:
		moveq	#-19,d0			;ww̃t@C͏݂łȂx
		bra	move_end
move_drive_error:
		moveq	#-15,d0			;whCuwɌ肪x
		bra	move_end
move_name_error:
		moveq	#-13,d0			;wt@C̎wɌ肪x
move_end:
		lea	(NAMESTS_SIZE*2,sp),sp
		rts


* 풓 ------------------------------------ *

keep_end:

start3:
		lea	(GetArgChar,pc),a4
GETARGCHAR:	.macro
		jsr	(a4)
		.endm

		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp
arg_next:
		GETARGCHAR
arg_next2:
		tst.l	d0
		beq	arg_next
		bmi	arg_end

		cmpi.b	#'-',d0
		bne	arg_error
*arg_option:
		GETARGCHAR
		cmpi.b	#'-',d0
		beq	long_option		;--long-option
arg_option_loop:
		cmpi.b	#'?',d0
		beq	print_usage
		ori.b	#$20,d0
		cmpi.b	#'h',d0
		beq	print_usage
		cmpi.b	#'r',d0
		beq	release
		cmpi.b	#'v',d0
		beq	print_version
		bra	arg_error
arg_option_next:
		GETARGCHAR
arg_option_next2:
		tst.b	d0
		bne	arg_option_loop
		bra	arg_next2

* --quiet, --release
* --help, --version
long_option:
		subq.l	#LONGOPT_MAX+1,sp
		lea	(sp),a0
		moveq	#LONGOPT_MAX,d1
get_long_opt_loop:
		GETARGCHAR
		move.b	d0,(a0)+
		dbeq	d1,get_long_opt_loop
		bne	arg_error		;

		lea	(long_opt_tbl,pc),a0
long_opt_cmp_loop:
		tst	(a0)
		beq	arg_error		;݂ȂIvV
		lea	(a0),a1
		adda	(a0)+,a1		;̃AhX
		lea	(a0),a3
		adda	(a0)+,a3		;AhX
		lea	(sp),a2
@@:
		cmpm.b	(a1)+,(a2)+		;r
		bne	long_opt_cmp_loop
		tst.b	(-1,a1)
		bne	@b
		jmp	(a3)

LONGOPT:	.macro	str,job
		.dc	str-$,job-$
		.endm
long_opt_tbl:
		LONGOPT	str_help,	print_usage
		LONGOPT	str_release,	release
		LONGOPT	str_version,	print_version
		.dc	0

arg_end:
		bra	keep			;풓

* 풓 ---------------------------------------- *

keep:
.ifndef UNIX_STYLE
		bsr	print_title
.endif
		bsr	keep_check
		bpl	already_keeped		;ɏ풓Ă

		DOS	_VERNUM
		cmpi	#$0302,d0
		bne	hu_ver_error		;Ή̃o[W Human68k

* 풓
		pea	(dos_mvdir,pc)
		move	#_MVDIR,-(sp)
		DOS	_INTVCG
		lea	(old_ffb1_vec,pc),a0
		move.l	d0,(a0)
		DOS	_INTVCS
		addq.l	#6,sp

* bZ[W\ď풓I
		pea	(keep_mes,pc)
		bsr	print_message
		addq.l	#4,sp

		clr	-(sp)
		pea	(keep_end-keep_start).w
		DOS	_KEEPPR


* 풓 ------------------------------------ *

release:
.ifndef UNIX_STYLE
		bsr	print_title
.endif
		bsr	keep_check
		bmi	not_keeped_error	;풓ĂȂ
		bne	version_error		;풓̃o[WႤ

* 풓
		move	#_MVDIR_UNHOOK,-(sp)
		DOS	_MVDIR
		addq.l	#2,sp
		tst.l	d0
		bmi	release_error

		move.l	d0,-(sp)
		DOS	_MFREE
		addq.l	#4,sp

* bZ[W\ďI
		pea	(release_mes,pc)
		bsr	print_message
		addq.l	#4,sp
		DOS	_EXIT


* 풓 ------------------------------------ *
* out	d0.l	-1:풓
*		 0:o[W풓Ă
*		 1:풓̃o[WႤ
*	ccr	<tst.l d0> ̌

keep_check:
		clr	-(sp)			;_MVDIR_GETID
		DOS	_MVDIR
		addq.l	#2,sp
		tst.l	d0
		bmi	@f
		cmpi.l	#_MVDIR_ID,d0
		beq	keep_check_version
@@:
		moveq	#-1,d0			;풓
		rts
keep_check_version:
		move	#_MVDIR_GETVER,-(sp)
		DOS	_MVDIR
		addq.l	#2,sp
		subi.l	#VERSION,d0
		beq	@f
		moveq	#1,d0			;풓̃o[WႤ
@@:		rts


* Tu[` -------------------------------- *

print_title:
		pea	(title_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
		rts

print_message:
.ifdef UNIX_STYLE
		pea	(header_mes,pc)
		DOS	_PRINT
		move.l	(8,sp),(sp)
.else
		move.l	(4,sp),-(sp)
.endif
		DOS	_PRINT
		addq.l	#4,sp
@@:		rts


* G[ ---------------------------------- *

print_version:
		lea	(ver_mes_end,pc),a0
.ifdef __CRLF__
		move.b	#CR,(a0)+
.endif
		move.b	#LF,(a0)+
		clr.b	(a0)
		bsr	print_title
		DOS	_EXIT

print_usage:
		bsr	print_title
		pea	(usage_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp
		DOS	_EXIT

arg_error:
.ifndef UNIX_STYLE
		bsr	print_title
.endif
		lea	(arg_err_mes,pc),a0
		bra	error_exit
already_keeped:
		lea	(keep_err_mes,pc),a0
		bra	error_exit
hu_ver_error:
		lea	(huver_err_mes,pc),a0
		bra	error_exit
release_error:
		lea	(rel_err_mes,pc),a0
		bra	error_exit
version_error:
		lea	(ver_err_mes,pc),a0
		bra	error_exit
not_keeped_error:
		lea	(nokeep_err_mes,pc),a0
		bra	error_exit

error_exit:
		move	#STDERR,-(sp)
.ifdef UNIX_STYLE
		pea	(header_mes,pc)
		DOS	_FPUTS
		move.l	a0,(sp)
.else
		pea	(a0)
.endif
		DOS	_FPUTS
		addq.l	#6,sp

		move	#1,-(sp)
		DOS	_EXIT2


* HUPAIR Decoder ------------------------------ *

.if 0
GetArgChar_p:	.dc.l	0
GetArgChar_c:	.dc.b	0
.even
		.else
GetArgChar_p:	.equ	GetArgCharInit
GetArgChar_c:	.equ	GetArgCharInit+4
.endif

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(GetArgChar_p,pc),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,pc),a0
		seq	(a0)
		move.l	a1,-(a0)
		movem.l	(sp)+,a0-a1
		rts


* Data Section -------------------------------- *

		.data
		.even

title_mes:	.dc.b	program,' version ',version
ver_mes_end:	.dc.b	'  ',date,' ',author,'.',CRLF,0

usage_mes:	.dc.b	'usage: ',program,' [option]',CRLF
		.dc.b	'option:',CRLF
		.dc.b	'	-r, --release	풓',CRLF
		.dc.b	0

.ifdef UNIX_STYLE
header_mes:	.dc.b	program,': ',0
.endif

keep_mes:	.dc.b	'풓܂.',CRLF,0
release_mes:	.dc.b	'풓܂.',CRLF,0

arg_err_mes:	.dc.b	'܂.',CRLF,0
huver_err_mes:	.dc.b	'Human68k version 3.02 ȊOł͎gpł܂.',CRLF,0
ver_err_mes:	.dc.b	'풓̃o[WႢ܂.',CRLF,0
nokeep_err_mes:	.dc.b	'풓Ă܂.',CRLF,0
keep_err_mes:	.dc.b	'ɏ풓Ă܂.',CRLF,0
rel_err_mes:	.dc.b	'xN^tbNĂ̂ŏ풓ł܂.',CRLF,0

* ǉꍇ long_opt_tbl ύX邱.
str_help:	.dc.b	'help',0
str_release:	.dc.b	'release',0
str_version:	.dc.b	'version',0
*			 1234567
LONGOPT_MAX:	.equ	7


		.end	start

* End of File --------------------------------- *
