# madoka3.s - madoka interpreter
# Copyright (C) 2000 Tachibana Eriko
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA


* Include File -------------------------------- *

		.include	mrl.mac
		.include	mint.mac
		.include	window.mac
		.include	message.mac
		.include	sysval.def

		.include	fefunc.mac
		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

* cmdhis.s
		.xref	command_history
		.xref	command_history_menu
		.xref	add_cmd_his
		.xref	is_exist_cmd_his
* cpmv.s
		.xref	get_filesize
* fileop.s
		.xref	to_mintslash
		.xref	get_drive_status
		.xref	copy_dir_name_a1_a2
* gvon.s
		.xref	gvram_off
		.xref	graph_home,GVON24_flag,GTONE,sq64k
		.xref	check_gusemd,gm_check_square
		.xref	g_half_16_usr,gvon_16_usr
		.xref	g_half_256_usr,gvon_256_usr
		.xref	g_half_64k_usr,gvon_64k_usr
* look.s
		.xref	LOOK_FILE_NAME,look_mode
* mint.s
		.xref	SaveFnckey,RestoreFnckey,ChangeFnckey
		.xref	search_cursor_file,search_mark_file
		.xref	search_builtin_func
		.xref	to_fullpath_file
		.xref	print_screen,print_file_list
		.xref	get_fnckey_mode,orig_fnckey_mode
		.xref	restore_fnckey_mode,reset_fnckey_mode
		.xref	fnckey_disp_on2,fnckey_disp_off
		.xref	set_curfile2,set_status
		.xref	set_scr_param,set_scroll_narrow_console
		.xref	fep_disable,fep_enable
		.xref	breakck_save_kill,breakck_restore
		.xref	hook_keyinp_ex_vector,restore_keyinp_ex_vector
		.xref	set_crt_mode_768x512
		.xref	make_clock_sub
		.xref	dos_drvctrl_d1,reset_current_dir
		.xref	skip_connect_line
		.xref	GetArgChar,GetArgCharInit
		.xref	mintrc_filename
		.xref	oldpwd_buf,MpuType,MINTSLASH
		.xref	kq_buffer,macro_table
		.xref	disable_clock_flag,malloc_mode,stack_top
		.xref	_sO,_s
* mintarc.s
		.xref	get_mintarc_dir
		.xref	get_mintarc_filename
		.xref	ma_list_adr,ma_list_num
		.xref	mintarc_extract
* outside.s
		.xref	key_wait
		.xref	atoi_a0
		.xref	dos_inpout
		.xref	break_check1,break_check
		.xref	strcmp_a1_a2,stricmp_a1_a2
		.xref	search_system_value,search_user_value_a1
		.xref	set_user_value_a1_a2,unset_user_value_a1
		.xref	set_user_value_match_a2
		.xref	getsec_flag


* Constant ------------------------------------ *

HUPAIR_ID_SIZE:	.equ	.sizeof.('#HUPAIR')+1

RL_MAX:		.equ	$ffff
MARGIN:		.equ	16

* }NWJɎgR[h
PREFIX:		.equ	CR
TERM:		.equ	LF

* g[NɎgR[h
TC_FILE:	.equ	$08
TC_ESC:		.equ	$09


* Offset Table -------------------------------- *

		.offset	0
Q_old_q_ptr:	.ds.l	1			;e q_ptr
Q_funcname:**	.ds.l	1			;s̊֐
Q_sp_save:	.ds.l	1			;A{[g sp
Q_rl_ptr:	.ds.l	1			;sҏW̃J[\ʒu

Q_next_ptr:	.ds.l	1			;s madoka
Q_macro:	.ds.l	1			;}N
Q_buf_top:	.ds.l	1			;madoka obt@
Q_buf_size:	.ds.l	1			;obt@TCY

Q_miss_line:	.ds.l	1			;L[vȂɎss
Q_ext_exec:	.ds.l	1			;&ext-exec t@C
		.even
Q_ma_req_cur:	.ds.b	1			;mintarc WJv
Q_ma_req_opp:	.ds.b	1			;

Q_mintarc:	.ds.b	1			;>LZHS_?A>TARS_?A>ZIPS_? ̎s
Q_redraw:**	.ds.b	1			;ĕ`v
Q_from_help:	.ds.b	1			;&ext-help/&describe-key ̎s
Q_expand_only:	.ds.b	1			;expand_token ̎s
Q_getsec:	.ds.b	1			;&getsec stO
Q_old_debug:	.ds.b	1			;&debug tOۑ

Q_abort:	.ds.b	1			;I
Q_skip:		.ds.b	1			;ubNʉ
Q_if_next:	.ds.b	1			;򖽗߃tO
Q_if_flag:	.ds.b	1			;V

Q_exec_j:	.ds.b	1			;&exec-j-special-entry ̎s
Q_key_prefix:	.ds.b	1			;&prefix 8 | ... | 1
Q_key_shift:	.ds.b	1			;OPT.2 | OPT.1 | CTRL | SHIFT
Q_key_xfn:	.ds.b	1			;XF5 | ... | XF1

Q_sw_start:
Q_sw_j:		.ds.b	1			;-j
Q_sw_prefix:	.ds.b	1			;-&8 | ... | -&1
Q_sw_shift:	.ds.b	1			;-o2 | -o1 | -c | -t
Q_sw_xfn:	.ds.b	1			;-x5 | ... | -x1
Q_sw_m:		.ds.b	1			;-m

Q_sw_a:		.ds.b	1			;-a
Q_sw_f:		.ds.b	1			;-f
Q_sw_i:		.ds.b	1			;-i
Q_sw_l:		.ds.b	1			;-l
Q_sw_n:		.ds.b	1			;-n
Q_sw_p:		.ds.b	1			;-p
Q_sw_q:		.ds.b	1			;-q
Q_sw_s:		.ds.b	1			;-s
Q_sw_v:		.ds.b	1			;-v
Q_sw_atmark:	.ds.b	1			;-@
Q_sw_h_k:	.ds.b	1			;-h / -k
Q_sw_d:		.ds.b	1			;$ff = -d / '1' = -d1 / '2' = -d2
Q_sw_g:		.ds.b	1			;-g? ($00 / '0'...'9')
Q_sw_end:
		.quad
sizeof_Quick:


MA_REQ_REDRAW:	.equ	3			;EBhEĕ`v
MA_REQ_MARK:	.equ	2			;$M WJv
MA_REQ_FILE:	.equ	1			;$F V
MA_REQ_PATH:	.equ	0			;$C V


* Macro --------------------------------------- *

PR_EA:		.macro	ea
		move.l	d0,-(sp)
		pea	ea
		DOS	_PRINT
		addq.l	#4,sp
		move.l	(sp)+,d0
		.endm

PR_STR:		.macro	str
		PR_EA	(@str,pc)
		bra	@end
@str:		.dc.b	str,0
		.even
@end:
		.endm


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even


*************************************************
*		&madoka				*
*************************************************

madoka::
		tst.l	d7
		beq	madoka_error

		lea	(Buffer),a1		;$argv0 pɃtpX
		lea	(a1),a2
		STRCPY	a0,a1
		move.l	a2,-(sp)
		jsr	(to_fullpath_file)
		move.l	d0,(sp)+
		bmi	madoka_error

		clr	-(sp)			;ROPEN
		move.l	a2,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d6
		bmi	madoka_error

		jsr	(get_filesize)
		move.l	d0,d1
		bmi	madoka_error_close

		addq.l	#4,d0
		move.l	d0,-(sp)
		move	(malloc_mode),-(sp)
		DOS	_MALLOC2
		addq.l	#6,sp
		move.l	d0,d5			;buffer
		bmi	madoka_error_close

		movea.l	d0,a1
		move.l	d1,-(sp)
		move.l	a1,-(sp)
		move	d6,-(sp)
		DOS	_READ
		addq.l	#10-4,sp
		cmp.l	(sp)+,d0
		bne	madoka_error_mfree
		clr.b	(a1,d0.l)

		cmpi	#'#!',(a1)+
		bne	madoka_error_mfree
madoka_skip_line:
		move.b	(a1)+,d0		;擪s("#!madoka ...")΂
		beq	madoka_error_mfree
		cmpi.b	#LF,d0
		bne	madoka_skip_line
@@:
		move.b	(a1)+,d0		;Rgs΂
		beq	madoka_error_mfree
		cmpi.b	#TAB,d0
		beq	@b
		cmpi.b	#SPACE,d0
		beq	@b
		cmpi.b	#'#',d0
		beq	madoka_skip_line
		pea	(-1,a1)

		move	d6,-(sp)		;G[͂Ȃ
		DOS	_CLOSE
		addq.l	#2,sp

		lea	(str_argv0,pc),a1	;$argv0 = t@C
		lea	(Buffer),a2
		jsr	(set_user_value_a1_a2)

		lea	(str_argv,pc),a1
		jsr	(unset_user_value_a1)
		subq.l	#1,d7
		beq	madoka_no_arg

		lea	(a0),a2			;$argv = 
		bra	@f
madoka_arg_loop:
		move.b	#SPACE,(-1,a0)
@@:		tst.b	(a0)+
		bne	@b
		subq.l	#1,d7
		bne	madoka_arg_loop

**		lea	(str_argv,pc),a1
		jsr	(set_user_value_a1_a2)
madoka_no_arg:
		moveq	#%0010_0000,d0
		movea.l	d5,a0
		movea.l	(sp)+,a1
		bsr	free_token_buf
		bsr	execute_quick

		lea	(str_argv0,pc),a1
		jsr	(unset_user_value_a1)
		lea	(str_argv,pc),a1
		jmp	(unset_user_value_a1)
**		rts

madoka_error_mfree:
		move.l	d5,-(sp)
		DOS	_MFREE
		addq.l	#4,sp
madoka_error_close:
		move	d6,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
madoka_error:
		rts


*	.dc.b	'#!madoka...'
*	.dc.b	' -api command...'
*	.dc.b	0


* quick s(ԍw) ------------------------ *
* in	d0.hb	quick ԍ(KQ_xxx)
*	d0.b	tO

execute_quick_no::
		PUSH	d1/a1
		move	d0,d1
		lsr	#8,d1			;quick ԍ
		lsl	#2,d1
		lea	(kq_buffer),a1
		move.l	(a1,d1.w),d1
		beq	@f			;`

		movea.l	d1,a1
		bsr	execute_quick
@@:
		POP	d1/a1
		rts


* g[No -------------------------------- *
* }NyѕϐWJ Buffer ɏ.
* out	d0.l	Buffer

expand_buf:	.equ	expand_token+2

expand_token::
		clr.l	(Buffer)
		moveq	#%0100_0000,d0
		bsr	execute_quick
		move.l	(expand_buf,pc),d0
		rts


* quick s ---------------------------------- *
* in	d0.l	tO
*		bit 6=1: expand_token ̎s
*		bit 5=1: }NWJɃobt@
*		bit 4=1: &ext-exec ̎s
*		bit 3=1: &exec-j-special-entry ̎s
*		bit 2=1: &command-history(-menu)̎s
*		bit 1=1: &ext-help/&describe-key ̎s
*		bit 0=1: >LZHS_?A>TARS_?A>ZIPS_? ̎s
*	a1.l	quick `̃AhX(-api command...)
*	a0.l	bit 5=1 ̏ꍇ: }NWJɉobt@
*		bit 4=1 ̏ꍇ: t@C

execute_quick::
		PUSH	d0-d7/a0-a5
		cmpa.l	#stack_top,sp
		bls	exe_q_abort

		moveq	#sizeof_Quick/4-1,d2
		moveq	#0,d7
@@:		move.l	d7,-(sp)
		dbra	d2,@b
		lea	(sp),a5

		lea	(q_ptr,pc),a2
		move.l	(a2),(Q_old_q_ptr,a5)
		move.l	a5,(a2)

		move.l	a1,(Q_miss_line,a5)
		lsr.b	#1,d0
		bcc	1f
		st	(Q_mintarc,a5)
		lea	(debug_flag,pc),a2
		move.b	(a2),(Q_old_debug,a5)
		clr.b	(a2)
		bra	@f			;mintarc quick  >NO_MAP ɍsȂ
1:
		move.l	(kq_buffer+KQ_NO_MAP*4),d1
		beq	@f
		move.l	d1,(Q_miss_line,a5)
@@:
		lsr.b	#1,d0
		scs	(Q_from_help,a5)
		lsr.b	#1,d0
		bcc	@f

		addq.b	#1,(Q_from_help,a5)	;&command-history(-menu)̎s
		STRLEN	a1,d1,+1
		move.l	d1,(Q_buf_size,a5)
		bsr	lift_memory_block	;ʃɈړ
		move.l	a1,d7			;w-n ΍x΍
@@:
		lsr.b	#1,d0
		scs	(Q_exec_j,a5)

		lsr.b	#1,d0
		bcc	@f
		move.l	a0,(Q_ext_exec,a5)
@@:
		lsr.b	#1,d0
		bcc	@f
		move.l	a0,d7
@@:
		lsr.b	#1,d0
		bcs	exe_q_expand

		move.l	d7,(Q_buf_top,a5)	;-n ΍
		tst.b	(Q_from_help,a5)
		bne	exe_q_from_help

		jsr	(skip_connect_line)
		move.l	a1,d0
		beq	exe_q_done

* ݂̃L[
		lea	(prefix_flag),a0
		move.b	(a0),(Q_key_prefix,a5)
		clr.b	(a0)

		moveq	#$e,d1
		IOCS	_BITSNS
		move.b	d0,(Q_key_shift,a5)

		moveq	#$b,d1
		IOCS	_BITSNS
		moveq	#%11,d2
		and.b	d0,d2
		lsl.b	#3,d2			;...54...
		moveq	#$a,d1
		IOCS	_BITSNS
		lsr.b	#5,d0			;.....321
		or.b	d2,d0
		move.b	d0,(Q_key_xfn,a5)
exe_q_loop:
		lea	(a1),a2
		bsr	clear_cmd_sw
		bsr	analyze_cmd_sw

* L[ƃXCb`r
		move.b	(Q_exec_j,a5),d0
		cmp.b	(Q_sw_j,a5),d0
		bne	exe_q_missmatch
		move.b	(Q_key_prefix,a5),d0
		cmp.b	(Q_sw_prefix,a5),d0
		bne	exe_q_missmatch
		move.b	(Q_key_shift,a5),d0
		cmp.b	(Q_sw_shift,a5),d0
		bne	exe_q_missmatch
		move.b	(Q_key_xfn,a5),d0
		cmp.b	(Q_sw_xfn,a5),d0
		bne	exe_q_missmatch

		movea.l	(PATH_BUF,a6),a4
		jsr	(search_mark_file)
		beq	@f
		tst.b	(Q_sw_m,a5)
		beq	exe_q_match		;}[N --
		bra	exe_q_missmatch		;}[N -m
@@:		tst.b	(Q_sw_m,a5)
		bne	exe_q_match		;}[NL -m
						;}[NL --
* ݂̏
*	L[v
*	}[NLA-m Ȃ
* ȉ̏̂ƂA̍ss
*	ɊSɈvs(-m ̂)Ȃ
.if 0
* ȉ͕̏sv
*	ݍs -&n -on -c -t -xn w肳ĂȂ
		move.b	(Q_sw_prefix,a5),d0
		or.b	(Q_sw_shift,a5),d0
		or.b	(Q_sw_xfn,a5),d0
		bne	exe_q_missmatch
.endif
		move.l	a2,(Q_miss_line,a5)
exe_q_missmatch:
		bsr	skip_madoka
		cmpi.b	#'-',(a1)
		beq	exe_q_loop		;̍s

		movea.l	(Q_miss_line,a5),a1
exe_q_from_help:
		bsr	clear_cmd_sw
		bsr	analyze_cmd_sw
exe_q_match:
		tst.b	(Q_sw_n,a5)
		bne	exe_q_done		;-n w莞͉ȂŏI

		tst.b	(Q_from_help,a5)
		bgt	exe_q_main_loop		;&command-history(-menu)̎s

		bsr	unfold_macro		;}NWJ
		bmi	exe_q_done

		move.l	d7,-(sp)
		beq	@f
		DOS	_MFREE			;XNvgt@Cǂݍ
@@:		addq.l	#4,sp			;obt@

		move.b	(debug_flag,pc),d0
		beq	@f
		bsr	print_unfold_madoka
@@:
		movea.l	(Q_buf_top,a5),a1
exe_q_main_loop:
		bsr	execute_madoka
exe_q_main_loop2:
		tst.b	(Q_abort,a5)
		bne	exe_q_done
		move.l	a1,d0
		beq	exe_q_done
exe_q_main_loop3:
		bsr	fetch_char
		beq	exe_q_done
		cmpi.b	#'{',d0
		beq	exe_q_brace1
		cmpi.b	#'}',d0
		beq	exe_q_brace2
		cmpi.b	#';',d0
		bne	exe_q_main_loop

		clr.b	(Q_if_flag,a5)		;&if tO
		bsr	get_char		;';' ΂
		bra	exe_q_main_loop3

* { : ubNJn
exe_q_brace1:
		bsr	execute_block
		bra	exe_q_main_loop2

* } : ubNI
exe_q_brace2:
		moveq	#MES_MERR0,d0
		jsr	(PrintMsgCrlf)
		bra	exe_q_done

exe_q_expand:
		st	(Q_expand_only,a5)
		bsr	unfold_macro		;}NWJ
		bmi	exe_q_done

		movea.l	(Q_buf_top,a5),a1
		bsr	execute_madoka
		bra	exe_q_done

* sI
exe_q_done:
		move.l	(Q_buf_top,a5),-(sp)
		ble	@f
		DOS	_MFREE
@@:		addq.l	#4,sp

		lea	(q_ptr,pc),a0
		move.l	(Q_old_q_ptr,a5),(a0)

		tst.b	(Q_mintarc,a5)
		beq	@f
		move.b	(Q_old_debug,a5),(debug_flag-q_ptr,a0)
@@:
		lea	(sizeof_Quick,sp),sp
exe_q_end:
		POP	d0-d7/a0-a5
		rts
exe_q_abort:
		moveq	#MES_STACK,d0
		jsr	(PrintMsgCrlf)
		bra	exe_q_end


* ubNʃAhXɈړ ------ *
* in	d1.l	ubÑTCY
*	a1.l	ubÑAhX
* out	a1.l	ړ̃AhX
* l:
*	mۂłȂꍇ͂̂܂܂ɂ.

lift_memory_block:
		PUSH	d0-d1/a0/a2
		move.l	d1,-(sp)		;obt@ʃɈړ
		move	#2,-(sp)
		DOS	_MALLOC2
		addq.l	#6,sp
		tst.l	d0
		bmi	exe_q_lift_end

		lea	(a1),a0			;AhX
		movea.l	d0,a1
		movea.l	d0,a2			;VAhX
		pea	(a0)

		moveq	#$f,d0
		and	d1,d0			;[
		lsr.l	#4,d1
		bra	1f
@@:
	.rept	4
		move.l	(a0)+,(a2)+		;16 oCgPʂœ]
	.endm
1:		subq.l	#1,d1
		bcc	@b
		bra	1f
@@:
		move.b	(a0)+,(a2)+		;[]
1:		subq	#1,d0
		bcc	@b

		DOS	_MFREE
		addq.l	#4,sp
exe_q_lift_end:
		POP	d0-d1/a0/a2
		rts


* R}hXCb` ---------------- *

clear_cmd_sw::
		PUSH	d0/a0
		moveq	#Q_sw_end-Q_sw_start,d0
		lea	(Q_sw_start,a5),a0
@@:		clr.b	(a0)+
		dbra	d0,@b
		POP	d0/a0
		rts


* R}hXCb`͂ ------------------ *
* in	a1.l	R}hXCb`
* out	a1.l	madoka {

analyze_cmd_sw::
		PUSH	d0-d1/a0/a2
		bsr	skip_blank
		lea	(a1),a2			;擪s -! pɕۑĂ

		cmpi.b	#'-',(a1)+
		bne	ana_cmd_sw_end
ana_cmd_sw_loop:
		move.b	(a1)+,d0
		cmpi.b	#$20,d0
		bls	ana_cmd_sw_end

		cmpi.b	#'-',d0
		beq	ana_cmd_sw_loop
		cmpi.b	#'!',d0
		beq	ana_cmd_sw_excl
		cmpi.b	#'@',d0
		beq	ana_cmd_sw_atmark
		cmpi.b	#'&',d0
		beq	ana_cmd_sw_and
		moveq	#$20,d1
		or.b	d0,d1
		subi	#'a',d1
		cmpi	#'x'-'a',d1
		bhi	ana_cmd_sw_loop

		add	d1,d1
		move	(@f,pc,d1.w),d1
		jmp	(@f,pc,d1.w)
@@:
		.dc	ana_cmd_sw_a-@b		;-a
		.dc	ana_cmd_sw_loop-@b
		.dc	ana_cmd_sw_c-@b		;-c
		.dc	ana_cmd_sw_d-@b		;-d
		.dc	ana_cmd_sw_loop-@b
		.dc	ana_cmd_sw_f-@b		;-f
		.dc	ana_cmd_sw_g-@b		;-g
		.dc	ana_cmd_sw_h-@b		;-h
		.dc	ana_cmd_sw_i-@b		;-i
		.dc	ana_cmd_sw_j-@b		;-j
		.dc	ana_cmd_sw_k-@b		;-k
		.dc	ana_cmd_sw_l-@b		;-l
		.dc	ana_cmd_sw_m-@b		;-m
		.dc	ana_cmd_sw_n-@b		;-n
		.dc	ana_cmd_sw_o-@b		;-o
		.dc	ana_cmd_sw_p-@b		;-p
		.dc	ana_cmd_sw_q-@b		;-q
		.dc	ana_cmd_sw_loop-@b
		.dc	ana_cmd_sw_s-@b		;-s
		.dc	ana_cmd_sw_t-@b		;-t
		.dc	ana_cmd_sw_loop-@b
		.dc	ana_cmd_sw_v-@b		;-v
		.dc	ana_cmd_sw_loop-@b
		.dc	ana_cmd_sw_x-@b		;-x

ana_cmd_sw_excl:
		move.l	a2,(Q_miss_line,a5)
		bra	ana_cmd_sw_loop
ana_cmd_sw_atmark:
		move.b	d0,(Q_sw_atmark,a5)
		bra	ana_cmd_sw_loop
ana_cmd_sw_and:
		cmpi.b	#'8',(a1)
		bhi	@f
		moveq	#'1',d1
		cmp.b	(a1),d1
		bhi	@f

		move.b	(a1)+,d0		;-&8 ` -&1
		sub.b	d1,d0
		bset	d0,(Q_sw_prefix,a5)
@@:		bra	ana_cmd_sw_loop

ana_cmd_sw_a:
		move.b	d0,(Q_sw_a,a5)		;-a
		bra	ana_cmd_sw_loop
ana_cmd_sw_c:
		bset	#1,(Q_sw_shift,a5)	;-c
		bra	ana_cmd_sw_loop
ana_cmd_sw_d:
		moveq	#-1,d0			;-d
		cmpi.b	#'1',(a1)
		beq	1f
		cmpi.b	#'2',(a1)
		bne	@f
1:
		move.b	(a1)+,d0		;-d1 / -d2
@@:		move.b	d0,(Q_sw_d,a5)
		bra	ana_cmd_sw_loop
ana_cmd_sw_f:
		move.b	d0,(Q_sw_f,a5)		;-f
		bra	ana_cmd_sw_loop
ana_cmd_sw_g:
		cmpi.b	#'9',(a1)
		bhi	@f
		cmpi.b	#'0',(a1)
		bcs	@f

		move.b	(a1)+,(Q_sw_g,a5)	;-g9 ` -g0
@@:		bra	ana_cmd_sw_loop
ana_cmd_sw_h:
ana_cmd_sw_k:
		move.b	d0,(Q_sw_h_k,a5)	;-h / -k
		bra	ana_cmd_sw_loop
ana_cmd_sw_i:
		move.b	d0,(Q_sw_i,a5)		;-i
		bra	ana_cmd_sw_loop
ana_cmd_sw_j:
		st	(Q_sw_j,a5)		;-j
		bra	ana_cmd_sw_loop
ana_cmd_sw_l:
		move.b	d0,(Q_sw_l,a5)		;-l
		bra	ana_cmd_sw_loop
ana_cmd_sw_m:
		st	(Q_sw_m,a5)		;-m
		bra	ana_cmd_sw_loop
ana_cmd_sw_n:
		move.b	d0,(Q_sw_n,a5)		;-n
		bra	ana_cmd_sw_loop
ana_cmd_sw_o:
		cmpi.b	#'1',(a1)
		beq	1f
		cmpi.b	#'2',(a1)
		bne	@f
1:
		moveq	#2-'1',d0		;-o1 / -o2
		add.b	(a1)+,d0
		bset	d0,(Q_sw_shift,a5)
@@:		bra	ana_cmd_sw_loop
ana_cmd_sw_p:
		move.b	d0,(Q_sw_p,a5)		;-p
		bra	ana_cmd_sw_loop
ana_cmd_sw_q:
		move.b	d0,(Q_sw_q,a5)		;-q
		bra	ana_cmd_sw_loop
ana_cmd_sw_s:
		move.b	d0,(Q_sw_s,a5)		;-s
		bra	ana_cmd_sw_loop
ana_cmd_sw_t:
		bset	#0,(Q_sw_shift,a5)	;-t
		bra	ana_cmd_sw_loop
ana_cmd_sw_v:
		move.b	d0,(Q_sw_v,a5)		;-v
		bra	ana_cmd_sw_loop
ana_cmd_sw_x:
		cmpi.b	#'5',(a1)
		bhi	@f
		moveq	#'1',d1
		cmp.b	(a1),d1
		bhi	@f

		move.b	(a1)+,d0		;-x5 ` -x1
		sub.b	d1,d0
		bset	d0,(Q_sw_xfn,a5)
@@:		bra	ana_cmd_sw_loop

ana_cmd_sw_end:
		subq.l	#1,a1
**		bsr	skip_blank
		POP	d0-d1/a0/a2
		rts


* R}hXCb`𕶎ɂ -------------- *
* out	a0.l	R}hXCb`(tmp_buf)

CMD_SW_SIZE::	.equ	.sizeof.('-d2g9')+(Q_sw_d-Q_sw_a)

make_cmd_sw::
		lea	(tmp_buf),a0
		PUSH	d0-d1/a0-a1
		move.b	#'-',(a0)+
		lea	(Q_sw_a,a5),a1
		moveq	#Q_sw_d-Q_sw_a-1,d1
make_cmd_sw_loop:
		move.b	(a1)+,d0
		beq	@f
		move.b	d0,(a0)+
@@:		dbra	d1,make_cmd_sw_loop

		move.b	(a1)+,d0		;Q_sw_d
		beq	@f
		move.b	#'d',(a0)+
		tst.b	d0
		bmi	@f			;-d
		move.b	d0,(a0)+		;-d1 / -d2
@@:
		move.b	(a1)+,d0		;Q_sw_g
		beq	@f
		move.b	#'g',(a0)+
		move.b	d0,(a0)+
@@:
		clr.b	(a0)
		POP	d0-d1/a0-a1
		rts


* 󔒂΂ -------------------------------- *
* i/o	a1.l	̃AhX

skip_blank_loop:
		addq.l	#1,a1
skip_blank::
		cmpi.b	#TAB,(a1)
		beq	skip_blank_loop
		cmpi.b	#SPACE,(a1)
		beq	skip_blank_loop
		rts


* madoka ΂ ----------------------------- *
* i/o	a1.l	̃AhX
* break	d0

skip_madoka::
* ܂A̍sɈړ
@@:		move.b	(a1)+,d0
		beq	skip_madoka_end
		cmpi.b	#EOF,d0
		beq	skip_madoka_end
		cmpi.b	#LF,d0
		bne	@b

* s󔒂łȂ madoka I
		move.b	(a1)+,d0
		cmpi.b	#TAB,d0
		beq	@f
		cmpi.b	#SPACE,d0
		bne	skip_madoka_end
@@:
* 󔒂΂āA̕𒲂ׂ
		bsr	skip_blank
		move.b	(a1)+,d0
		cmpi.b	#'#',d0
		beq	skip_madoka_end		;RgȂ madoka I
**		cmpi.b	#'\',d0
**		beq	skip_madoka		;sȂ玟̍sɈړ
		cmpi.b	#'-',d0
		bne	skip_madoka		;madoka Ă
skip_madoka_end:
		subq.l	#1,a1
		rts


* }NWJ ---------------------------------- *
* in	a1.l	madoka {
* out	d0.l	0:I -1:s
*	ccr	<tst.l d0> ̌

* }NWJJn
*		.dc.b	PREFIX,'('
*		.dc.b	'00000000'
*		.dc.b	'macroname',TERM
*		.dc.b	'arg1',TERM
*		.dc.b	'arg2',TERM
*		.dc.b	TERM
*		`}NLqe`
* }NWJI
*		.dc.b	PREFIX,')'

PUT:		.macro	put_op
		subq.l	#1,d7
		bcs	unf_mac_overflow
		put_op
		.endm

REQ_BRACE1:	.equ	13
REQ_BRACE2:	.equ	12
S_QUOTE:	.equ	11
D_QUOTE:	.equ	10
REQ_BLOCK:	.equ	9
AFTER_CHAIN:	.equ	8

MASK:		.equ	.not.(1<<S_QUOTE+1<<D_QUOTE+1<<REQ_BRACE1+1<<REQ_BRACE2)

unfold_macro::
		PUSH	d1-d7/a0-a4
		move.l	sp,(Q_sp_save,a5)

		pea	(-1)
		DOS	_MALLOC
		move.l	d0,(sp)
		clr.b	(sp)
		DOS	_MALLOC
		move.l	(sp)+,d7		;obt@TCY
		move.l	d0,(Q_buf_top,a5)
		bmi	unf_mac_error

		movea.l	d0,a2
		moveq	#0,d6
		lea	(sp),a4
		bsr	unfold_macro_sub

		PUT	<clr.b  (a2)+>		;I

		movea.l	(Q_buf_top,a5),a1	;ubNKvTCY
		move.l	a2,d1			;؂l߂
		sub.l	a1,d1
		move.l	d1,-(sp)
		pea	(a1)
		DOS	_SETBLOCK
		addq.l	#8,sp

		move.l	d1,(Q_buf_size,a5)
		tst	(malloc_mode)
		bne	unf_mac_success

		bsr	lift_memory_block	;ʃɈړ
		move.l	a1,(Q_buf_top,a5)
unf_mac_success:
		moveq	#0,d0
		bra	unf_mac_return
unf_mac_overflow:
		movea.l	(Q_sp_save,a5),sp	;obt@eʕs
		move.l	(Q_buf_top,a5),-(sp)
		DOS	_MFREE
		addq.l	#4,sp
unf_mac_error:
		moveq	#-1,d0			;obt@mێs
unf_mac_return:
		POP	d1-d7/a0-a4
		rts


* }NWJ
unfold_macro_sub::
		tst.l	d0			;_~[
unf_mac_loop:
		lea	(a1),a0
		bsr	skip_blank
		cmpa.l	a0,a1
		beq	unf_mac_no_blank

		move.b	(a1)+,d0
		cmpi.b	#'#',d0
		beq	unf_mac_comment		;󔒁{'#' ŃRg
		cmpi.b	#'\',d0
		beq	unf_mac_bslash		;󔒁{'\' ōsA
		subq.l	#1,a1
unf_mac_no_blank:
		move.b	(a1)+,d0
		beq	unf_mac_end
		cmpi.b	#LF,d0
		beq	unf_mac_lf
		cmpi.b	#CR,d0
		beq	unf_mac_cr
		cmpi.b	#EOF,d0
		beq	unf_mac_end

		cmpi.b	#"'",d0
		beq	unf_mac_s_quote
		btst	#S_QUOTE,d6
		bne	unf_mac_not_chain
		cmpi.b	#'"',d0
		beq	unf_mac_d_quote

		cmpi.b	#'$',d0
		beq	unf_mac_dollar
		cmpi.b	#'(',d0
		beq	unf_mac_paren
		tst.b	d6
		beq	@f
		cmpi.b	#')',d0
		bne	@f
		subq.l	#1,a1			;$(macro arg1 arg2)
		rts				;		  ^
@@:
		cmpi.b	#';',d0
		beq	unf_mac_chain
		cmpi.b	#'{',d0
		bne	@f
		bclr	#REQ_BRACE1,d6
		beq	unf_mac_chain		;ubNJn '{'
		bset	#REQ_BRACE2,d6
		bra	unf_mac_not_chain	;${foo}  '{'
@@:
		cmpi.b	#'}',d0
		bne	@f
		bclr	#REQ_BRACE2,d6
		beq	unf_mac_chain		;ubNI '}'
		bra	unf_mac_not_chain	;${foo}  '}'
@@:
		cmpi.b	#'|',d0
		bne	unf_mac_not_chain
		cmp.b	(a1),d0
		bne	unf_mac_not_chain	;PƂ '|'

		addq.l	#1,a1
		moveq	#';',d0			;'||'  ';' ɕϊ
unf_mac_chain:
		bset	#AFTER_CHAIN,d6		;`FCL
		bclr	#REQ_BLOCK,d6
		bra	unf_mac_put2
unf_mac_not_chain:
		bclr	#AFTER_CHAIN,d6
		bclr	#REQ_BLOCK,d6		;O̍s`FCŏIĂȂ
		bne	unf_mac_end		;̕ { } łȂ΂ȂȂ
unf_mac_put:
		PUT	<move.b  d0,(a2)+>
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	unf_mac_next		;PoCg

		move.b	(a1)+,d0		;QoCg
		bne	unf_mac_put2
		addq.l	#1,d7
		subq.l	#1,a2
		bra	unf_mac_end
unf_mac_put2:
		PUT	<move.b  d0,(a2)+>
unf_mac_next:
		moveq	#$20,d0
		cmp.b	(a1),d0
		bcs	unf_mac_no_blank	;͋̕󔒂ł͂Ȃ
		beq	@f
		cmpi.b	#TAB,(a1)
		bne	unf_mac_no_blank
@@:
		btst	#S_QUOTE,d6
		bne	1f
		btst	#D_QUOTE,d6
		beq	@f
1:
		PUT	<move.b  (a1)+,(a2)+>	;'`'/"`" ̋
		cmpi.b	#'\',(a1)
		bne	unf_mac_next
		addq.l	#1,a1			;'`'/"`" ̍sA
		bra	unf_mac_bslash
@@:
		tst.b	d6
		bne	@f
		PUT	<move.b  d0,(a2)+>
		bra	unf_mac_loop
@@:		rts


* ' : VONI[g
unf_mac_s_quote:
		bchg	#S_QUOTE,d6
		bra	unf_mac_not_chain

* " : _uNI[g
unf_mac_d_quote:
		bclr	#S_QUOTE,d6
		bchg	#D_QUOTE,d6
		bra	unf_mac_not_chain


* $ : ϐ
unf_mac_dollar:
		cmpi.b	#'(',(a1)
		beq	unf_mac_d_paren

		lea	(a1),a0
		move.b	(a1)+,d0
		cmpi.b	#'?',d0
		bne	@f
		move.b	(a1)+,d0		;$?
@@:
		cmpi.b	#'@',d0
		beq	1f			;$@
		cmpi.b	#'%',d0
		bne	@f
1:		move.b	(a1)+,d0		;$%
@@:
		cmpi.b	#'{',d0
		bne	@f
		bset	#REQ_BRACE1,d6		;${foo}
@@:
		lea	(a0),a1
		moveq	#'$',d0
		bra	unf_mac_not_chain


* $( : t}N
unf_mac_d_paren:
		PUSH	d7/a1/a2
		addq.l	#1,a1

		PUT	<move.b  #PREFIX,(a2)+>	;}NJn}[N
		PUT	<move.b  #'(',(a2)+>
		moveq	#8-1,d0
@@:
		PUT	<move.b  #'0',(a2)+>
		dbra	d0,@b
		move.l	a2,d4			;}N擪AhX

		move.b	(a1)+,d0
		bsr	is_macro_char1
		bra	1f
unf_mac_d_paren_loop:
		PUT	<move.b  d0,(a2)+>
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@f			;PoCg
		move.b	(a1)+,d0		;QoCg
		cmpi.b	#$20,d0
		bls	unf_mac_paren9		;̓s $20 ȉ̓G[
		PUT	<move.b  d0,(a2)+>
@@:
		move.b	(a1)+,d0
		bsr	is_macro_char2
1:		bne	unf_mac_d_paren_loop

		subq.l	#1,a1

		move.l	a2,d5			;}NAhX
		PUT	<clr.b  (a2)+>		;Ƃ LF ɏ
unf_mac_d_paren_loop2:
		move.l	a2,-(sp)
		move.b	d6,-(sp)
		move.b	#')',d6
		PUSH	d4/d5
		bsr	unfold_macro_sub	;WJ
		POP	d4/d5
		move.b	(sp)+,d6
		cmpa.l	(sp)+,a2
		beq	@f

		PUT	<move.b  #TERM,(a2)+>	;}NI}[N
		bra	unf_mac_d_paren_loop2
@@:
		cmpi.b	#')',(a1)+
		bne	unf_mac_d_paren9

		PUT	<move.b  #TERM,(a2)+>	;}NI}[N

		move.l	d4,d0
		bsr	search_macro
		tst.l	d0
		beq	unf_mac_d_paren9	;`

		movea.l	d5,a0
		move.b	#TERM,(a0)		;NUL 

**		POP	d7/a1/a2
		lea	(.sizeof.(d7/a1/a2),sp),sp

		move.l	a1,-(sp)
		movea.l	d0,a1
		bsr	unfold_macro_sub	;ċAWJ
		movea.l	(sp)+,a1

		PUT	<move.b  #PREFIX,(a2)+>	;}NWJI}[N
		PUT	<move.b  #')',(a2)+>

		bra	unf_mac_next		;unf_mac_loop
unf_mac_d_paren9:
		POP	d7/a1/a2
		moveq	#'$',d0
		bra	unf_mac_not_chain


* ( : }N
unf_mac_paren:
		move.l	a1,-(sp)
		move.b	(a1)+,d0
		bsr	is_macro_char1
		bra	1f
unf_mac_paren_loop:
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@f			;PoCg
		cmpi.b	#$20,(a1)+		;QoCg
		bls	unf_mac_paren9		;̓s $20 ȉ̓G[
@@:
		move.b	(a1)+,d0
		bsr	is_macro_char2
1:		bne	unf_mac_paren_loop
		cmpi.b	#')',-(a1)
		bne	unf_mac_paren9

		move.l	(sp),d0
		clr.b	(a1)			;')' 
		bsr	search_macro
		move.b	#')',(a1)+		;')' ߂
		tst.l	d0
		beq	unf_mac_paren9		;`

		move.l	a1,(sp)
		movea.l	d0,a1
		bsr	unfold_macro_sub	;ċAWJ
		movea.l	(sp)+,a1
		bra	unf_mac_next		;unf_mac_loop
unf_mac_paren9:
		movea.l	(sp)+,a1
		moveq	#'(',d0
		bra	unf_mac_not_chain

* }NɎgp\ȕׂ
is_macro_char2:
		cmpi.b	#'0',d0
		bcs	is_macro_char1
		cmpi.b	#'9',d0
		bls	is_macro_char_t		;0-9
is_macro_char1:
		tst.b	d0
		bmi	is_macro_char_t		;oCg/Љ
		cmpi.b	#'z',d0
		bhi	is_macro_char_f
		cmpi.b	#'a',d0
		bcc	is_macro_char_t		;a-z
		cmpi.b	#'_',d0
		beq	is_macro_char_t
		cmpi.b	#'-',d0
		beq	is_macro_char_t
		cmpi.b	#'Z',d0
		bhi	is_macro_char_f
		cmpi.b	#'A',d0
		bcc	is_macro_char_t		;A-Z
		cmpi.b	#'+',d0
		beq	is_macro_char_t
is_macro_char_f:
		moveq	#0,d0
		rts
is_macro_char_t:
		tst.b	d0
		rts

* }N
* in	d0.l	}ÑAhX
* out	d0.l	WJ madoka ̃AhX(0 Ȃ}N`)
search_macro:
		PUSH	d1-d2/a0-a3
		movea.l	d0,a1
		moveq	#$20,d1
		lea	(macro_table),a3
		bra	sch_mac_start
sch_mac_loop:
		movea.l	d0,a2
		lea	(a2),a0
@@:		cmp.b	(a0)+,d1
		bcs	@b
		move.b	-(a0),d2
		clr.b	(a0)			;}N؂o
		jsr	(strcmp_a1_a2)
		bne	sch_mac_next

		move.b	d2,(a0)			;ɖ߂
		lea	(a0),a1
		bsr	skip_blank
		move.l	a1,d0
		bra	sch_mac_end
sch_mac_next:
		move.b	d2,(a0)			;ɖ߂
sch_mac_start:
		move.l	(a3)+,d0
		bne	sch_mac_loop
sch_mac_end:
		POP	d1-d2/a0-a3
		rts


* \ : sA
unf_mac_bslash:
		lea	(a1),a0
		bsr	skip_blank
		move.b	(a1)+,d0
		cmpi.b	#LF,d0
		beq	unf_mac_bslash_lf	;󔒁{'\'{(){LF
		cmpi.b	#CR,d0
		beq	unf_mac_bslash_cr	;󔒁{'\'{(){CR
		cmpi.b	#'#',d0
		bne	@f
		subq.l	#1,a1
		cmpa.l	a0,a1
		bne	unf_mac_bslash_comment	;󔒁{'\'{󔒁{'#'
@@:
		lea	(a0),a1			;sAł͂Ȃ '\'
		moveq	#'\',d0
		btst	#S_QUOTE,d6
		bne	unf_mac_not_chain	;'`' 

		cmpi	#2,(unix)
		bcs	unf_mac_not_chain	;%unix 0/1 Ȃ '\' ̂

		bclr	#AFTER_CHAIN,d6
		bclr	#REQ_BLOCK,d6		;%unix 2 Ȃ玟̃̕GXP[v
		bne	unf_mac_end

		PUT	<move.b  d0,(a2)+>	;܂ '\' o

		move.b	(a1)+,d0
		cmpi.b	#$20,d0
		bcc	unf_mac_put		;̕o
		move.l	#1<<EOF+1<<CR+1<<LF+1<<NUL,d1
		btst	d0,d1
		beq	unf_mac_put
		bra	unf_mac_end

* 󔒁{'\'{(){CR
unf_mac_bslash_cr:
		cmpi.b	#LF,(a1)+
		beq	@f
		subq.l	#1,a1
@@:		bra	unf_mac_bslash_lf

* 󔒁{'\'{󔒁{'#'
unf_mac_bslash_comment:
		move.b	(a1)+,d0
		beq	unf_mac_end
		cmpi.b	#EOF,d0
		beq	unf_mac_end
		cmpi.b	#LF,d0
		bne	unf_mac_bslash_comment
		bra	unf_mac_bslash_lf

* 󔒁{'\'{(){LF
unf_mac_bslash_lf:
		andi	#MASK,d6
		lea	(a1),a0
		bsr	skip_blank
		cmpa.l	a0,a1
		beq	unf_mac_end		;s̐擪󔒂ł͂Ȃ
		move.b	(a1),d0
		cmpi.b	#'-',d0
		beq	unf_mac_end		;R}hXCb`

		subq.l	#1,a1			;󔒂w悤ɂ
		bra	unf_mac_loop


* CR : A
unf_mac_cr:
		cmpi.b	#LF,(a1)+
		beq	@f
		subq.l	#1,a1
@@:		bra	unf_mac_lf


* # : Rg
unf_mac_comment:
		move.b	(a1)+,d0
		beq	unf_mac_end
		cmpi.b	#EOF,d0
		beq	unf_mac_end
		cmpi.b	#LF,d0
		bne	unf_mac_comment
		bra	unf_mac_lf


* LF : s
unf_mac_lf:
		andi	#MASK,d6
		lea	(a1),a0
		bsr	skip_blank
		cmpa.l	a0,a1
		beq	unf_mac_end		;s̐擪󔒂ł͂Ȃ
		move.b	(a1),d0
		cmpi.b	#'-',d0
		beq	unf_mac_end		;R}hXCb`

		subq.l	#1,a1			;󔒂w悤ɂ
		btst	#AFTER_CHAIN,d6
		bne	unf_mac_loop		;O̍s`CŏIĂ
		bset	#REQ_BLOCK,d6
		bra	unf_mac_loop		;ȊOȂ { } Kv

* I
unf_mac_end:
		rts


* }NWJς madoka \(fobOp) ------ *

print_unfold_madoka:
		PUSH	d0/a0
		PR_STR	<"==== unfold ====",LF>
		movea.l	(Q_buf_top,a5),a0
1:
		moveq	#0,d0
		move.b	(a0)+,d0
		beq	9f
		cmpi.b	#PREFIX,d0
		beq	7f
		cmpi.b	#TERM,d0
		beq	5f

		move	d0,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		bra	1b
5:
		cmpi.b	#TERM,(a0)
		beq	6f
		PR_STR	<" ">			;TERM,'nextarg'
		bra	1b
6:
		addq.l	#1,a0			;TERM AΈ̏I
		PR_STR	<"]">
		bra	1b
7:
		cmpi.b	#'(',(a0)+
		bne	8f
		addq.l	#8,a0			;PREFIX,'(',$00~8,'macroname'
		PR_STR	<"[}NJn ">
		bra	1b
8:
		PR_STR	<"[}NI]">	;PREFIX,')'
		bra	1b
9:
		jsr	(PrintCrlf)
		POP	d0/a0
		rts


* ubNʉ -------------------------------- *
* in	a1.l	madoka {
* out	a1.l	sAhX(NULL ȂI)

skip_block::
		move.b	(Q_skip,a5),-(sp)
		st	(Q_skip,a5)
		bsr	execute_block
		move.b	(sp)+,(Q_skip,a5)
		rts


* ubNs -------------------------------- *
* in	a1.l	madoka {
* out	a1.l	sAhX(NULL ȂI)

execute_block::
		move.l	d0,-(sp)
		bsr	get_char		;'{' ΂

		move.l	(Q_funcname,a5),-(sp)
**		move.b	(Q_if_flag,a5),-(sp)
		clr.b	(Q_if_flag,a5)		;&if tO
exe_b_loop:
		bsr	execute_madoka
exe_b_loop2:
		tst.b	(Q_abort,a5)
		bne	exe_b_end
		move.l	a1,d0
		beq	exe_b_error
exe_b_loop3:
		bsr	fetch_char
		beq	exe_b_error
		cmpi.b	#'{',d0
		beq	exe_b_brace1
		cmpi.b	#'}',d0
		beq	exe_b_brace2
		cmpi.b	#';',d0
		bne	exe_b_loop

		clr.b	(Q_if_flag,a5)		;&if tO
		bsr	get_char		;';' ΂
		bra	exe_b_loop3

* { : ubNJn
exe_b_brace1:
		bsr	execute_block
		bra	exe_b_loop2

exe_b_error:
		suba.l	a1,a1
		moveq	#MES_MERR1,d0
		jsr	(PrintMsgCrlf)
		bra	exe_b_end

* } : ubNI
exe_b_brace2:
		bsr	get_char		;'}' ΂
		bra	exe_b_end

exe_b_end:
**		move.b	(sp)+,(Q_if_flag,a5)
		move.l	(sp)+,(Q_funcname,a5)
		move.l	(sp)+,d0
		rts


* madoka s --------------------------------- *
* in	a1.l	madoka {
* out	a1.l	sAhX(NULL ȂI)

execute_madoka::
		PUSH	d0-d7/a0/a2-a5
exe_m_loop:
		clr.l	(Q_rl_ptr,a5)

		pea	(-1)			;g[N؂oobt@m
		DOS	_MALLOC
		move.l	d0,(sp)
		clr.b	(sp)
		DOS	_MALLOC
		move.l	(sp),d7			;TCY
		move.l	d0,(sp)
		bmi	exe_m_memory_error

		movea.l	d0,a4
		lea	(a4),a2			;݃|C^
		moveq	#0,d6
		bra	1f
@@:
		add.l	d0,d6			;g[N
1:		bsr	get_token
		bgt	@b
		bmi	exe_m_memory_error

		move.l	a1,(Q_next_ptr,a5)	;sAhX
		tst.l	d6
		beq	exe_m_return		;g[NȂ
		tst.b	(Q_skip,a5)
		bne	exe_m_return		;XLbv

		suba.l	a4,a2			;g[ÑoCg
		pea	(MARGIN,a2)		;̖ɗ]T
		pea	(a4)
		DOS	_SETBLOCK
		addq.l	#8,sp

		bsr	execute_ma_req		;MA_REQ ̏

* $< ꍇ͍sҏWs
		move.l	(Q_rl_ptr,a5),d5
		beq	exe_m_exec
		cmpa.l	#RL_MAX,a2
		bhi	exe_m_exec		;g[N

**		PR_STR	<"==== readline ====",LF>

* s̓obt@m
		clr.l	-(sp)
		addq	#1,(sp)			;RL_MAX+1
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	exe_m_memory_error
		movea.l	d0,a1			;obt@

* g[N𕶎ɖ߂
		PUSH	d6/a0-a1
		lea	(a4),a0
		bra	@f
exe_m_rl_cat_loop:
		move.b	#SPACE,(-1,a1)
@@:
		cmpa.l	d5,a0
		bne	1f
		move.l	a1,(Q_rl_ptr,a5)	;J[\ʒu␳
1:
		move.b	(a0)+,d0		; remove_tc Ƃقړ
		cmpi.b	#TC_FILE,d0
		beq	@b
		cmpi.b	#TC_ESC,d0
		bne	1f
		move.b	(a0)+,d0
1:		cmpi.b	#PREFIX,d0
		beq	2f
		cmpi.b	#TERM,d0
		bne	3f
2:		moveq	#SPACE,d0		;}NR[h͋󔒂ɒu
3:		move.b	d0,(a1)+
		beq	@f
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		move.b	(a0)+,(a1)+
		bne	@b			;܂
@@:
		subq.l	#1,d6
		bne	exe_m_rl_cat_loop
		POP	d6/a0-a1

		DOS	_MFREE			;g[N؂oobt@
		move.l	a1,(sp)			;s̓obt@

		GETMES	MES_ICOMD
		bsr	open_rl_win
		moveq	#1,d1
		moveq	#1,d2
		jsr	(WinSetCursor)
		move	d0,-(sp)
		move	#78,-(sp)		;EBhE

		move.l	#RL_MAX<<16+RL_F_CSR,d1
		jsr	(is_exist_cmd_his)
		beq	@f
		addq	#RL_F_RD,d1		;ROLL DOWN ŃqXg˓
@@:
		move.l	(Q_rl_ptr,a5),d2
		sub.l	a1,d2			;J[\ʒu

		move.l	(sp),d0
		jsr	(MintReadLine)
		move.l	d0,d2
		jsr	(break_check1)		;u[NL[̏ԂXV
		move.l	(sp)+,d0
		jsr	(WinClose)
		tst.l	d2
		bgt	exe_m_rl_history

		tst.b	(Q_sw_a,a5)
		bne	@f
		bsr	make_cmd_sw		;qXgɓo^
		jsr	(add_cmd_his)
@@:
		tst.l	d2
		bmi	exe_m_rl_cancel
* m
		STRLEN	a1,d1
		bsr	eval_sub
		bmi	exe_m_memory_error

		DOS	_MFREE			;s̓obt@
		addq.l	#4,sp

		movea.l	(Q_next_ptr,a5),a1	;x߂
		bra	exe_m_loop
* qXg˓
exe_m_rl_history:
		DOS	_MFREE			;s̓obt@

		moveq	#0,d7			;Ȃ
		bsr	call_command_history
		bra	exe_m_end


* ̂܂܎s
exe_m_exec:
		lea	(a4),a0
		tst.b	(Q_expand_only,a5)
		bne	exe_m_expand

		move.l	d6,d0
		move.l	a2,d1			;g[Nobt@̃TCY
		bsr	execute_command
		jsr	(break_check1)		;u[NL[̏ԂXV
		bra	exe_m_end
exe_m_expand:
		clr.b	(1023,a0)		;1KB 
		movea.l	(expand_buf,pc),a1
		STRCPY	a0,a1
		bra	exe_m_return

exe_m_rl_cancel:
exe_m_memory_error:
		st	(Q_abort,a5)
		clr.l	(Q_next_ptr,a5)
exe_m_return:
		tst.l	(sp)
		ble	exe_m_end
		DOS	_MFREE			;g[N؂o/s̓obt@
exe_m_end:
		addq.l	#4,sp
		move.l	(Q_next_ptr,a5),a1
		POP	d0-d7/a0/a2-a5
		rts


* s̓EBhEJ ---------------------- *
* in	d0.l	^Cg
* out	d0.l	EBhEԍ

open_rl_win::
		PUSH	d1/a0
		lea	(subwin_rl,pc),a0
		move.l	d0,(SUBWIN_TITLE,a0)
		moveq	#(96-80)/2,d0
		move	(kz_x),d1
		bmi	@f			;
		moveq	#96-80,d0
		cmp	d1,d0
		bls	@f
		move	d1,d0
@@:		move	d0,(SUBWIN_X,a0)
		move	(kz_y),d0
		cmpi	#28,d0
		bhi	@f
		move	d0,(SUBWIN_Y,a0)
@@:		jsr	(WinOpen)
		POP	d1/a0
		rts


* MA_REQ ̏ ------------------------------- *
* mintarc bΉ.

execute_ma_req::
		PUSH	d0-d7/a0-a4
		movea.l	(PATH_OPP,a6),a6
		move.b	(Q_ma_req_opp,a5),d7	;Α
		clr.b	(Q_ma_req_opp,a5)
		bsr	exe_ma_req_sub
		movea.l	(PATH_OPP,a6),a6
		beq	@f
		jsr	(ReverseCursorBarOpp)
@@:
		move.b	(Q_ma_req_cur,a5),d7	;J[\
		clr.b	(Q_ma_req_cur,a5)
		bsr	exe_ma_req_sub
		beq	@f
		jsr	(ReverseCursorBar)
@@:
		POP	d0-d7/a0-a4
		rts

* in	d7.b	Q_ma_req_{cur,opp}
* out	d0.l	0:ĕ`Ȃ 1:
exe_ma_req_sub:
		tst.b	(PATH_MARC_FLAG,a6)
		beq	@f			;mintarc łȂΓWJsv
		tst.b	(Q_expand_only,a5)
		bne	@f

		moveq	#1<<MA_REQ_MARK+1<<MA_REQ_FILE+1<<MA_REQ_PATH,d0
		and.b	d7,d0
		beq	@f
		jsr	(mintarc_extract)
@@:
		btst	#MA_REQ_REDRAW,d7
		beq	exe_ma_req_end

		move	(PATH_WIN_MARK,a6),d0
		jsr	(WinClearAll)
		jsr	(print_file_list)
		moveq	#1,d0
		rts
exe_ma_req_end:
		moveq	#0,d0
		rts


* g[N؂o ---------------------------- *
* in	a1.l	̃AhX
*	a2.l	g[N݃obt@
*	d7.l	obt@coCg
* out	d0.l	g[N(-1 Ȃobt@eʕs)
*	ccr	<tst.l d0> ̌
*	a1.l	g[NõAhX
*	a2.l	V		    AhX
*	d7.l	V		    coCg

PUT:		.macro	put_op
		subq.l	#1,d7
**		bcs	get_token_overflow
		bls	get_token_overflow	;QoCg邩mF
		put_op
		.endm

CHK:		.macro	ea
		cmp.l	ea,d7
		bcs	get_token_overflow
		.endm

PASS:		.macro
		STRLEN	a2,d0
		sub.l	d0,d7
		adda.l	d0,a2
		.endm

BACK:		.macro	ea
		add.l	ea,d7
		suba.l	ea,a2
		.endm


V_Q:		.equ	19
V_AT:		.equ	18
V_PER:		.equ	17
V_BRACE:	.equ	16

T_MACRO:	.equ	11
T_S_QUOTE:	.equ	10
T_D_QUOTE:	.equ	9
T_WORD:		.equ	8

get_token2::
		PUSH	d1-d7/a0/a3-a4/a6
		move.l	#1<<T_MACRO,d6
		bra	@f
get_token::
		PUSH	d1-d7/a0/a3-a4/a6	;ϐWJ a6 ς鎖
		moveq	#0,d6
@@:		moveq	#0,d5

		move.l	(Q_sp_save,a5),-(sp)
		move.l	sp,(Q_sp_save,a5)

		bsr	skip_blank
		bsr	get_token_sub
		btst	#T_WORD,d6
		beq	@f

		PUT	<clr.b  (a2)+>
@@:
		move.l	d5,d0			;g[N
get_token_end:
		move.l	(sp)+,(Q_sp_save,a5)
		POP	d1-d7/a0/a3-a4/a6
		tst.l	d0
		rts

get_token_overflow:
		movea.l	(Q_sp_save,a5),sp
		moveq	#-1,d0
		bra	get_token_end

* 
get_token_loop:
		bset	#T_WORD,d6
		bne	get_token_loop2
		addq.l	#1,d5			;g[NJn
get_token_sub::
get_token_loop2:
		bsr	get_char
		beq	get_token_nul

		cmpi.b	#'z',d0
		bhi	@f
		cmpi.b	#'a',d0
		bcc	get_token_char1		;a-z
		cmpi.b	#'Z',d0
		bhi	@f
		cmpi.b	#'A',d0
		bcc	get_token_char1		;A-Z
@@:
		cmpi.b	#"'",d0
		beq	get_token_s_quote
		cmpi.b	#'"',d0
		beq	get_token_d_quote
		btst	#T_S_QUOTE,d6
		bne	get_token_char2

		cmpi.b	#'$',d0
		beq	get_token_dollar
		cmpi.b	#'~',d0
		beq	get_token_tilde
		cmpi.b	#'\',d0
		beq	get_token_bslash

		btst	#T_D_QUOTE,d6
		bne	get_token_char2

		cmpi.b	#SPACE,d0
		beq	get_token_blank
		cmpi.b	#';',d0
		beq	get_token_chain
		cmpi.b	#'{',d0
		beq	get_token_chain
		cmpi.b	#'}',d0
		beq	get_token_chain
get_token_char2:
		.fail	(TERM<=TC_FILE).or.(TERM<=TC_ESC)
		cmpi.b	#TERM,d0
		bhi	get_token_char3
		beq	get_token_lf		;}N̏I
		cmpi.b	#TC_FILE,d0
		beq	@f
		cmpi.b	#TC_ESC,d0
		bne	get_token_char3
@@:
* TC_FILEATC_ESC ƓR[h̓GXP[v
		PUT	<move.b  #TC_ESC,(a2)+>
get_token_char3:
		PUT	<move.b  d0,(a2)+>
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	get_token_loop

		move.b	(a1)+,d0		;QoCg
get_token_char1:
		PUT	<move.b  d0,(a2)+>
		bra	get_token_loop

* 
get_token_blank:
		btst	#T_MACRO,d6
		bne	get_token_char1		;}NWJ
		btst	#T_WORD,d6
		beq	get_token_loop2		;܂g[Nn܂ĂȂ
		rts

* \ : GXP[v
get_token_bslash:
		cmpi	#2,(unix)
		bcs	get_token_char1		;%unix 0/1 Ȃ '\' ̂

		bsr	get_char		;%unix 2 Ȃ玟̕ʂ
		bne	get_token_char2
		bra	get_token_nul

* ; { } : `FCL
get_token_chain:
		btst	#T_MACRO,d6
		bne	get_token_char1		;}NWJ
* NUL
* LF : }NI
get_token_nul:
get_token_lf:
		subq.l	#1,a1
		rts

* ' : NH[eBO
get_token_s_quote:
		bchg	#T_S_QUOTE,d6
		btst	#T_D_QUOTE,d6
		bne	get_token_char1		;"`  '
		bra	get_token_loop

* " : NH[eBO
get_token_d_quote:
		btst	#T_S_QUOTE,d6
		beq	@f
		btst	#T_D_QUOTE,d6
		beq	get_token_char1		;'`  "
		bclr	#T_S_QUOTE,d6		;"`'`  "
@@:		bchg	#T_D_QUOTE,d6
		bra	get_token_loop


* w}ÑAhX
* out	d0.l	}NAhX
get_prev_macro:
		PUSH	d1-d2/a1
		movea.l	(Q_macro,a5),a1
		moveq	#0,d1
		moveq	#8-1,d2
@@:
		moveq	#$f,d0
		lsl.l	#4,d1
		and.b	-(a1),d0
		or.b	d0,d1
		dbra	d2,@b
		add.l	a1,d1
		move.l	d1,d0
		POP	d1-d2/a1
		rts


* 
* in	a1.l	̃AhX
* out	a1.l	V
*	d0.b	R[h
*	ccr	<tst.b d0> ̌
* l:
*	}NWJJn/I}[N͓ŏAԒlɂ
*	Ȃ. }NLq̍ċA}Nl.
*	}N𑖍ɈI}[N(LF)𔭌
*	}[N̂܂ܕԂ.

get_char::
		move.b	(a1)+,d0
		beq	get_char_nul
		cmpi.b	#PREFIX,d0
		bne	get_char_end		;ʏ̕ or TERM
		move.b	(a1)+,d0
		beq	get_char_nul
		cmpi.b	#')',d0
		beq	get_char_mac_end	;PREFIX,')' : }NWJI}[N
		cmpi.b	#'(',d0
		beq	get_char_mac_start	;PREFIX,'(' : }NWJJn}[N
		bra	get_char
get_char_mac_end:
		bsr	get_prev_macro
		move.l	d0,(Q_macro,a5)
		bra	get_char
get_char_mac_start:
		PUSH	d1-d2
		move.l	(Q_macro,a5),d1
		sub.l	a1,d1
		moveq	#8-1,d2
@@:
		moveq	#$f,d0
		and.b	d1,d0
		addi.b	#'0',d0
		lsr.l	#4,d1
		move.b	d0,(a1)+
		dbra	d2,@b
		POP	d1-d2
		move.l	a1,(Q_macro,a5)
@@:
		bsr	get_char
		cmpi.b	#TERM,d0
		bne	@b			;΂
		cmp.b	(a1),d0
		bne	@b			;̈
		addq.l	#1,a1
		bra	get_char
get_char_nul:
get_char_end:
		tst.b	d0
		rts


* ̕ǂ݂
fetch_char2::
		bsr	get_char
		bra	fetch_char

* ǂ
* in	a1.l	̃AhX
*	d0.b	R[h
*	ccr	<tst.b d0> ̌

fetch_char::
		move.l	(Q_macro,a5),-(sp)
		move.l	a1,-(sp)
		bsr	get_char
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)
		tst.b	d0
		rts


* ~/ : z[fBNgWJ
get_token_tilde:
		tst.b	(Q_skip,a5)
		bne	get_token_char1		;XLbv

		bsr	fetch_char
		cmpi.b	#'/',d0
		bne	get_token_tilde9	;PƂ '~'

* $HOME WJ
		lea	(tmp_buf),a3
		pea	(a3)
		clr.l	-(sp)
		pea	(str_home,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	get_token_tilde9
		tst.b	(a3)
		beq	get_token_tilde9

		PUT	<move.b  #TC_FILE,(a2)+>
		move.l	a2,-(sp)
		exg	a1,a3
		bsr	put_a1_esc
		exg	a1,a3
		movea.l	(sp)+,a3

* Ō̕𒲂ׂ
		moveq	#0,d1
@@:		move.b	(a3)+,d0
		beq	@f
		move.b	d0,d1
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		tst.b	(a3)+
		bne	@b
@@:
		bsr	get_char		;'/' o
		cmp.b	d0,d1
		beq	@f			;c:// ɂȂȂ悤ɂ
		PUT	<move.b  d0,(a2)+>
@@:
		PUT	<move.b  #TC_FILE,(a2)+>
		bra	get_token_loop
get_token_tilde9:
		moveq	#'~',d0
		bra	get_token_char1


* $ : ϐWJ
get_token_dollar:
		move.l	(Q_macro,a5),-(sp)	;A{[gpɕۑ
		move.l	a1,-(sp)		;V

		ext.l	d6			;V_Q`V_BRACE NA

		bsr	fetch_char
		cmpi.b	#'?',d0
		bne	@f
		bset	#V_Q,d6			;ϐ $?
		bsr	fetch_char2
@@:
		cmpi.b	#'@',d0
		bne	@f
		bset	#V_AT,d6		;VXeϐ $@
		bra	1f
@@:
		cmpi.b	#'%',d0
		bne	@f
		bset	#V_PER,d6		;ϐ $%
1:		bsr	fetch_char2
@@:
		cmpi.b	#'{',d0
		bne	@f
		bset	#V_BRACE,d6		;${
		bsr	fetch_char2
@@:

* ϐo
		move.l	a2,d2
		PUSH	d7/a2
@@:
		cmpi.b	#'#',d0
**		seq	d3
		beq	1f			;$# ΍
		cmpi.b	#'&',d0
**		seq	d3
		beq	1f			;$& ΍
		cmpi.b	#'-',d0
		beq	1f
		cmpi.b	#'0',d0
		bcs	9f
		cmpi.b	#'9',d0
		bls	1f			;0-9
		cmpi.b	#'<',d0
**		seq	d3
		beq	1f			;$< ΍
		cmpi.b	#'A',d0
		bcs	9f
		cmpi.b	#'Z',d0
		bls	1f			;A-Z
		cmpi.b	#'_',d0
		beq	1f
		cmpi.b	#'a',d0
		bcs	9f
		cmpi.b	#'z',d0
		bls	1f			;a-z
		move.b	d0,d1
		bpl	9f
		lsr.b	#5,d1
		btst	d1,#%10010000
		beq	1f
		PUT	<move.b  d0,(a2)+>	;QoCg
		bsr	get_char		;ʃoCgǂݎ̂Ă
		PUT	<move.b  (a1)+,(a2)+>
		bsr	fetch_char
		bra	@b
1:
		PUT	<move.b  d0,(a2)+>
		bsr	fetch_char2
**		tst.b	d3
**		beq	@b			;$# $& $< $O# Ȃϐ͏I
		bra	@b
9:
		sub.l	a2,d2
		PUT	<clr.b  (a2)+>
		POP	d7/a2
		neg.l	d2			;ϐ̒
		beq	get_token_d_9		;ϐLqĂȂ

**		btst	#V_BRACE,d6
**		beq	@f
**		cmpi.b	#':',d0
**		beq	@f
**		cmpi.b	#'}',d0
**		bne	get_token_d_9		;ϐ̋Lqs
**@@:
		moveq	#0,d4			;ϐڐ-1
		tst.b	(Q_skip,a5)
		beq	@f
		addq.l	#8,sp			;XLbv
		bra	get_token_d_deco_loop
@@:
		btst	#V_AT,d6
		bne	get_token_d_usr_skip
		btst	#V_PER,d6
		bne	get_token_d_sys_skip

* }N
*get_token_d_macro:
		cmpi.b	#'9',(a2)
		bhi	get_token_d_mac_skip
		lea	(a2),a0
		cmpi.b	#'0',(a0)
		bhi	@f
		bcs	get_token_d_mac_skip
		moveq	#0,d0
		addq.l	#1,a0
		bra	get_token_d_mac2
@@:
		jsr	(atoi_a0)
		bne	get_token_d_mac_skip
get_token_d_mac2:
		tst.b	(a0)
		bne	get_token_d_mac_skip

		move.l	d0,d1			;ԍ(0`)
		move.l	(Q_macro,a5),d0
		beq	get_token_d_mac_skip	;}NWJł͂Ȃ

		move.l	(Q_macro,a5),-(sp)
		move.l	a1,-(sp)
		movea.l	d0,a1
		bra	1f
@@:
		bsr	get_char
		cmpi.b	#TERM,d0
		bne	@b
		cmp.b	(a1),d0
		beq	get_token_d_mac9	;ԍ傫
1:		subq.l	#1,d1
		bcc	@b

		bsr	get_prev_macro
		move.l	d0,(Q_macro,a5)
		move.l	a2,d1
		bra	1f
@@:
		add.l	d0,d4
1:		bsr	get_token2
		bgt	@b
		bmi	get_token_overflow

		BACK	#1
		tst.l	d4
		beq	@f
		subq.l	#1,d4
@@:
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	d1,-(sp)		;Cpɕۑ

		bra	get_token_d_found2
get_token_d_mac9:
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)
get_token_d_mac_skip:

* VXe\ϐ

* $ARG $MATCH e[uŏ $?ARG $?MATCH
*  1 ɂȂĂ܂̂ŁAɒׂă[Uϐ
* ̏ɔ΂
		lea	(a2),a0
		cmpi.b	#'A',(a0)+
		bne	@f
	.irpc	c,RG
		cmpi.b	#'&c',(a0)+
		bne	9f
	.endm
		tst.b	(a0)
		bne	9f
		moveq	#'_',d0			;$ARG  $_ ɒu
		bra	8f
@@:
		cmpi.b	#'M',(a2)
		bne	9f
	.irpc	c,ATCH
		cmpi.b	#'&c',(a0)+
		bne	9f
	.endm
		tst.b	(a0)
		bne	9f
		moveq	#'&',d0			;$MATCH  $& ɒu
8:		move.b	d0,(a2)
		clr.b	(1,a2)
		bra	get_token_d_sys_res_skip
9:

* VXe\ϐe[u猟
		moveq	#$01,d1
		moveq	#0,d3
		lea	(sys_res_val_tbl,pc),a4
1:
		cmp.b	(a4,d2.l),d1
		bcs	9f			;ϐ̒Ⴄ
		lea	(a2),a0
		lea	(a4),a3
2:
		move.b	(a0)+,d0
		beq	get_token_d_sys_res_found
		cmp.b	(a3)+,d0
		beq	2b
9:
		cmp.b	(a4)+,d1		;e[u̕ϐ΂
		bcs	9b
		beq	1b			;̕ʖ
		addq	#2,d3
		tst.b	(a4)
		bne	1b			;̕ϐ
		bra	get_token_d_sys_res_skip
get_token_d_sys_res_found:
		btst	#V_Q,d6
		bne	get_token_d_q_found

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	a2,-(sp)		;Cpɕۑ

* WJ[`Ăяo
		lea	(sys_res_val_adr,pc),a0
		adda	d3,a0
		adda	(a0),a0
		jsr	(a0)
		bra	get_token_d_found2
get_token_d_sys_res_skip:

* [Uϐ
		exg	a1,a2
		jsr	(search_user_value_a1)
		exg	a1,a2
		beq	get_token_d_usr_skip

		btst	#V_Q,d6
		bne	get_token_d_q_found

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	a2,-(sp)		;Cpɕۑ

		movea.l	d0,a1
		moveq	#$01,d0
@@:		cmp.b	(a1)+,d0
		bne	@b
		bsr	put_a1_esc
		bra	get_token_d_found
get_token_d_usr_skip:

* VXeϐ
		btst	#V_PER,d6
		bne	get_token_d_sys_skip

		exg	a1,a2
		jsr	(search_system_value)
		exg	a1,a2
		beq	get_token_d_sys_skip

		btst	#V_Q,d6
		bne	get_token_d_q_found

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	a2,-(sp)		;Cpɕۑ

		movea.l	d0,a1
		moveq	#0,d0
		move	(a1),d0
		bsr	ltos_d0
		bra	get_token_d_found2
get_token_d_sys_skip:

* ϐ
		btst	#V_AT,d6
		bne	get_token_d_not_found

		lea	(tmp_buf),a3
		pea	(a3)
		clr.l	-(sp)
		pea	(a2)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	get_token_d_not_found

		btst	#V_Q,d6
		bne	get_token_d_q_found

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	a2,-(sp)		;Cpɕۑ

		exg	a1,a3
		bsr	put_a1_esc
		exg	a1,a3
		bra	get_token_d_found

get_token_d_not_found:
		btst	#V_Q,d6
		bne	get_token_d_q_not_found

		btst	#V_BRACE,d6
		beq	get_token_d_9		;$foo ȂA"$foo" ̂܂ܒʂ

		lea	(str_nul,pc),a3		;${foo} ȂA"NUL" ɓWJ
		bra	@f
get_token_d_q_not_found:
		lea	(str_0,pc),a3
		bra	@f
get_token_d_q_found:
		lea	(str_1,pc),a3
@@:
		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
		move.l	a2,-(sp)		;Cpɕۑ

		exg	a1,a3
		bsr	put_a1
		exg	a1,a3
		bra	get_token_d_found2	;sv

get_token_d_found:
**		tst.l	d4
**		bne	get_token_d_found2	;ς

* WJ𕪊
		movea.l	(sp),a3			;WJAhX
		moveq	#SPACE,d1
		bra	@f
get_token_d_split:
		clr.b	(-1,a3)			;󔒂ŕ
		addq.l	#1,d4
@@:
		move.b	(a3)+,d0
		beq	get_token_d_found2
		cmp.b	d1,d0
		beq	get_token_d_split
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		tst.b	(a3)+			;QoCg
		bne	@b
		BACK	#2
		PUT	<clr.b (a2)+>
get_token_d_found2:
		movea.l	(sp)+,a3		;WJAhX

* C
get_token_d_decorate:
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)
get_token_d_deco_loop:
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V

		bsr	get_char
		cmpi.b	#'}',d0
		beq	get_token_d_brace
		cmpi.b	#':',d0
		bne	get_token_d_8		;CȂ
		bsr	get_modify_type
		beq	get_token_d_8

		tst.b	(Q_skip,a5)
		bne	get_token_d_deco_skip	;XLbv

		tst.l	d7
		beq	get_token_overflow
		clr.b	(a2)

		move.l	a3,-(sp)
		movea.l	d0,a0
		jsr	(a0)			;C[`Ăяo
		movea.l	(sp)+,a3
get_token_d_deco_skip:
		addq.l	#8,sp
		bra	get_token_d_deco_loop

get_token_d_brace:
		btst	#V_BRACE,d6
		beq	get_token_d_8

		addq.l	#8,sp
		move.l	(Q_macro,a5),-(sp)	;̎ʒu
		move.l	a1,-(sp)		;V
get_token_d_8:
**		tst.b	(Q_skip,a5)
**		bne	get_token_d_89		;XLbv(d4=0 Ȃ̂ŕsv)
		tst.l	d4
		beq	get_token_d_89
		btst	#T_D_QUOTE,d6
		beq	get_token_d_88		;"`" OȂ畡̃g[NƂĕԂ

		moveq	#SPACE,d1		;Ăɖ߂
@@:
		tst.b	(a3)+
		bne	@b
		move.b	d1,(-1,a3)
		subq.l	#1,d4
		bne	@b
**		moveq	#0,d4
get_token_d_88:
		add.l	d4,d5
get_token_d_89:
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)
		bra	get_token_loop

get_token_d_9:
		movea.l	(sp)+,a1
		move.l	(sp)+,(Q_macro,a5)
		moveq	#'$',d0
		bra	get_token_char1


* ϐC ------------------------------------ *

* C̎ނ𓾂
* in	a1.l	CL̃AhX
* out	a1.l	+=1 (:alA:au ̏ꍇ += 2)
*	d0.l	C[`̃AhX(NULL ȂG[)
*	ccr	<tst.l d0> ̌
* l:
*	CLLqĂȂꍇA
*	a1.l ̒l͕sƂȂ.

get_modify_type::
		PUSH	a2-a3
		bsr	get_char
		cmpi.b	#'a',d0
		bne	@f
		bsr	get_char
		andi.b	#$df,d0
@@:
		lea	(modify_tbl,pc),a2
		lea	(modify_adr,pc),a3
@@:
		cmp.b	(a2)+,d0
		beq	@f
		addq.l	#2,a3
		tst.b	(a2)
		bne	@b
		moveq	#0,d0
		bra	get_modify_type_end
@@:
		adda	(a3),a3
		move.l	a3,d0
get_modify_type_end:
		POP	a2-a3
		rts

* C[`
* in	d4.l	ϐڐ-1
*	d7.l	obt@coCg
*	a2.l	̏݃|C^
*	a3.l	WJ̃AhX
* break	d0-d3/a3-a4

* :al = S
modify_al:
		moveq	#'A',d1
		moveq	#'Z',d2
		bra	modify_alu

* :au = S啶
modify_au:
		moveq	#'a',d1
		moveq	#'z',d2
modify_alu:
		move.l	d4,d3
modify_alu_loop:
		bsr	skip_tc_a3
		cmp.b	(a3),d1
		bhi	@f
		cmp.b	(a3),d2
		bcs	@f
		eori.b	#$20,(a3)		;啶 <-> 
@@:
		move.b	(a3)+,d0
		beq	modify_alu_nul
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	modify_alu_loop
		tst.b	(a3)+			;QoCg
		bne	modify_alu_loop
modify_alu_nul:
		subq.l	#1,d3
		bcc	modify_alu_loop
		rts


* R[h΂
skip_tc_a3_e:
		addq.l	#1,a3
		tst.b	(a3)
		beq	skip_tc_a3_end
skip_tc_a3_f:
		addq.l	#1,a3
skip_tc_a3:
		cmpi.b	#TC_FILE,(a3)
		beq	skip_tc_a3_f
		cmpi.b	#TC_ESC,(a3)
		beq	skip_tc_a3_e
skip_tc_a3_end:
		rts


* :l = 
modify_l:
		moveq	#'A',d1
		moveq	#'Z',d2
		bra	modify_lu

* :u = 啶
modify_u:
		moveq	#'a',d1
		moveq	#'z',d2
modify_lu:
		move.l	d4,d3
modify_lu_loop:
		cmpi.b	#TC_FILE,(a3)+		;擪 TC_FILE ΂
		beq	modify_lu_loop
		subq.l	#1,a3
		cmp.b	(a3),d1
		bhi	@f
		cmp.b	(a3),d2
		bcs	@f
		eori.b	#$20,(a3)		;啶 <-> 
@@:
		move.b	(a3)+,d0
		beq	modify_lu_nul
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		tst.b	(a3)+			;QoCg
		bne	@b
modify_lu_nul:
		subq.l	#1,d3
		bcc	modify_lu_loop
		rts


* :e = gqo
modify_e:
		move.l	a2,d0
		sub.l	a3,d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		move.l	d4,d3
modify_e_loop:
		bsr	search_ext
		tst.b	(a3)+			;'.' ΂
		bne	@f
		move.b	-(a3),d0		;TC_FILE ͕sv
@@:
		bsr	put_a3_tc
		beq	@f
		bsr	put_tc_file
@@:		PUT	<clr.b  (a2)+>

		subq.l	#1,d3
		bcc	modify_e_loop
		BACK	#1
		rts


* :r = gq폜
modify_r:
		move.l	a2,d0
		sub.l	a3,d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		move.l	d4,d3
modify_r_loop:
		lea	(a3),a4
		bsr	search_ext
		exg	a3,a4
		move.b	(a4),-(sp)
		clr.b	(a4)			;'.'  NUL ɏ

		moveq	#0,d0
		bsr	put_a3_tc

		move.b	(sp)+,-(a3)		;'.' ɖ߂
@@:		tst.b	(a3)+			;gq΂
		bne	@b

		tst.b	d0
		beq	@f
		bsr	put_tc_file
@@:
		PUT	<clr.b  (a2)+>

		subq.l	#1,d3
		bcc	modify_r_loop
		BACK	#1
		rts


* :d = hCuo
modify_d:
		move.l	a2,d0
		sub.l	a3,d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		move.l	d4,d3
modify_d_loop:
		PUSH	d7/a2
		moveq	#0,d0
		bsr	trans_tc_file_a3
		moveq	#$df,d1
		and.b	(a3),d1
		cmpi.b	#'A',d1
		bcs	modify_d_fail		;hCűLqȂ
		cmpi.b	#'Z',d1
		bhi	modify_d_fail		;V
		PUT	<move.b  (a3)+,(a2)+>
		bsr	trans_tc_file_a3
		cmpi.b	#':',(a3)
		bne	modify_d_fail		;V

		addq.l	#.sizeof.(d7/a2),sp
**		PUT	<move.b  (a3)+,(a2)+>	;':' ͕sv
		bra	@f
modify_d_fail:
		POP	d7/a2
		moveq	#0,d0
@@:
		tst.b	(a3)+			;c̕΂
		bne	@b

		tst.b	d0
		beq	@f
		bsr	put_tc_file
@@:
		PUT	<clr.b  (a2)+>
		subq.l	#1,d3
		bcc	modify_d_loop
		BACK	#1
		rts


* 擪 TC_FILE ]
* in	a3.l	
*	d0.b	݂̃[h
* out	d0.b	[h(TC_FILE or 0)

@@:
		eori.b	#TC_FILE,d0
		PUT	<move.b  (a3)+,(a2)+>
trans_tc_file_a3:
		cmpi.b	#TC_FILE,(a3)
		beq	@b
		rts


* :t = t@Co
modify_t:
		move.l	a2,d0
		sub.l	a3,d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		move.l	d4,d3
modify_t_loop:
		bsr	search_last_sep
		moveq	#TC_FILE,d1
		bra	1f
@@:
		addq.l	#1,a3
1:		cmpi.b	#'/',(a3)		;pXf~^΂
		beq	@b
		cmpi.b	#'\',(a3)
		beq	@b
		cmp.b	(a3),d1
		bne	@f
		eor.b	d1,d0			;TC_FILE
		bra	@b
@@:
		tst.b	(a3)
		bne	@f
		moveq	#0,d0			;TC_FILE ͕sv
@@:
		bsr	put_a3_tc
		beq	@f
		bsr	put_tc_file
@@:		PUT	<clr.b  (a2)+>

		subq.l	#1,d3
		bcc	modify_t_loop
		BACK	#1
		rts


* :h = t@C폜
modify_h:
		move.l	a2,d0
		sub.l	a3,d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		move.l	d4,d3
modify_h_loop:
		lea	(a3),a4
		bsr	search_last_sep
		exg	a3,a4
		move.b	(a4),-(sp)
		clr.b	(a4)			;pXf~^ NUL ɏ

		moveq	#0,d0
		bsr	put_a3_tc

		move.b	(sp)+,-(a3)		;pXf~^ɖ߂
@@:		tst.b	(a3)+			;t@C΂
		bne	@b

		tst.b	d0
		beq	@f
		bsr	put_tc_file
@@:
		PUT	<clr.b  (a2)+>

		subq.l	#1,d3
		bcc	modify_h_loop
		BACK	#1
		rts


		.offset	0
~mod_s_a1:	.ds.l	1
~mod_s_mac:	.ds.l	1
~mod_s_top:	.ds.l	1
~mod_s_from:	.ds.l	1
~mod_s_to:	.ds.l	1
~mod_s_new:	.ds.l	1
~mod_s_d7:	.ds.l	1
~mod_s_a2:	.ds.l	1
sizeof_mod_s:
		.text

* :s/from/to/[g] = u
modify_s:
		lea	(-sizeof_mod_s,sp),sp
		move.l	(Q_macro,a5),(~mod_s_mac,sp)
		move.l	a1,(~mod_s_a1,sp)
		move.l	a3,(~mod_s_top,sp)
		movem.l	d7/a2,(~mod_s_d7,sp)

		PUT	<clr.b  (a2)+>
		moveq	#$20,d2

		bsr	get_char2
		beq	modify_s9
		move	d0,d1			;؂L

* u̎
		move.l	a2,(~mod_s_from,sp)
		bsr	get_char2
		beq	modify_s9
modify_s_from_loop:
		cmp	d2,d0
		bne	@f
		bset	#31,d2			;from ɋ󔒂܂܂
@@:		bsr	put_char2
		bsr	get_char2
		beq	modify_s9
		cmp	d0,d1
		bne	modify_s_from_loop
		PUT	<clr.b  (a2)+>

* u敶̎
		move.l	(Q_macro,a5),(~mod_s_mac,sp)
		move.l	a1,(~mod_s_a1,sp)	;̎_Ŏsm
		move.l	a2,(~mod_s_to,sp)
		bra	@f
modify_s_to_loop:
		bsr	put_char2
@@:		bsr	get_char2
		cmp	d2,d0
		bls	@f
		cmpi	#':',d0
		beq	@f
		move.l	(Q_macro,a5),(~mod_s_mac,sp)
		move.l	a1,(~mod_s_a1,sp)
		cmp	d0,d1
		bne	modify_s_to_loop
		bsr	get_char
		cmpi.b	#'g',d0
		bne	@f
		move.l	(Q_macro,a5),(~mod_s_mac,sp)
		move.l	a1,(~mod_s_a1,sp)	;s/from/to/g
		bset	#30,d2
@@:		PUT	<clr.b  (a2)+>

		swap	d2			;bit16=1:spc bit15=1:g
		add	d2,d2
		bcc	modify_s_no_space
		tst.l	d4
		beq	modify_s_no_space
		move.l	a3,-(sp)
		moveq	#SPACE,d1
@@:
		tst.b	(a3)+
		bne	@b
		move.b	d1,-(a3)
		subq.l	#1,d4
		bne	@b
		movea.l	(sp)+,a3
modify_s_no_space:
		move.l	a2,(~mod_s_new,sp)

		move.l	d4,d3
modify_s_cmp_loop2:
		clr.b	d2
modify_s_cmp_loop:
		tst.b	d2
		bne	modify_s_skip		;uς(g Ȃ)

		move.l	a3,d1
		movea.l	(~mod_s_from,sp),a4
@@:
		tst.b	(a4)
		beq	modify_s_match		;from v
1:
		move.b	(a3)+,d0
		cmpi.b	#TC_FILE,d0
		beq	1b			;TC_FILE ͖
		cmpi.b	#TC_ESC,d0
		bne	1f
		move.b	(a3)+,d0		;̕o
1:
		cmp.b	(a4)+,d0		;PoCgr
		bne	modify_s_miss
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		cmpm.b	(a3)+,(a4)+		;ʃoCgr
		beq	@b
modify_s_miss:
		movea.l	d1,a3			;sv
modify_s_skip:
1:		move.b	(a3)+,d0
		cmpi.b	#TC_FILE,d0
		beq	1b			;TC_FILE ͖
		cmpi.b	#TC_ESC,d0
		bne	1f
		PUT	<move.b  d0,(a2)+>
		move.b	(a3)+,d0		;̕o
1:
		PUT	<move.b  d0,(a2)+>	;PoCg]
		beq	modify_s_nul
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	modify_s_cmp_loop
		PUT	<move.b  (a3)+,(a2)+>	;ʃoCg]
		bra	modify_s_cmp_loop
modify_s_match:
		move.l	(~mod_s_to,sp),a1
		bsr	put_a1
		tst	d2
		spl	d2			;g ȂȂȌ͒uȂ
		bra	modify_s_cmp_loop
modify_s_nul:
		subq.l	#1,d3
		bcc	modify_s_cmp_loop2

		move.l	a2,d0
		sub.l	(~mod_s_top,sp),d0
		BACK	d0			;݃|C^obt@擪ɖ߂

		movea.l	(~mod_s_new,sp),a3
		move.l	d4,d3
modify_s_trans_loop:
		PUT	<move.b  (a3)+,(a2)+>
		bne	modify_s_trans_loop
		subq.l	#1,d3
		bcc	modify_s_trans_loop

		BACK	#1
		movem.l	d7/a2,(~mod_s_d7,sp)
modify_s9:
		move.l	(~mod_s_mac,sp),(Q_macro,a5)
		movea.l	(~mod_s_a1,sp),a1
		movem.l	(~mod_s_d7,sp),d7/a2
		lea	(sizeof_mod_s,sp),sp
		rts


* (QoCgΉ)
put_char2:
		tst	d0
		bpl	@f
		move	d0,-(sp)
		PUT	<move.b  (sp)+,(a2)+>
@@:		PUT	<move.b  d0,(a2)+>
		rts


* (QoCgΉ)
get_char2:
		moveq	#0,d0
		move.l	a1,-(sp)
		bsr	get_char
		beq	get_char2_error
		move	d0,-(sp)
		lsr.b	#5,d0
		btst	d0,#%10010000
		bne	@f
		move	(sp)+,d0
		bra	get_char2_end
@@:
		move.l	a1,(2,sp)
		move.b	(a1)+,d0
		beq	get_char2_error2
		move.b	d0,(sp)
		move	(sp)+,d0
		ror	#8,d0
get_char2_end:
		addq.l	#4,sp
		rts
get_char2_error2:
		clr	(sp)+
get_char2_error:
		movea.l	(sp)+,a1
		rts


* C ---------------------------------- *


* gq
* in	a3.l	t@C
* out	a3.l	'.' ̃AhX
*		(gqȂꍇ NUL ̃AhXԂ)
*	d0.b	[h(TC_FILE ܂ 0)

search_ext:
		move.l	d1,-(sp)
		moveq	#0,d1
		move.b	d1,-(sp)
		clr.l	-(sp)
search_ext_loop1:
		move.b	(a3)+,d0
		cmpi.b	#'.',d0
		beq	search_ext_loop2	;擪 '.' ͖
		subq.l	#1,a3
		cmpi.b	#TC_FILE,d0
		beq	@f
		subi.b	#TC_ESC,d0
		bne	search_ext_loop2
		addq.l	#1,a3			;̕΂
@@:		addq.l	#1,a3
		eor.b	d0,d1
		bra	search_ext_loop1
search_ext_found:
		addq.l	#2+4,sp
		move.b	d1,-(sp)
		move.l	a3,-(sp)
search_ext_loop2:
		move.b	(a3)+,d0
		beq	search_ext_nul
		cmpi.b	#'.',d0
		beq	search_ext_found
		cmpi.b	#TC_FILE,d0
		bne	@f
		eor.b	d0,d1
		bra	search_ext_loop2
@@:
		cmpi.b	#TC_ESC,d0
		beq	@f			;̕΂
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	search_ext_loop2
@@:		tst.b	(a3)+			;QoCg
		bne	search_ext_loop2
search_ext_nul:
		move.l	(sp)+,d0
		beq	@f
		movea.l	d0,a3
@@:		subq.l	#1,a3
		move.b	(sp)+,d0

		move.l	(sp)+,d1
		rts


* Ō̃pXf~^
* in	a3.l	t@C
* out	a3.l	Ō̃pXf~^̃AhX
*	d0.b	[h(TC_FILE ܂ 0)

search_last_sep:
		PUSH	d1-d3
		moveq	#0,d1
		moveq	#%10,d2			;hCuoptO
		moveq	#TC_FILE,d3
		move.b	d1,-(sp)
		move.l	a3,-(sp)
		bra	search_l_s_loop
search_l_s_found:
		subq.l	#1,a3
		addq.l	#2+4,sp
		move.b	d1,-(sp)
		move.l	a3,-(sp)
		moveq	#0,d2
@@:
		addq.l	#1,a3
		cmpi.b	#'/',(a3)		;ApXf~^΂
		beq	@b
		cmpi.b	#'\',(a3)
		beq	@b
		cmp.b	(a3),d3
		bne	search_l_s_loop
		eor.b	d3,d1			;TC_FILE
		bra	@b
search_l_s_drive:
		addq.l	#2+4,sp
		move.b	d1,-(sp)
		move.l	a3,-(sp)
search_l_s_loop:
		move.b	(a3)+,d0
		beq	search_l_s_nul
		cmpi.b	#'/',d0
		beq	search_l_s_found
		cmpi.b	#'\',d0
		beq	search_l_s_found
		cmpi.b	#':',d0
		bne	@f
		lsr	#1,d2
		bcs	search_l_s_drive
@@:
		cmp.b	d3,d0
		bne	@f
		eor.b	d3,d1			;TC_FILE
		bra	search_l_s_loop
@@:
		cmpi.b	#TC_ESC,d0
		beq	@f			;̕΂
		lsr	#1,d2
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	search_l_s_loop
@@:		moveq	#0,d2
		tst.b	(a3)+			;QoCg
		bne	search_l_s_loop
search_l_s_nul:
		movea.l	(sp)+,a3
		move.b	(sp)+,d0

		POP	d1-d3
		rts


* obt@ɏ
* in	a3.l	
*	d0.b	݂̃[h
* out	d0.b	[h(TC_FILE or 0)
*	ccr	<tst.b d0> ̌

put_a3_tc:
		move.b	d0,-(sp)
		beq	put_a3_tc_loop
		bsr	put_tc_file
put_a3_tc_loop:
		move.b	(a3)+,d0
		cmpi.b	#TC_FILE,d0
		bne	1f
		eor.b	d0,(sp)
		bra	2f
1:		cmpi.b	#TC_ESC,d0
		bne	2f
		PUT	<move.b  d0,(a2)+>
		move.b	(a3)+,d0
2:		PUT	<move.b  d0,(a2)+>
		beq	put_a3_tc_end
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	put_a3_tc_loop
		PUT	<move.b  (a3)+,(a2)+>
		bra	put_a3_tc_loop
put_a3_tc_end:
		BACK	#1
		move.b	(sp)+,d0
		rts


* VXeϐWJ ---------------------------- *

* J[\pX
*	$C $CURRENT $PWD
sys_res_c:
		bset	#MA_REQ_PATH,(Q_ma_req_cur,a5)

		bsr	put_tc_file
		bsr	put_path
		BACK	#1			;̃pXf~^폜
		bra	put_tc_file
**		rts


* J[\ʒut@C
*	$F $FILE
sys_res_f:
		tst.b	(Q_mintarc,a5)
		bne	sys_res_f_mintarc
		move.l	(Q_ext_exec,a5),d0
		bne	sys_res_f_extexec
sys_res_f2:
		bsr	put_tc_file
sys_res_f3:
		bset	#MA_REQ_FILE,(Q_ma_req_cur,a5)

		moveq	#FILENAME_MAX+1,d0
		CHK	d0
		jsr	(search_cursor_file)
		lea	(DIR_NAME,a4),a1
		jsr	(copy_dir_name_a1_a2)
		PASS
		bra	put_tc_file
**		rts


* mintarc ł $PA$F ͏Ƀt@C(tpX)WJ
sys_res_f_mintarc:
		jsr	(get_mintarc_filename)

* &ext-exec ł $PA$F ̓t@CWJ
sys_res_f_extexec:
		movea.l	d0,a1
		bsr	put_tc_file
		bsr	put_a1
		bra	put_tc_file
**		rts


* J[\ʒut@C(tpX)
*	$P $PFILE
sys_res_p:
		tst.b	(Q_mintarc,a5)
		bne	sys_res_f_mintarc
		move.l	(Q_ext_exec,a5),d0
		bne	sys_res_f_extexec

		bsr	put_tc_file
		bsr	put_path
		bra	sys_res_f3
**		rts


* J[\}[Nt@C
*	$M $MARK
sys_res_m:
		moveq	#0,d3			;}[NȂApXȂ
		bra	sys_res_mark

* }[Nt@CWJ
* in	d3.hb	$ff=}[N
*	d3.b	$ff=tpX
*	d4.l	ϐڐ-1
* out	d4.l	V

sys_res_mark:
		movea.l	(PATH_BUF,a6),a4
		jsr	(search_mark_file)
		beq	sys_res_mark2
		tst.b	d3			;}[NȂ
		beq	sys_res_f
		bra	sys_res_p
sys_res_mark2:
		bset	#MA_REQ_MARK,(Q_ma_req_cur,a5)
		tst	d3
		bpl	@f			;}[N͂Ƃōĕ`悷
		bset	#MA_REQ_REDRAW,(Q_ma_req_cur,a5)
@@:
		bra	sys_res_mark_start
sys_res_mark_next:
		addq.l	#1,d4
		PUT	<clr.b  (a2)+>
sys_res_mark_start:
		bsr	put_tc_file
		tst.b	d3
		beq	sys_res_mark_no_path

		bsr	put_path		;pXt
sys_res_mark_no_path:
		tst	d3
		bpl	@f
		bclr	#MARK,(DIR_ATR,a4)	;}[N
@@:
		moveq	#FILENAME_MAX+1,d0
		CHK	d0
		lea	(DIR_NAME,a4),a1
		jsr	(copy_dir_name_a1_a2)
		PASS
		bsr	put_tc_file

		lea	(sizeof_DIR,a4),a4
		jsr	(search_mark_file)
		beq	sys_res_mark_next

		rts


* J[\}[Nt@C(tpX)
*	$PM $PMARK
sys_res_pm:
		moveq	#1,d3			;}[NȂAtpX
		bra	sys_res_mark


* J[\}[Nt@C(}[N)
*	$MARK_R
sys_res_m_r:
		moveq	#$80,d3			;}[NApXȂ
		add.b	d3,d3
		bra	sys_res_mark


* J[\}[Nt@C(tpXA}[N)
*	$PMARK_R
sys_res_pm_r:
		moveq	#-1,d3			;}[NAtpX
		bra	sys_res_mark


* J[\}[N
*	$# $MARK_COUNT
sys_res_m_c:
		bsr	get_mark_count
		bra	ltos_d0
**		rts


* J[\J[\ʒu(sԍ)
*	$CURSOR
sys_res_csr:
		move	(PATH_WIN_FILE,a6),d0
		jsr	(WinGetCursor)
		move.l	d2,d0
		add	(PATH_PAGETOP,a6),d0
		addq	#1,d0
		bra	ltos_d0
**		rts


* J[\t@C
*	$ENTRIES
sys_res_ent:
		moveq	#0,d0
		move	(PATH_FILENUM,a6),d0
		bra	ltos_d0
**		rts


* ΑpX
*	$O $OPPOSITE
sys_res_o:
		lea	(sys_res_c,pc),a0
		bra	call_sys_res_opp
**		rts


* ΑJ[\ʒut@C
*	$OF $OFILE
sys_res_of:
		lea	(sys_res_f,pc),a0
		bra	call_sys_res_opp
**		rts


* ΑJ[\ʒut@C(tpX)
*	$OP $OPFILE
sys_res_op:
		lea	(sys_res_p,pc),a0
		bra	call_sys_res_opp
**		rts


* Α}[Nt@C
*	$OM $OMARK
sys_res_om:
		lea	(sys_res_m,pc),a0
		bra	call_sys_res_opp
**		rts


* Α}[Nt@C(tpX)
*	$OPM $OPMARK
sys_res_opm:
		lea	(sys_res_pm,pc),a0
		bra	call_sys_res_opp
**		rts


* Α}[Nt@C(}[N)
*	$OMARK_R
sys_res_om_r:
		lea	(sys_res_m_r,pc),a0
		bra	call_sys_res_opp
**		rts


* Α}[Nt@C(tpXA}[N)
*	$OPMARK_R
sys_res_opm_r:
		lea	(sys_res_pm_r,pc),a0
		bra	call_sys_res_opp
**		rts


* Α}[N
*	$O# $OMARK_COUNT
sys_res_om_c:
		lea	(sys_res_m_c,pc),a0
		bra	call_sys_res_opp
**		rts


* ΑJ[\ʒu(sԍ)
*	$OCURSOR
sys_res_ocsr:
		lea	(sys_res_csr,pc),a0
		bra	call_sys_res_opp
**		rts


* Αt@C
*	$OENTRIES
sys_res_oent:
		lea	(sys_res_ent,pc),a0
		bra	call_sys_res_opp
**		rts


* EBhE}[Nt@C
*	$B $BMARK $BOTH_SIDE_MARKS
sys_res_b:
		movea.l	(PATH_BUF,a6),a4
		jsr	(search_mark_file)
		beq	@f

		movea.l	(PATH_OPP,a6),a4
		movea.l	(PATH_BUF,a4),a4
		jsr	(search_mark_file)
		bne	sys_res_f2		;/ = $F
		bra	sys_res_opm		;/L = $OPM
@@:
		moveq	#0,d3			;}[NȂApXȂ
		bsr	sys_res_mark2

		movea.l	(PATH_OPP,a6),a4
		movea.l	(PATH_BUF,a4),a4
		jsr	(search_mark_file)
		bne	sys_res_b_end		;L/ = $M

		addq.l	#1,d4
		PUT	<clr.b  (a2)+>		;L/L = $M $OPM
		bra	sys_res_opm
sys_res_b_end:
		rts


* sҏW
*	$< $READLINE
sys_res_rl:
		move.l	a2,(Q_rl_ptr,a5)
		rts


* Xe[^Xl
*	$STATUS
sys_res_status:
		moveq	#0,d0
		move	(status,pc),d0
		bra	ltos_d0
**		rts


* OJgpX
*	$OLDPWD
sys_res_oldpwd:
		bsr	put_tc_file
		lea	(oldpwd_buf),a1
		bsr	put_a1
		bra	put_tc_file
**		rts


* J[\Eʒu
*	$SIDE
sys_res_side:
		lea	(str_left,pc),a1
		tst	(PATH_WINRL,a6)
		beq	@f
		addq.l	#str_right-str_left,a1
@@:		bra	put_a1
**		rts


* MPU ̎
*	$MPUTYPE
sys_res_mpu:
		moveq	#0,d0
		move.b	(MpuType),d0
		bra	ltos_d0
**		rts


* `t@C
*	$MINTRC
sys_res_mintrc:
		bsr	put_tc_file
		lea	(mintrc_filename),a1
		bsr	put_a1
		bra	put_tc_file
**		rts


* Ƀt@C{Ώۃt@C
*	$MINTARC
sys_res_mintarc:
		tst.b	(PATH_MARC_FLAG,a6)
		beq	sys_res_mintarc_end

		bsr	put_tc_file
		jsr	(get_mintarc_filename)
		movea.l	d0,a1
		bsr	put_a1
		bsr	put_tc_file

		movea.l	(ma_list_adr),a1
		move.l	(ma_list_num),d3
		bra	sys_res_mintarc_next
sys_res_mintarc_loop:
		addq.l	#1,d4
		PUT	<clr.b  (a2)+>
@@:
		bsr	put_tc_file
		addq.l	#1,a1			;tO΂
		bsr	put_a1
		bsr	put_tc_file
sys_res_mintarc_next:
		subq.l	#1,d3
		bcc	sys_res_mintarc_loop
sys_res_mintarc_end:
		rts


* Ƀt@C
*	$MARC_LEFT
sys_res_mark_l:
		moveq	#WIN_LEFT,d0
		bra.s	@f


* EɃt@C
*	$MARC_RIGHT
sys_res_mark_r:
		moveq	#WIN_RIGHT,d0
@@:		cmp	(PATH_WINRL,a6),d0
		bne	sys_res_marc_o
		bra	sys_res_marc

* J[\Ƀt@C
*	$MARC
sys_res_marc:
		move.l	a6,-(sp)
		bra.s	@f

* ΑɃt@C
*	$MARC_OPPOSITE
sys_res_marc_o:
		move.l	a6,-(sp)
		movea.l	(PATH_OPP,a6),a6
@@:
		tst.b	(PATH_MARC_FLAG,a6)
		beq	sys_res_marc_end

		bsr	put_tc_file
		jsr	(get_mintarc_filename)
		movea.l	d0,a1
		bsr	put_a1
		bsr	put_tc_file
sys_res_marc_end:
		movea.l	(sp)+,a6
		rts


* OtBbNʃ[h
*	$GVON
sys_res_gvon:
		lea	(VC_R2),a1
		IOCS	_B_WPEEK
		cmpi	#T_ON,d1
		beq	sys_res_gvon_off

		move	d0,d1
		lea	(VC_R0-(VC_R2+2),a1),a1
		IOCS	_B_WPEEK
		subq	#3,d0
		beq	sys_res_gvon_64k	;64K F[h

		cmpi	#64,(GTONE)
		bne	sys_res_gvon_half
sys_res_gvon_max:
		lea	(str_max,pc),a1
		bra	@f
sys_res_gvon_64k:
		cmpi	#T_ON+G_HALF_ON,d1
		bne	sys_res_gvon_max
sys_res_gvon_half:
		lea	(str_half,pc),a1
		bra	@f
sys_res_gvon_off:
		lea	(str_off,pc),a1
@@:		bra	put_a1
**		rts


* OtBbNʐ`[h
*	$SQUARE
sys_res_square:
		moveq	#0,d0
		sub.b	(sq64k),d0		;$00->'0' $ff->'1'
		bra	ltos_d0
**		rts


* &look-file \[h
*	$LOOK
sys_res_look:
		moveq	#0,d0
		add	(look_mode),d0
		bra	ltos_d0
**		rts


* &look-file {t@C
*	$LOOK_FILE_NAME
sys_res_look_fn:
		bsr	put_tc_file
		lea	(LOOK_FILE_NAME),a1
		bsr	put_a1
		bra	put_tc_file
**		rts


* (4 )
*	$YEAR
sys_res_year:
		jsr	(make_clock_sub)
		clr.b	(4,a1)
		bra	put_a1
**		rts

* (2 )
*	$YEAR2
sys_res_year2:
		moveq	#2,d0
		bra.s	@f

* 
*	$MONTH
sys_res_month:
		moveq	#5,d0
		bra.s	@f

* 
*	$DAY
sys_res_day:
		moveq	#8,d0
		bra.s	@f

* 
*	$HOUR
sys_res_hour:
		moveq	#16,d0
		bra.s	@f

* 
*	$MINUTE
sys_res_minute:
		moveq	#19,d0
		bra.s	@f

* b
*	$SECOND
sys_res_second:
		moveq	#22,d0
@@:
		jsr	(make_clock_sub)
		adda.l	d0,a1
		clr.b	(2,a1)
		bra	put_a1
**		rts


* ϐWJ ------------------------------ *

* TC_FILE }[N
put_tc_file:
		PUT	<move.b  #TC_FILE,(a2)+>
		clr.b	(a2)
		rts


* pXobt@ɏ
* break	d0/a1

put_path:
		lea	(PATH_DIRNAME,a6),a1
		tst.b	(PATH_MARC_FLAG,a6)
		beq	@f
		jsr	(get_mintarc_dir)
		movea.l	d0,a1
		bsr	put_a1
		lea	(PATH_DIRNAME+.sizeof.('a:/'),a6),a1
@@:
		bra	put_a1
**		rts


* obt@ɏ
* in	a1.l	
* break	d0/a1

put_a1:
		STRLEN	a1,d0
		sub.l	d0,d7
		bls	get_token_overflow	;NUL ̕ނ̂ bls
		STRCPY	a1,a2
		subq.l	#1,a2
		rts


* obt@ɏ(GXP[v)
* in	a1.l	

put_a1_esc:
		PUSH	d0-d1/a1
		moveq	#TC_ESC,d1
put_a1_esc_loop:
		move.b	(a1)+,d0
		beq	put_a1_esc_end
		cmpi.b	#TC_FILE,d0
		beq	1f
		cmp.b	d1,d0
		bne	2f
1:		PUT	<move.b  d1,(a2)+>
2:		PUT	<move.b  d0,(a2)+>
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	put_a1_esc_loop
		move.b	(a1)+,d0
		beq	9f
		PUT	<move.b  d0,(a2)+>
		bra	put_a1_esc_loop
9:		BACK	#1
put_a1_esc_end:
		PUT	<clr.b  (a2)+>
		BACK	#1
		POP	d0-d1/a1
		rts


* lϊ
ltos_d0:
		PUSH	d1/a0
		moveq	#.sizeof.('2147483647')+1,d1
		CHK	d1
		lea	(a2),a0
		FPACK	__LTOS
		PASS
		POP	d1/a0
		rts


* ΑĂяo
* in	a0.l	ϐWJ[`

call_sys_res_opp:
		bsr	@f
		jsr	(a0)
@@:
		movea.l	(PATH_OPP,a6),a6
		move	(Q_ma_req_cur,a5),d0
		ror	#8,d0
		move	d0,(Q_ma_req_cur,a5)
		rts


* }[NZo
get_mark_count:
		PUSH	d1/a4
		moveq	#0,d0
		movea.l	(PATH_BUF,a6),a4
		bra	@f
get_m_c_mark:
		addq.l	#1,d0
get_m_c_next:
		lea	(sizeof_DIR,a4),a4
@@:		move.b	(DIR_ATR,a4),d1
		bpl	get_m_c_next
		not.b	d1
		bne	get_m_c_mark
		POP	d1/a4
		rts


* ϐCe[u ---------------------------- *

**		.data
		.even
modify_adr:
		.dc	modify_al-$
		.dc	modify_au-$
		.dc	modify_l-$
		.dc	modify_u-$
		.dc	modify_e-$
		.dc	modify_r-$
		.dc	modify_d-$
		.dc	modify_t-$
		.dc	modify_h-$
		.dc	modify_s-$
modify_tbl:
		.dc.b	'LUluerdths',0


* VXe\ϐe[u -------------------- *

**		.data
		.even

TABLE_BODY:	.macro

* J[\EBhE
		OBJ	sys_res_c,	'C','CURRENT','PWD'
		OBJ	sys_res_f,	'F','FILE'
		OBJ	sys_res_p,	'P','PFILE'
		OBJ	sys_res_m,	'M','MARK'
		OBJ	sys_res_pm,	'PM','PMARK'
		OBJ	sys_res_m_r,	'MARK_R'
		OBJ	sys_res_pm_r,	'PMARK_R'
		OBJ	sys_res_m_c,	'#','MARK_COUNT'
		OBJ	sys_res_csr,	'CURSOR'
		OBJ	sys_res_ent,	'ENTRIES'

* ΑEBhE
		OBJ	sys_res_o,	'O','OPPOSITE'
		OBJ	sys_res_of,	'OF','OFILE'
		OBJ	sys_res_op,	'OP','OPFILE'
		OBJ	sys_res_om,	'OM','OMARK'
		OBJ	sys_res_opm,	'OPM','OPMARK'
		OBJ	sys_res_om_r,	'OMARK_R'
		OBJ	sys_res_opm_r,	'OPMARK_R'
		OBJ	sys_res_om_c,	'O#','OMARK_COUNT'
		OBJ	sys_res_ocsr,	'OCURSOR'
		OBJ	sys_res_oent,	'OENTRIES'

* ̑
		OBJ	sys_res_b,	'B','BMARK','BOTH_SIDE_MARKS'
		OBJ	sys_res_rl,	'<','READLINE'
		OBJ	sys_res_status,	'STATUS'
		OBJ	sys_res_oldpwd,	'OLDPWD'
		OBJ	sys_res_side,	'SIDE'
		OBJ	sys_res_mpu,	'MPUTYPE'
		OBJ	sys_res_mintrc,	'MINTRC'

* mintarc
		OBJ	sys_res_mintarc,'MINTARC'
		OBJ	sys_res_mark_l,	'MARC_LEFT'
		OBJ	sys_res_mark_r,	'MARC_RIGHT'
		OBJ	sys_res_marc,	'MARC'
		OBJ	sys_res_marc_o,	'MARC_OPPOSITE'

* &gvon / &look-file
		OBJ	sys_res_gvon,	'GVON'
		OBJ	sys_res_square,	'SQUARE'
		OBJ	sys_res_look,	'LOOK'
		OBJ	sys_res_look_fn,'LOOK_FILE_NAME'

* 
		OBJ	sys_res_year,	'YEAR'
		OBJ	sys_res_year2,	'YEAR2'
		OBJ	sys_res_month,	'MONTH'
		OBJ	sys_res_day,	'DAY'
		OBJ	sys_res_hour,	'HOUR'
		OBJ	sys_res_minute,	'MINUTE'
		OBJ	sys_res_second,	'SECOND'
		.endm

* AhXe[up}N
OBJ:		.macro	label,v1,v2,v3
		.dc	label-$
		.endm

sys_res_val_adr:
		TABLE_BODY

* ϐe[up}N
OBJ:		.macro	label,v1,v2,v3
		.sizem	sz,cnt
		.dc.b	v1
	.if cnt>=3
		.dc.b	$01,v2
	.if cnt>=4
		.dc.b	$01,v3
	.endif
	.endif
		.dc.b	$00
		.endm

sys_res_val_tbl::
		TABLE_BODY
		.dc.b	0


* Text Section -------------------------------- *

**		.text
		.even


* R}hs -------------------------------- *
* in	d0.l	g[N
*	d1.l	g[Nobt@̃TCY
*	a0.l	g[N
* l:
*	g[Ñ͉.

execute_command::
		PUSH	d0-d1/d7/a1
		move.l	d0,d7

		clr.b	(Q_if_next,a5)

		move.b	(debug_flag,pc),d0
		beq	@f
		bsr	print_token_list
		jsr	(CursorBlinkOn)
		jsr	(dos_inpout)
		jsr	(CursorBlinkOff)
@@:
		jsr	(search_builtin_func)
		beq	exe_cmd_file
*exe_cmd_builtin:
		movea.l	d0,a1			;AhX
		move.l	d7,d0
		bsr	execute_builtin		;ߎs
		bra	exe_cmd_end
exe_cmd_file:
		tst.b	(Q_sw_a,a5)
		beq	@f			;-a w莞̓qXgɓo^
		tst.b	(Q_sw_p,a5)
		bne	exe_cmd_skip_print	;-p w莞͕\Ȃ
@@:
		move.l	d1,-(sp)		;hupair_encode Ŕj󂳂̂
		DOS	_MALLOC			;g[ÑRs[n
		move.l	d0,(sp)+
		bmi	exe_cmd_skip_print

		move.l	a0,-(sp)		;AhX
		move.l	d0,-(sp)
		movea.l	d0,a1			;VAhX

		moveq	#$f,d0
		and	d1,d0			;[
		lsr.l	#4,d1
		bra	1f
@@:
	.rept	4
		move.l	(a0)+,(a1)+
	.endm
1:		subq.l	#1,d1
		bcc	@b
		bra	1f
@@:
		move.b	(a0)+,(a1)+		;[]
1:		subq	#1,d0
		bcc	@b

		movea.l	(sp),a0
		move.l	d7,d0
		lea	(str_nul+.sizeof.('NUL'),pc),a1
		bsr	hupair_encode
		bmi	exe_cmd_print_error
		DOS	_MFREE			;Rs[obt@
**		addq.l	#4,sp

		move.l	a0,(sp)			;obt@
		lea	(HUPAIR_ID_SIZE+1,a0),a1

		tst.b	(Q_sw_p,a5)
		bne	@f
		move.l	d1,-(sp)
		pea	(a1)
		move	#1,-(sp)		;STDOUT
		DOS	_WRITE			;R}hC\
		lea	(10,sp),sp
		jsr	(PrintCrlf)
@@:
		tst.b	(Q_sw_a,a5)
		bne	@f
		bsr	make_cmd_sw		;qXgɓo^
		jsr	(add_cmd_his)
@@:
exe_cmd_print_error:
		DOS	_MFREE			;HUPAIR obt@
		addq.l	#4,sp
		movea.l	(sp)+,a0
exe_cmd_skip_print:
		move.l	d7,d0
		bsr	execute_file		;t@Cs
exe_cmd_end:
		move.b	(Q_if_next,a5),(Q_if_flag,a5)

		POP	d0-d1/d7/a1
		rts


* g[N\(fobOp) ------------------ *

print_token_list:
		PUSH	d0/d7/a0
		PR_STR	<"==== token ====",LF>
@@:
		moveq	#0,d0
		move.b	(a0)+,d0
		beq	3f
		cmpi.b	#TC_FILE,d0
		beq	1f
		cmpi.b	#TC_ESC,d0
		beq	2f
		move	d0,-(sp)
		DOS	_PUTCHAR
		addq.l	#2,sp
		bra	@b
1:		PR_STR	'<F>'
		bra	@b
2:		PR_STR	'<E>'
		bra	@b
3:		jsr	(PrintCrlf)

		subq.l	#1,d7
		bne	@b
		POP	d0/d7/a0
		rts


* g[Nobt@ ------------------------ *

free_token_buf::
		PUSH	d0/a5
		move.l	(q_ptr,pc),d0
		beq	free_token_buf_end
		movea.l	d0,a5
		move.l	(Q_funcname,a5),-(sp)
		ble	@f
		clr.l	(Q_funcname,a5)
		DOS	_MFREE
@@:		addq.l	#4,sp
free_token_buf_end:
		POP	d0/a5
		rts


* ߎs -------------------------------- *
* in	d0.l	g[N
*	a0.l	g[N
*	a1.l	AhX
* l:
*	&cursor-opposite-window Ȃǂ̎sɂ
*	a6.l 邱Ƃ.

execute_builtin::
		PUSH	d0-d7/a0-a5
**		PR_STR	<"==== builtin ====",LF>

		move.l	d0,d7
		move.l	a0,(Q_funcname,a5)
@@:		tst.b	(a0)+			;֐΂
		bne	@b

		lea	(a0),a3
		subq.l	#1,d7			;֐̕
		beq	exe_cmd_b_no_arg

		lea	(unless,pc),a2	;&unless &if &else-if 
		cmpa.l	a1,a2			;R[h폜Ȃ
		bhi	@f
		lea	(else_if,pc),a2
		cmpa.l	a1,a2
		bcc	exe_cmd_b_thru
@@:
		lea	(a0),a2
exe_cmd_b_loop:
		move.b	(a2)+,d1		;R[h菜
		cmpi.b	#TC_FILE,d1
		beq	exe_cmd_b_loop		;
		cmpi.b	#TC_ESC,d1
		bne	@f
		move.b	(a2)+,d1		;̂PoCĝ܂ܒʂ
@@:		move.b	d1,(a3)+
		bne	exe_cmd_b_loop
		subq.l	#1,d0
		bne	exe_cmd_b_loop
exe_cmd_b_no_arg:
.if 0
* R[h폜ubNkł邪A
* ʂł͂Ȃ̂őẍׂ̂܂܂ɂĂ.
		suba.l	(Q_funcname,a5),a3
		pea	(MARGIN,a3)		;̖ɗ]T
		move.l	(Q_funcname,a5),-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp
.endif
exe_cmd_b_thru:
		move.l	d7,d0			;̐(0`)
		jsr	(a1)			;ߌĂяo

		movea.l	(q_ptr,pc),a5
		move.l	(Q_funcname,a5),-(sp)
		ble	@f
		DOS	_MFREE			;g[Nobt@
@@:		addq.l	#4,sp

		POP	d0-d7/a0-a5
		rts


* OR}hs ---------------------------- *
* in	d0.l	g[N
*	a0.l	g[N

		.offset	0
~exe_file:	.ds.b	128
~exe_argv0:	.ds.b	128
~exe_args:	.ds.b	256
		.text

execute_file::
		PUSH	d0-d7/a0-a6
		move.l	d0,d7
		lea	(a0),a4			;g[N
		lea	(tmp_buf),a3

* VFN`FbN
		moveq	#0,d6
		tst.b	(Q_sw_v,a5)
		bne	exe_file_no_shell

* VFN܂܂邩ׂ
		lea	(schr_tbl-tmp_buf,a3),a1
		moveq	#0,d1			;[h
		moveq	#0,d0
		move.l	d7,d2
exe_file_shchk_f:
		eor.b	d0,d1
exe_file_shchk_loop:
		move.b	(a0)+,d0
		ble	exe_file_shchk_le
		cmpi.b	#TC_FILE,d0
		beq	exe_file_shchk_f
		cmpi.b	#TC_ESC,d0
		bne	@f
		move.b	(a0)+,d0
@@:
		tst.b	d1			;t@CɌꂽLނ
		bne	exe_file_shchk_loop	;VFNƌȂȂ

		tst.b	(a1,d0.w)
		beq	exe_file_shchk_loop
		bra	exe_file_shell		;VFN܂܂Ă
exe_file_shchk_le:
		beq	exe_file_shchk_next
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	exe_file_shchk_loop	;PoCgЉ
		addq.l	#1,a0
		bra	exe_file_shchk_loop
exe_file_shchk_next:
		subq.l	#1,d2
		bne	exe_file_shchk_loop

* VFNR}h܂܂邩ׂ
		tst	(unix)
		bne	exe_file_no_shell

		GETMES	MES_SCMD0
		movea.l	d0,a0
exe_file_shchk2_loop:
		lea	(a0),a1
		tst.b	(a0)
		beq	exe_file_no_shell
@@:
		move.b	(a0)+,d1
		beq	@f
		cmpi.b	#';',d1
		beq	@f
		lsr.b	#5,d1
		btst	d1,#%10010000
		beq	@b
		move.b	(a0)+,d1
		bne	@b
@@:
		clr.b	-(a0)			;Z~R NUL ɏ
		lea	(a4),a2
		jsr	(stricmp_a1_a2)
		seq	d0
		move.b	d1,(a0)+		;ɖ߂
		tst.b	d0
		beq	exe_file_shchk2_loop
		bra	exe_file_shell		;VFNR}h܂܂Ă

* VFNKv
exe_file_shell:
**		PR_STR	<"==== shell ====",LF>

* ϐ $MINTSHELL 
		lea	(~exe_file,a3),a1
		pea	(a1)
		clr.l	-(sp)
		pea	(str_mintshell,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		beq	@f
		GETMES	MES_SCMDX		;`Ȃ 'COMMAND.X' ɂ
		movea.l	d0,a0
		STRCPY	a0,a1
@@:
* VF
		lea	(~exe_file,a3),a0	;R}hC
		lea	(~exe_args,a3),a1	;obt@
		bsr	search_command
		bmi	exe_file_error

		lea	(~exe_argv0,a3),a1	;argv0 Zbg
		STRCPY	a0,a1

		move.l	d7,d0			;̐
		lea	(a4),a0			;
		lea	(~exe_args+1,a3),a1	;VFIvV
		bsr	shell_encode
		bmi	exe_file_error2

		exg	a0,a4
		move.l	d0,d7

* g[Nobt@
		pea	(a0)
		DOS	_MFREE
		addq.l	#4,sp

		lea	(a4),a0			;
		lea	(~exe_file,a3),a1	;argv0
		bra	exe_file_search_ok

* VFN͕sv
exe_file_no_shell:
**		PR_STR	<"==== file ====",LF>

* st@Co
		lea	(a4),a0
		lea	(a4),a1
		bsr	remove_tc
		lea	(a0),a2			;

		lea	(a4),a0
		STRLEN	a0,d1
		moveq	#-13,d0
		lsr.l	#7,d1			;cmpi.l #128,d1 / bcc
		bne	exe_file_error		;t@C

		lea	(~exe_file,a3),a1	;t@CZbg
		STRCPY	a0,a1
		lea	(a4),a0
		lea	(~exe_argv0,a3),a1	;argv0 Zbg
		STRCPY	a0,a1

* t@C
		lea	(~exe_file,a3),a0	;R}hC
		lea	(~exe_args,a3),a1	;obt@
		bsr	search_command
		bmi	exe_file_error2

		subq.l	#1,d7			;擪̃g[N̕
		lea	(a2),a0			;
		lea	(~exe_argv0,a3),a1	;argv0
exe_file_search_ok:
* GR[h
		move.l	d7,d0
		bsr	hupair_encode
		bmi	exe_file_error2

		exg	a0,a4
		move.l	d0,d7

* g[Nobt@
		pea	(a0)
		DOS	_MFREE
		addq.l	#4,sp

* ʃɈړ
		move.l	d7,-(sp)
		move	#2,-(sp)
		DOS	_MALLOC2
		addq.l	#6,sp
		move.l	d0,d2
		bmi	exe_file_lift_skip

		movea.l	d0,a1			;Vobt@
		pea	(a4)

		moveq	#$f,d0
		and	d7,d0			;[
		lsr.l	#4,d7
		bra	1f
@@:
	.rept	4
		move.l	(a4)+,(a1)+		;16 oCgPʂœ]
	.endm
1:		subq.l	#1,d7
		bcc	@b
		bra	1f
@@:
		move.b	(a4)+,(a1)+		;[]
1:		subq	#1,d0
		bcc	@b

		movea.l	d2,a4

		DOS	_MFREE			;ȑÕobt@
		addq.l	#4,sp
exe_file_lift_skip:

* st@C[h
		PUSH	a3/a4
		clr.l	-(sp)
		pea	(HUPAIR_ID_SIZE,a4)
		pea	(~exe_file,a3)
		move	#LOAD,-(sp)
		move.l	a4,d7
		DOS	_EXEC
		move.l	a4,d7			;d7 = sAhX
		lea	(14,sp),sp
		POP	a3/a4
		tst.l	d0
		bmi	exe_file_error2

* HUPAIR `FbN
		movea.l	d7,a0
		addq.l	#2,a0
		cmpi.l	#'#HUP',(a0)+
		bne	@f
		cmpi.l	#'AIR'<<8,(a0)+
		beq	exe_file_hupair_ok	;HUPAIR Ή
@@:
* st@C HUPAIR ΉȂA
* HUPAIR GR[fBO
		lea	(a4),a0
		clr.l	(a0)+			;HUPAIR ʎqׂ
		clr.l	(a0)+
		addq.l	#1,a0

		moveq	#SPACE,d1
		lea	(a0),a1
		lea	(GetArgChar),a2
		pea	(a0)
		jsr	(GetArgCharInit-GetArgChar,a2)
		addq.l	#4,sp
exe_file_dec_loop:
		jsr	(a2)
@@:		move.b	d0,(a1)+
		bne	exe_file_dec_loop
		move.b	d1,(-1,a1)
		jsr	(a2)
		tst.l	d0
		bpl	@b

		clr.b	-(a1)
		move.l	a1,d1
		sub.l	a0,d1
		move.b	d1,-(a0)		;

		lsr.l	#8,d1
		beq	exe_file_hupair_ok	;255 oCgȉȂs\

* HUPAIR Ή̎st@C 255 oCg𒴂
* nƂꍇ̓G[Ԃ
		PUSH	a3-a6			;_~[R[hs
		pea	(exe_file_dummy,pc)	;[hvOI
		move	#EXECONLY,-(sp)
		DOS	_EXEC
		addq.l	#6,sp
		POP	a3-a6
		moveq	#-41,d0
		bra	exe_file_error2
exe_file_dummy:
		DOS	_EXIT
exe_file_hupair_ok:
		bsr	execute_switch_before

* sJnԋL^
		tst.b	(getsec_flag)
		bne	@f
		IOCS	_ONTIME
		move.l	d0,(_sO)
@@:
* [hς݃vOs
		PUSH	a4-a6
		move.l	d7,-(sp)		;sAhX
		move	#EXECONLY,-(sp)
		DOS	_EXEC
		addq.l	#6,sp
		POP	a4-a6

* @exitcode/@status XV
		lea	(exitcode,pc),a0
		move	d0,(a0)
		move	d0,(status-exitcode,a0)

* sIԋL^
		IOCS	_ONTIME
		move.l	d0,(_s)

		bsr	execute_switch_after
		bra	exe_file_end
exe_file_error2:
		lea	(~exe_argv0,a3),a0
exe_file_error:
		bsr	print_dos_error
exe_file_end:
		move.l	a4,-(sp)		;eobt@\
		ble	@f
		DOS	_MFREE
@@:		addq.l	#4,sp

		POP	d0-d7/a0-a6
		rts


* VFGR[h ------------------------ *
* in	d0.l	g[N
*	a0.l	g[N
*	a1.l	VFIvV(/C Ȃ)
* out	d0.l	̐(ȂG[R[h)
*	a0.l	obt@AhX
*	ccr	<tst.l d0> ̌

PUT:		.macro	put_op
		subq.l	#1,d7
		bcs	sh_enc_overflow
		put_op
		.endm

shell_encode::
		PUSH	d1-d7/a1-a3
		move.l	d0,d4

		pea	(-1)
		DOS	_MALLOC
		move.l	d0,(sp)
		clr.b	(sp)
		DOS	_MALLOC
		move.l	(sp)+,d7		;obt@TCY
		move.l	d0,d6
		bmi	sh_enc_memerr

		movea.l	d6,a2
		moveq	#1,d5			;̐

* VFIvV𕪊Ȃ]
sh_enc_shopt_loop:
		bsr	skip_blank
		move.b	(a1)+,d0
		beq	sh_enc_shopt_end
		addq.l	#1,d5
@@:
		PUT	<move.b  d0,(a2)+>
		beq	sh_enc_shopt_end
		move.b	(a1)+,d0
		cmpi.b	#TAB,d0
		beq	@f
		cmpi.b	#SPACE,d0
		bne	@b
@@:
		PUT	<clr.b  (a2)+>
		bra	sh_enc_shopt_loop
sh_enc_shopt_end:

* g[NNH[eBOA󔒂ŌqȂ]

* TC_FILE Ŋꂽ͈͂
*	u'v́u"vŃNH[eBO
*	u"v́u'vŃNH[eBO
*	Xy[X/^u͂ǂ炩ŃNH[eBO
*	ȊÕVFŃu'vŃNH[eBO
* ȊO͈̔͂
*	u'v́u"vŃNH[eBO
*	u"v́u'vŃNH[eBO
*	Xy[X/^u͂ǂ炩ŃNH[eBO
*	ȊÕVFN̓NH[eBOȂ

		moveq	#0,d0
		move	(unix),d2
		moveq	#"'",d3			;ÕNH[eBO
		lea	(schr_tbl),a3
sh_enc_token_loop:
		tst.b	(a0)
		beq	sh_enc_token_nul	;󕶎

		moveq	#-1,d1			;[h
sh_enc_token_f:
		not	d1
sh_enc_token_loop2:
		move.b	(a0)+,d0
		beq	sh_enc_token_next
		cmpi.b	#TC_FILE,d0
		beq	sh_enc_token_f
		cmpi.b	#TC_ESC,d0
		bne	@f
		move.b	(a0)+,d0
@@:
		cmpi.b	#TAB,d0
		beq	sh_enc_token_q		;󔒂 '  " ̂ǂ炩Ŋ
		cmpi.b	#SPACE,d0
		beq	sh_enc_token_q		;V
		cmpi.b	#"'",d0
		beq	sh_enc_token_qd
		cmpi.b	#'"',d0
		beq	sh_enc_token_qs
		tst	d1
		beq	sh_enc_token_put
		tst.b	(a3,d0.w)		;t@CɃVFN
		bne	sh_enc_token_qs		;'`' ŃNH[eBO
sh_enc_token_put:
		PUT	<move.b  d0,(a2)+>
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	sh_enc_token_loop2
		PUT	<move.b  (a0)+,(a2)+>
		bra	sh_enc_token_loop2
sh_enc_token_qd:
		moveq	#'"',d3
		bra	sh_enc_token_q
sh_enc_token_qs:
		moveq	#"'",d3
sh_enc_token_q:
		tst	d2
		beq	sh_enc_token_put	;%unix 0 ȂNH[eBOȂ

		PUT	<move.b  d3,(a2)+>
		PUT	<move.b  d0,(a2)+>
		PUT	<move.b  d3,(a2)+>
		bra	sh_enc_token_loop2
sh_enc_token_nul:
		tst	d2
		beq	sh_enc_token_next	;%unix 0 ȂNH[eBOȂ

		PUT	<move.b  d3,(a2)+>
		PUT	<move.b  d3,(a2)+>
sh_enc_token_next:
		PUT	<move.b  #SPACE,(a2)+>
		subq.l	#1,d4
		bne	sh_enc_token_loop
		clr.b	(-1,a2)

		suba.l	d6,a2			;obt@KvTCYɏk
		move.l	a2,-(sp)
		move.l	d6,-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp

		movea.l	d6,a0
		move.l	d5,d0
sh_enc_end:
		POP	d1-d7/a1-a3
		rts
sh_enc_overflow:
		move.l	d6,-(sp)
		DOS	_MFREE
		addq.l	#4,sp
sh_enc_memerr:
		moveq	#-8,d0
		bra	sh_enc_end


* HUPAIR GR[h --------------------------- *
* in	d0.l	g[N
*	a0.l	g[N
*	a1.l	argv0
* out	d0.l	obt@TCY(ȂG[R[h)
*	d1.l	R}hC̒
*	a0.l	obt@AhX
*		.dc.b	'#HUPAIR',0
*		.dc.b	len
*		.dc.b	'arg...',0
*	ccr	<tst.l d0> ̌

PUT:		.macro	put_op
		subq.l	#1,d7
		bcs	hu_enc_overflow
		put_op
		.endm

hupair_encode::
		PUSH	d3-d7/a1-a4
		move.l	d0,d4
		lea	(a1),a4

		pea	(-1)
		DOS	_MALLOC
		move.l	d0,(sp)
		clr.b	(sp)
		DOS	_MALLOC
		move.l	(sp)+,d7		;obt@TCY
		move.l	d0,d6
		bmi	hu_enc_memerr

		movea.l	d6,a2

		STRLEN	a1,d0,+HUPAIR_ID_SIZE+1+1
		sub.l	d0,d7			;HUPAIR_ID,c,NUL,argv0,NUL ̃TCY
		bcs	hu_enc_overflow

		move.l	#'#HUP',(a2)+
		move.l	#'AIR'<<8,(a2)+
		st	(a2)+			;R}hC̒(b)
		lea	(a2),a3

		tst.l	d4
		beq	hu_enc_nulstr

		move.l	a0,d5			;g[Nobt@擪
hu_enc_loop:
		movea.l	d5,a1
		bsr	remove_tc		;R[hO

* NH[eBOL𔻕ʂ
		movea.l	d5,a1
		move.b	(a1)+,d3
		beq	hu_enc_qd		;󕶎
hu_enc_q_loop:
		cmpi.b	#"'",d3
		beq	hu_enc_qd
		cmpi.b	#'"',d3
		beq	hu_enc_qs
		cmpi.b	#SPACE,d3
		bne	hu_enc_q_next

* 󔒂 " ܂ ' ̂ǂ炩
@@:		move.b	(a1)+,d3
		beq	hu_enc_qd
		cmpi.b	#"'",d3
		beq	hu_enc_qd
		cmpi.b	#'"',d3
		bne	@b
hu_enc_qs:
		moveq	#"'",d3
		bra	@f
hu_enc_qd:
		moveq	#'"',d3
@@:		PUT	<move.b  d3,(a2)+>	;NH[eBOJn
		bra	@f
hu_enc_q_next:
		move.b	(a1)+,d3
		bne	hu_enc_q_loop

		moveq	#0,d3			;NH[eBOsv
@@:
* NH[eBOȂ]
		movea.l	d5,a1
		move.b	(a1)+,d0
		beq	hu_enc_next
hu_enc_loop2:
		cmp.b	d0,d3
		bne	@f
		PUT	<move.b  d3,(a2)+>	;NH[eBOI
		eori.b	#"'".xor.'"',d3
		PUT	<move.b  d3,(a2)+>	;NH[eBOĊJ
@@:
		PUT	<move.b  d0,(a2)+>
		move.b	(a1)+,d0
		bne	hu_enc_loop2
hu_enc_next:
		tst.b	d3
		beq	@f
		PUT	<move.b  d3,(a2)+>	;NH[eBOI
@@:
		PUT	<move.b  #SPACE,(a2)+>
		subq.l	#1,d4
		bne	hu_enc_loop
		subq.l	#1,a2
hu_enc_nulstr:
		clr.b	(a2)

		move.l	a2,d1
		sub.l	a3,d1			;R}hC̒
		addq.l	#1,a2
		cmpi.l	#$ff,d1
		bcc	@f
		move.b	d1,-(a3)
@@:
		STRCPY	a4,a2			;argv0 𖖔ɕt

		movea.l	d6,a0			;obt@擪
		suba.l	a0,a2			;obt@TCY
		move.l	a2,-(sp)
		pea	(a0)
		DOS	_SETBLOCK
		addq.l	#8,sp
		move.l	a2,d0
hu_enc_end:
		POP	d3-d7/a1-a4
		rts
hu_enc_overflow:
		move.l	d6,-(sp)
		DOS	_MFREE
		addq.l	#4,sp
hu_enc_memerr:
		moveq	#-8,d0
		bra	hu_enc_end


* R[h폜 ------------------------------ *
* in	a0.l	
*	a1.l	݃obt@
* out	a0.l	NUL ̎̃AhX()
*	a1.l	V		(obt@)
* break	d0

remove_tc:
@@:		move.b	(a0)+,d0
		cmpi.b	#TC_FILE,d0
		beq	@b
		cmpi.b	#TC_ESC,d0
		bne	1f
		move.b	(a0)+,d0
1:		move.b	d0,(a1)+
		beq	@f
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b
		move.b	(a0)+,(a1)+
		bne	@b
@@:
		rts


* DOS G[bZ[W\ -------------------- *
* in	d0.l	G[R[h
*	a0.l	t@C

print_dos_error:
		PUSH	d0-d2/a0
		move.l	d0,d2
		pea	(a0)
		DOS	_PRINT
		addq.l	#4,sp

		lea	(err_mes_tbl,pc),a0
		cmpi.l	#$ffffffb0,d2
		bcc	@f
		moveq	#0,d2
@@:
		move.b	(a0)+,d0		;bZ[Wԍ
		move.b	(a0)+,d1		;G[R[h
		beq	@f
		cmp.b	d1,d2
		bne	@b
@@:
		jsr	(PrintMsgCrlf)
		POP	d0-d2/a0
		rts

err_mes_tbl:
		.dc.b	MES_E_NOF,-2		;w肵t@CȂ
		.dc.b	MES_E_FOP,-4		;I[vĂt@C
		.dc.b	MES_E_NOM,-8		;sɕKvȃȂ
		.dc.b	MES_E_FMT,-11		;st@C̃tH[}bgُ
		.dc.b	MES_E_NAM,-13		;t@C̎wɌ肪
		.dc.b	MES_E_DRV,-15		;hCuwɌ肪
		.dc.b	MES_E_RDY,-40		;hCȕoĂȂ(g)
		.dc.b	MES_E_ARG,-41		;HUPAIR ɑΉĂȂ(g)
		.dc.b	MES_E_EXE,0		;̑̃G[
		.even


* st@C ---------------------------- *
* in	d0.l	0 ȊOȂJgfBNg猟Ȃ
*	a0.l	R}hC/t@Cobt@
*	a1.l	obt@
* out	d0.l	G[R[h
*		  0:.x|.r|.z
*		  1:.bat
*		-40:hCȕoĂȂ(g)
*		̑̐lȂ DOS R[̃G[R[h.
* l:
*	DOS _EXEC gp.
*	gq .bat/.BAT ͕⊮Ȃ̂ŁAȗ
*	Lqł.

search_command::
		PUSH	d1-d4/a2
		moveq	#TAB,d2
		moveq	#SPACE,d3
		move.l	d0,d4

		lea	(a0),a2
@@:
		move.b	(a2)+,d0		;擪̋󔒂΂
		cmp.b	d2,d0
		beq	@b
		cmp.b	d3,d0
		beq	@b
		subq.l	#1,a2

		moveq	#0,d1
		bra	sch_cmd_scan_next
sch_cmd_scan_loop:
		cmpi.b	#'/',d0
		beq	sch_cmd_scan_found	;pXf~^
		cmpi.b	#'\',d0
		beq	sch_cmd_scan_found	;V
		cmp.b	d2,d0
		beq	sch_cmd_scan_blank	;R}hI
		cmp.b	d3,d0
		beq	sch_cmd_scan_blank	;V
		cmpi.b	#':',d0
		bne	sch_cmd_scan_next
sch_cmd_scan_found:
		moveq	#1,d1
sch_cmd_scan_next:
		move.b	(a2)+,d0
		bgt	sch_cmd_scan_loop
		beq	sch_cmd_scan_nul
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	sch_cmd_scan_next
		tst.b	(a2)+
		bne	sch_cmd_scan_next
sch_cmd_scan_nul:
		subq.l	#1,a2
sch_cmd_scan_blank:
		tst	d1
		beq	sch_cmd_no_path

* hCupXf~^ꍇ
		move.b	(a2),-(sp)
		clr.b	(a2)			;󔒈ȍ~؂藣
		jsr	(get_drive_status)
		move.b	(sp)+,(a2)
		tst.l	d0
		bmi	sch_cmd_end
		andi.b	#1<<DRV_NOTREADY+1<<DRV_INSERT+1<<DRV_ERRINS,d0
		subq.b	#1<<DRV_INSERT,d0
		beq	sch_cmd_pathchk
*sch_cmd_notready:
		moveq	#-40,d0
		bra	sch_cmd_end

* t@Ĉ݂̏ꍇ($path )
sch_cmd_no_path:
		tst.l	d4
		bne	@f			;&which -c ȂɃpb`Ă
		moveq	#0,d1
		jsr	(dos_drvctrl_d1)
		bmi	sch_cmd_end
		andi.b	#1<<DRV_NOTREADY+1<<DRV_INSERT+1<<DRV_ERRINS,d0
		subq.b	#1<<DRV_INSERT,d0
		beq	sch_cmd_pathchk		;JghCu}Ȃ
@@:		bsr	set_dos_exec_patch	;DOS _EXEC Ƀpb`Ă

sch_cmd_pathchk:
		clr.l	-(sp)
		pea	(a1)			;obt@
		pea	(a0)			;R}hC
		move	#PATHCHK,-(sp)
		DOS	_EXEC
		lea	(14,sp),sp
		bsr	restore_dos_exec_patch
		tst.l	d0
		bmi	sch_cmd_end

		jsr	(to_mintslash)

		lea	(a0),a2
@@:		tst.b	(a2)+
		bne	@b
		subq.l	#.sizeof.('.bat')+1,a2
		moveq	#0,d0
		cmpa.l	a2,a0
		bcc	sch_cmd_end		;.x|.r|.z|gqȂ
		move.b	(a2)+,-(sp)
		move	(sp)+,d1
		move.b	(a2)+,d1
		swap	d1
		move.b	(a2)+,-(sp)
		move	(sp)+,d1
		move.b	(a2)+,d1
		ori.l	#$00202020,d1
		cmpi.l	#'.bat',d1
		bne	sch_cmd_end
		moveq	#1,d0			;.bat
sch_cmd_end:
		POP	d1-d4/a2
		tst.l	d0
		rts


* DOS _EXEC JgfBNg}pb`
set_dos_exec_patch:
		PUSH	d0-d1
		TO_SUPER
		move	#$600e,d1
		cmp	($9d80),d1
		bne	@f
		DOS	_VERNUM
		cmpi	#$0302,d0
		bne	@f

		move	d1,(dos_exec_patch_flag)
		move	#$2048,($9d80)		;movea.l a0,a0
		cmpi.b	#2,(MPUTYPE)
		bcs	@f
		moveq	#3,d1			;LbVj
		IOCS	_SYS_STAT
@@:
		TO_USER
		POP	d0-d1
		rts

* DOS _EXEC pb`A
* (mint.s  prepare_exit_mint Ă΂)
restore_dos_exec_patch::
		PUSH	d0-d1/a1
		lea	(dos_exec_patch_flag,pc),a1
		move	(a1),d1
		beq	@f
		clr	(a1)
		lea	($9d80),a1		;DOS _EXEC ̃pb`ɖ߂
		IOCS	_B_WPOKE
@@:
		POP	d0-d1/a1
		rts


dos_exec_patch_flag:
		.dc	0


* VFNe[u쐬 ------------------ *

init_schr_tbl::
		PUSH	d0-d1/a0-a1
		tst	(unix)
		seq	d0
		addi.b	#MES_SCHR1,d0
		jsr	(get_message)
		movea.l	d0,a0

		lea	(schr_tbl+128),a1
		moveq	#0,d0
		moveq	#128/(4*4)-1,d1
@@:
	.rept	4
		move.l	d0,-(a1)		;obt@NA
	.endm
		dbra	d1,@b
@@:
		st	(a1,d0.w)		;tOZbg
		move.b	(a0)+,d0
		bgt	@b
		beq	@f
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	@b			;PoCgЉ
		tst.b	(a0)+
		bne	@b
@@:
		POP	d0-d1/a0-a1
		rts


* IvVXCb`̏(sO) ------------ *

execute_switch_before::

* J[\ʒut@Cۑ
		jsr	(set_curfile2)

* t@NVL[\s
		jsr	(RestoreFnckey)
		tst.b	(Q_sw_f,a5)
		beq	1f
		jsr	(SaveCursor)
		jsr	(fnckey_disp_off)
		jsr	(RestoreCursor)
		bra	@f
1:
		jsr	(restore_fnckey_mode)	;mint NȌԂɖ߂
@@:

* Sʎs
		move.b	(Q_sw_s,a5),(Q_redraw,a5)
		beq	@f			;ĕ`vtOĂ
		moveq	#32,d0
		tst.b	(Q_sw_f,a5)
		bne	1f
		cmpi	#3,(orig_fnckey_mode)
		beq	1f
		moveq	#31,d0
1:		move.l	d0,-(sp)
		move	#15,-(sp)
		DOS	_CONCTRL		;XN[͈͐ݒ(S)
		addq.l	#6,sp
		jsr	(ConsoleClear)
		bra	exe_sw_b_skip_s
@@:
		tst.b	(Q_sw_f,a5)
		beq	@f
		lea	(fnmd),a0
		move	(a0),-(sp)
		beq	1f
		clr	(a0)
		jsr	(set_scr_param)
		jsr	(set_scroll_narrow_console)
1:		move	(sp)+,(a0)
		jsr	(set_scr_param)
@@:
		jsr	(ConsoleClear2)		;%cclr 0 Ȃʏ

* ʏԕۑ
		pea	(save_text_state,pc)
		DOS	_SUPER_JSR
		addq.l	#4,sp
exe_sw_b_skip_s:

* eLXgpbg
		tst.b	(Q_sw_atmark,a5)
		beq	@f
		bsr	init_text_palette
@@:

* ʃvCIeB
		tst.b	(Q_sw_q,a5)
		beq	@f
		moveq	#T_ON+G_ON,d1
		IOCS	_VC_R2
@@:

* DOS  / ̑
		jsr	(fep_enable)
		jsr	(breakck_restore)
		jsr	(restore_keyinp_ex_vector)

* J[\
		tst.b	(Q_sw_i,a5)
		bne	@f
		jsr	(CursorBlinkOn)
@@:
		rts


* eLXgpbg ---------------------- *
* break	d0-d2

init_text_palette::
		moveq	#-2,d2
		moveq	#3,d1
@@:
		IOCS	_TPALET
		dbra	d1,@b
		rts


* IvVXCb`̏(s) ------------ *

execute_switch_after::

* L[͑҂
		cmpi.b	#'h',(Q_sw_h_k,a5)
		bcs	@f			;-h / -k Ȃ
		st	(disable_clock_flag)
		beq	1f
		jsr	(dos_inpout)		;-k
		bra	2f
1:		jsr	(key_wait)		;-h
2:		clr.b	(disable_clock_flag)
@@:

* J[\
**		tst.b	(Q_sw_i,a5)		;-i ȂłqvZXI
**		bne	@f			;\̂ŁAɏ
		jsr	(CursorBlinkOff)
**@@:

* DOS  / ̑
		jsr	(hook_keyinp_ex_vector)
		jsr	(breakck_save_kill)
		jsr	(WinFontInit)
		jsr	(fep_disable)

* OtBbN
		bsr	execute_switch_g

* ʏԌ
		jsr	(set_crt_mode_768x512)
		bne	1f
		tst.b	(Q_redraw,a5)
		bne	@f
		pea	(check_text_state,pc)
		DOS	_SUPER_JSR
		move.l	d0,(sp)+
1:		sne	(Q_redraw,a5)
@@:

* t@NVL[\s
		jsr	(SaveFnckey)
		jsr	(ChangeFnckey)
		tst.b	(Q_sw_f,a5)
		beq	1f
		IOCS	_B_DOWN_S
		IOCS	_B_UP_S
		jsr	(SaveCursor)
		jsr	(fnckey_disp_on2)
		jsr	(RestoreCursor)
		bra	@f
1:
**		jsr	(get_fnckey_mode)
		jsr	(reset_fnckey_mode)	;ɖ߂
@@:

* R\[͈
		tst.b	(Q_redraw,a5)
		bne	@f
		jsr	(set_scr_param)
		jsr	(set_scroll_narrow_console)
@@:

* Sʎs / ʃNA / [h
		moveq	#%0000_0011,d0
		and.b	(Q_sw_d,a5),d0
		tst.b	(Q_sw_l,a5)
		beq	@f
		ori.b	#%0100_0000,d0
@@:		tst.b	(Q_redraw,a5)
		beq	@f
		ori.b	#%1100_1100,d0
@@:
		jsr	(print_screen)
		jsr	(reset_current_dir)

* sԁEIR[h\
		moveq	#0,d0
		move	(code),d0
		beq	@f
		tst	(cplp)
		bne	@f			;cplp sɕ\ς
		tst.b	(getsec_flag)
		bne	1f
		bsr	print_runtime
1:		bsr	print_exitcode
@@:
		rts


* -g XCb`̏ --------------------------- *

execute_switch_g::
		move.b	(Q_sw_g,a5),d1
		beq	exe_sw_g_end0
		move.l	(buildin,pc),d0
		tst	d0
		bne	exe_sw_g_end0		;G[Iꍇ͋NȂ
		move.l	d0,-(sp)

		cmpi.b	#'0',d1
		beq	@f
		jsr	(check_gusemd)
		bne	exe_sw_g_end		;GVRAM ͎gp
@@:
		moveq	#$f,d0
		and.b	(Q_sw_g,a5),d0
		move.b	(@f,pc,d0.w),d0
		jmp	(@f,pc,d0.w)
@@:
		.dc.b	exe_sw_g0_gvoff-@b
		.dc.b	exe_sw_g1_half16-@b
		.dc.b	exe_sw_g2_half256-@b
		.dc.b	exe_sw_g3_half-@b
		.dc.b	exe_sw_g4_gvon256-@b
		.dc.b	exe_sw_g5_gvon-@b
		.dc.b	exe_sw_g6_half64k-@b
		.dc.b	exe_sw_g7_gvon16-@b
		.dc.b	exe_sw_g8_gvon64k-@b
		.dc.b	exe_sw_g9_gvon24khz-@b

exe_sw_g0_gvoff:
		jsr	(gvram_off)		;-g0
		bra	exe_sw_g_end

exe_sw_g3_half:
		bsr	exe_sw_g_getcol		;-g3 (&half)
		beq	exe_sw_g1_half16
		subq	#1,d0
		beq	exe_sw_g2_half256
exe_sw_g6_half64k:
		bsr	exe_sw_sq_chk		;-g6 (&half 64KF)
		jsr	(g_half_64k_usr)
		bra	exe_sw_g_end
exe_sw_g2_half256:
		bsr	exe_sw_sq_chk		;-g2 (&half 256F)
		jsr	(g_half_256_usr)
		bra	exe_sw_g_end
exe_sw_g1_half16:
		jsr	(g_half_16_usr)		;-g1 (&half 16F)
		bra	exe_sw_g_end

exe_sw_g5_gvon:
		bsr	exe_sw_g_getcol		;-g5 (&gvon)
		beq	exe_sw_g7_gvon16
		subq	#1,d0
		beq	exe_sw_g4_gvon256
exe_sw_g8_gvon64k:
		bsr	exe_sw_g_sub		;-g8 (&gvon 64KF)
		jsr	(gvon_64k_usr)
		bra	exe_sw_g_redraw
exe_sw_g4_gvon256:
		bsr	exe_sw_g_sub		;-g4 (&gvon 256F)
		jsr	(gvon_256_usr)
		bra	exe_sw_g_redraw
exe_sw_g9_gvon24khz:
		st	(GVON24_flag)		;-g9 (&gvon Ȃ)
exe_sw_g7_gvon16:
		bsr	exe_sw_g_sub		;-g7 (&gvon 16F)
		jsr	(gvon_16_usr)
		bra	exe_sw_g_redraw

exe_sw_g_redraw:
		st	(Q_redraw,a5)		;Sʂ̍ĕ`悪Kv
exe_sw_g_end:
		move.l	(sp)+,(buildin)
exe_sw_g_end0:
		rts


* OtBbN\F[h
* out	d0.l	[h
* break	d1
exe_sw_g_getcol:
		moveq	#-1,d1
		IOCS	_VC_R0
		andi	#3,d0
		rts

exe_sw_g_sub:
		clr.l	(graph_home)
exe_sw_sq_chk:
		jmp	(gm_check_square)
**		rts


* sԕ\ -------------------------------- *
* in	d0.l	Œ\(0 ȂK\)
*
* t@CsɎsԂR\[ɕ\
* (%cplp 1 ܂ %code 0 ̏ꍇ͌ĂяoȂ).
* ܂AS`FCI &getsec s
* oߎԂ\(%cplp 1 ̏ꍇ͑
* print_cplp_line Ăяo).

print_runtime::
		PUSH	d0-d1/a0-a1
		move.l	(_s),d1
		sub.l	(_sO),d1
		bcc	@f
		addi.l	#24*60*60*100,d1
@@:
		cmp.l	d0,d1
		bcs	print_runtime_end

		lea	(sp),a1
		lea	(-12,sp),sp
		move.l	d1,d0
		moveq	#3,d1
		lea	(sp),a0
		FPACK	__IUSING
		clr	-(a1)
		move.l	#('0'.xor.SPACE)*$01010000+CR<<8+LF,-(a1)
		move	-(a0),d0		;
		or	d0,(a1)
		move.b	#'.',-(a1)
@@:
		moveq	#'0'.xor.SPACE,d0
		or.b	-(a0),d0
		move.b	d0,-(a1)
		cmpa.l	a0,sp
		bne	@b
		pea	(a1)
		DOS	_PRINT
		lea	(12+4,sp),sp
print_runtime_end:
		POP	d0-d1/a0-a1
		rts


* ʏԕۑ -------------------------------- *
* break	d0-d1/a0-a1

* R\[͌Ȃ悤ɒӂ邱. `FbN
* ̂̓^CgA{[ApXAt@CXgA
* hCuł邪A%dirh ŏ(3)ɂꍇ
* R\[ɂȂ悤ɔ͈͂߂ƁA
*  7 sƂȂ.
*	128*16*7/48  298
* ɂ 298 oCgƂɃ`FbN.

save_text_state::
		bsr	text_state_sub
		move.l	($948),(a1)+		;eLXg\JnAhXItZbg
		move.l	($970),(a1)+		;eLXg-1/s-1
@@:
		move.l	(a0),(a1)+
		lea	(298,a0),a0
		dbra	d1,@b
		rts

text_state_sub:
		lea	(TVRAM_P0),a0
		lea	(tmp_buf),a1
		moveq	#48-1,d1
		rts


* ʏԌ -------------------------------- *
* out	d0.l	!= 0 ̎AeLXgj
* break	d1/a0-a1

check_text_state::
		bsr	text_state_sub
		move.l	($948),d0
		sub.l	(a1)+,d0
		bne	9f
		move.l	($970),d0
		sub.l	(a1)+,d0
		bne	9f
@@:
		move.l	(a0),d0
		sub.l	(a1)+,d0
		lea	(298,a0),a0
		dbne	d1,@b
9:		rts


* IR[h\ ------------------------------ *

* t@CsɏIR[hR\[ɕ\.
* %cplp 1 ܂ %code 0 ̏ꍇ͌ĂяoȂ.

print_exitcode::
		PUSH	d0/a0
		move	(exitcode,pc),d0
		beq	print_exitcode_end

		subq.l	#8,sp
		ext.l	d0
		lea	(sp),a0
		FPACK	__LTOS
		GETMES	MES_EXCOD
		move.l	d0,-(sp)
		DOS	_PRINT
		pea	(4,sp)
		DOS	_PRINT
		lea	(8+8,sp),sp
		jsr	(PrintCrlf)
print_exitcode_end:
		POP	d0/a0
		rts


*  ------------------------------------ *

*************************************************
*		&debug				*
*************************************************

debug::
		lea	(debug_flag,pc),a0
		not.b	(a0)
		rts


*************************************************
*		&end=&return			*
*************************************************

end::
		movea.l	(q_ptr,pc),a5
		st	(Q_abort,a5)
		rts


*************************************************
*		&eval				*
*************************************************

eval::
* 󔒂Ōq
		lea	(a0),a1
		move.l	d7,d1
		moveq	#SPACE,d0
		bra	1f
@@:
		tst.b	(a0)+
		bne	@b
		move.b	d0,-(a0)
1:
		subq.l	#1,d1
		bcc	@b
		clr.b	(a0)

		move.l	a0,d1
		sub.l	a1,d1
		bsr	eval_sub
eval_error:
		rts


* s/&eval 
* in	d1.l	strlen (a1)
*	a1.l	ǉ madoka
* out	ccr	N=0:I N=1:G[
* break	d0

eval_sub:
		PUSH	d1-d3/a1/a3-a4
		add.l	(Q_buf_size,a5),d1	;KvTCY

		move.l	d1,-(sp)
		move	#2,-(sp)		;malloc_mode
		DOS	_MALLOC2
		addq.l	#6,sp
		move.l	d0,d2
		bmi	eval_sub_end

		move.l	(Q_buf_top,a5),d3	;ȑÕobt@
		move.l	d2,(Q_buf_top,a5)
		move.l	d1,(Q_buf_size,a5)

		move.l	(Q_macro,a5),d0
		beq	@f
		sub.l	d3,d0
		add.l	d2,d0
		move.l	d0,(Q_macro,a5)
@@:
		movea.l	(Q_next_ptr,a5),a4	;c madoka
		move.b	(a4),d0
		clr.b	(a4)

		movea.l	d3,a2			;]
		movea.l	d2,a3			;    
		STRCPY	a2,a3			;ߍς݂ madoka ]
		subq.l	#1,a3

		move.b	d0,(a4)
		move.l	a3,(Q_next_ptr,a5)

		STRCPY	a1,a3			;s͂̌ʂq
		subq.l	#1,a3

		STRCPY	a4,a3			;c madoka q

		move.l	d3,-(sp)
		DOS	_MFREE			;ȑÕobt@
		clr.l	(sp)+			;N=0
eval_sub_end:
		POP	d1-d3/a1/a3-a4
		rts


* 򖽗߃`FbN ------------------------ *
*
* ݎs̖(&else/&else-if)̒O
* (&if/&unless/&else-if)ł邩ǂׁA
* łȂG[bZ[W\ē
* I(Ăяo̓߂ɂ͋AȂ).
* madoka ̎ŝI.

else_check::
		move.l	a5,-(sp)
		movea.l	(q_ptr,pc),a5
		tst.b	(Q_if_flag,a5)
		movea.l	(sp)+,a5
		bne	else_check_end

		movea.l	(q_ptr,pc),a5
		st	(Q_abort,a5)
		move.l	(Q_funcname,a5),(sp)	;֐
		DOS	_PRINT
		addq.l	#4,sp
		moveq	#MES_MERR5,d0
		jmp	(PrintMsgCrlf)
else_check_end:
		rts


* ubNLq`FbN ------------------------ *
*
* ݎs̖߂̒ɃubNLqĂ邩
* ǂׁALqĂȂG[bZ[W
* \ē߂I(Ăяo̓
* ɂ͋AȂ). madoka ̎ŝI.

block_check::
		PUSH	d0/a1/a5
		movea.l	(q_ptr,pc),a5
		movea.l	(Q_next_ptr,a5),a1
		bsr	fetch_char
		cmpi.b	#'{',d0
		POP	d0/a1/a5
		beq	block_check_end

		movea.l	(q_ptr,pc),a5
		st	(Q_abort,a5)
		move.l	(Q_funcname,a5),(sp)	;֐
		DOS	_PRINT
		addq.l	#4,sp
		moveq	#MES_MERR4,d0
		jmp	(PrintMsgCrlf)
block_check_end:
		rts


*************************************************
*		&else				*
*************************************************

else::
		bsr	else_check
		bsr	block_check

		movea.l	(q_ptr,pc),a5
		movea.l	(Q_next_ptr,a5),a1
		tst.b	(Q_if_flag,a5)
		bmi	else_false		;&if ς

* ubNs
*if_true:
		bsr	free_token_buf
		bsr	execute_block
		bra	@f

* ubN΂
else_false:
		bsr	skip_block
@@:
		move.l	a1,(Q_next_ptr,a5)
		clr.b	(Q_if_next,a5)		; &else s
		rts


*************************************************
*		&else-if=&elsif			*
*************************************************

else_if::
		bsr	else_check
		bsr	block_check

		movea.l	(q_ptr,pc),a5
		movea.l	(Q_next_ptr,a5),a1
		tst.b	(Q_if_flag,a5)
		bmi	else_if_false		;&if ς

		moveq	#0,d6
		bra	if_elsif

* ubN΂
else_if_false:
		bsr	skip_block
		move.l	a1,(Q_next_ptr,a5)
		st	(Q_if_next,a5)		;&if 
		rts


*************************************************
*		&unless				*
*************************************************

unless::
		moveq	#1,d6
		ror.l	#1,d6			;bset #IF_UNLESS,d6
		bra.s	if_unless


*************************************************
*		&if				*
*************************************************

IF_UNLESS:	.equ	31
IF_CONST:	.equ	15
IF_EXP:		.equ	14
IF_FILE:	.equ	7
IF_PAREN:	.equ	6


if::
		moveq	#0,d6
if_unless:
		bsr	block_check
if_elsif:
		bsr	if_exp

		movea.l	(q_ptr,pc),a5
		tst.b	(Q_abort,a5)
		bne	if_error2		;t@Cq̃G[
		move.l	d0,d1
		bsr	if_get_char
		bne	if_error		;cĂ
		move.l	d1,d0

		btst	#IF_EXP,d6
		bne	if_exist_exp

		move.l	d0,d1
		moveq	#0,d0
		move	(status,pc),d0
		btst	#IF_CONST,d6
		beq	if_exist_exp		;SďȗȂA@status != 0

		cmp.l	d1,d0			;萔ȂA@status == 萔
		seq	d0
		moveq	#1,d1
		and.l	d1,d0
if_exist_exp:
		tst.l	d6
		bpl	@f
		bsr	if_cmp_d0_0		;&unless Ȃ^Ultɂ
@@:
* ̒l^ǂ𒲂ׂ
		movea.l	(Q_next_ptr,a5),a1
		tst.l	d0
		beq	if_false

* ubNs
*if_true:
		bsr	free_token_buf
		bsr	execute_block
		move.l	a1,(Q_next_ptr,a5)
		st	(Q_if_next,a5)		;&if 
		rts

* ubN΂
if_false:
		bsr	skip_block
		move.l	a1,(Q_next_ptr,a5)
		move.b	#$01,(Q_if_next,a5)	;&if s
		rts

if_error:
		move.l	(Q_funcname,a5),-(sp)	;֐
		DOS	_PRINT
		addq.l	#4,sp
		moveq	#MES_MERR6,d0
		bra	@f
if_error2:
		moveq	#MES_MERR2-1,d0
		add.b	(Q_abort,a5),d0		;&merr2 / &merr3
@@:
		st	(Q_abort,a5)
		jmp	(PrintMsgCrlf)
**		rts


* d0  0 r
* in	d0.l	l
* out	d0.l	0:sv 1:v
*	ccr	<tst.l d0> ̌
* break	d1

if_cmp_d0_0:
		tst.l	d0
		seq	d0
		moveq	#1,d1
		and.l	d1,d0
		rts


* NUL ȊO̕
* i/o	d7.l	̐
*	a0.l	̃AhX
* out	d0.l	0:Ȃ ȊO:d0.b 
*	ccrZ	1:Ȃ 0:

if_get_char_next:
		subq.l	#1,d7
if_get_char::
		move.l	d7,d0
		beq	@f
		move.b	(a0)+,d0
		beq	if_get_char_next
if_exp_end:
@@:		rts


* <> ̒lvZ
if_exp::
		bsr	if_get_char
		beq.s	if_exp_end
		cmpi.b	#'!',d0
		beq	if_exp_not
		subq.l	#1,a0
		bra	if_term
**		rts
if_exp_not:
		bsr	if_term			;! <>
		bset	#IF_EXP,d6
		bra	if_cmp_d0_0		;^Ultɂ
**		rts


* <> ̒lvZ
if_term::
		bsr	if_get_char
		beq	if_term_end
		subq.l	#1,a0
		bsr	if_factor
		move.l	d0,-(sp)
		bsr	if_get_char
		beq	if_term_end2
		subq.l	#1,a0			;Zq邩ׂ
		bsr	if_get_op_type
		bpl	@f
if_term_end2:
		move.l	(sp)+,d0		;ZqȂ
if_term_end:
		rts
@@:
		move	d0,-(sp)		;<q> <Zq> <q>
		bsr	if_factor
		move	(sp)+,d2		;d2=Zq
		move.l	(sp)+,d1		;d1= d0=E

		bset	#IF_EXP,d6
		move	(@f,pc,d2.w),d2
		cmp.l	d1,d0
		jmp	(@f,pc,d2.w)
@@:
		.dc	if_term_eq-@b		;==
		.dc	if_term_ne-@b		;!=
		.dc	if_term_hi-@b		;<
		.dc	if_term_cc-@b		;<=
		.dc	if_term_cs-@b		;>
		.dc	if_term_ls-@b		;>=
if_term_eq:
		seq	d0
		bra	@f
if_term_ne:
		sne	d0
		bra	@f
if_term_hi:
		shi	d0
		bra	@f
if_term_cc:
		scc	d0
		bra	@f
if_term_cs:
		scs	d0
		bra	@f
if_term_ls:
		sls	d0
@@:
		moveq	#1,d1
		and.l	d1,d0
		rts


* <q> ̒lvZ
if_factor::
		bsr	if_get_char
		beq	if_fac_end
		cmpi.b	#'(',d0
		beq	if_fac_paren

		subq.l	#1,a0
		jsr	(atoi_a0)
		beq	if_fac_const
		bsr	if_get_atvalue
		bpl	if_fac_atvalue
		cmpi.b	#'-',(a0)
		bne	@f
		bsr	if_file_test
		bra	if_fac_file_test
@@:
		bsr	if_command
if_fac_command:
if_fac_atvalue:
if_fac_file_test:
		bset	#IF_EXP,d6		;<ϐ>A<t@C>A<R}h>
if_fac_end:
		rts
if_fac_const:
		bset	#IF_CONST,d6		;<萔>
		rts

if_fac_paren:
		clr.l	-(sp)
		bsr	if_get_char
		beq	@f
		cmpi.b	#')',d0
		beq	@f			;( )
		addq.l	#4,sp
		subq.l	#1,a0

		move.b	d6,-(sp)		;( <> )
		bset	#IF_PAREN,d6
		bsr	if_exp
		move.b	(sp)+,d6

		move.l	d0,-(sp)
		bsr	if_get_char
		beq	@f
		cmpi.b	#')',d0
		beq	@f
		subq.l	#1,a0			; ) Ȃ
@@:
		move.l	(sp)+,d0
		rts


* Zq̎ނ𒲂ׂ
* in	a0.l	
* out	a0.l	Zq̏ꍇAZq̎̕
*		ZqłȂꍇ͕ςȂ
*	d0.l	-2:Zqł͂Ȃ
*		 0:==	2:!=	4:<	6:<=	8:>	10:>=
*	ccr	<tst.l d0> ̌

if_get_op_type::
		move.b	(a0)+,-(sp)
		move	(sp)+,d0
		move.b	(a0)+,d0
		cmpi	#'==',d0
		beq	1f
		cmpi	#'!=',d0
		beq	2f
		cmpi	#'<=',d0
		beq	6f
		cmpi	#'>=',d0
		beq	9f
		subq.l	#1,a0
		lsr	#8,d0
		cmpi.b	#'<',d0
		beq	4f
		cmpi.b	#'>',d0
		beq	8f
		subq.l	#1,a0
		moveq	#-2,d0
		rts
1:		moveq	#0,d0
		rts
2:		moveq	#2,d0
		rts
4:		moveq	#4,d0
		rts
6:		moveq	#6,d0
		rts
8:		moveq	#8,d0
		rts
9:		moveq	#10,d0
		rts


* ϐ̒l
* in	a0.l	
* out	a0.l	ϐ̏ꍇAϐ̎̕
*		ϐłȂꍇ͕ςȂ
*	d0.l	$0000`$ffff:ϐ̒l
*		-1:ϐł͂Ȃ
*	ccr	<tst.l d0> ̌

if_get_atvalue::
		PUSH	d1-d2/a2
		moveq	#0,d2

		move	(status,pc),d2
		lea	(str_atstatus,pc),a1
		bsr	if_get_atval_sub
		subq	#.sizeof.('@st'),d0
		bcc	if_get_atval_found

		move	(exitcode,pc),d2
		lea	(str_atexitcode,pc),a1
		bsr	if_get_atval_sub
		subq	#.sizeof.('@ex'),d0
		bcc	if_get_atval_found

		move	(buildin,pc),d2
		lea	(str_atbuildin,pc),a1
		bsr	if_get_atval_sub
		subq	#.sizeof.('@bu'),d0
		bcc	if_get_atval_found

		moveq	#-1,d0
		bra	@f
if_get_atval_found:
		addq.l	#.sizeof.('@st'),a0
		adda.l	d0,a0
		move.l	d2,d0
@@:
		POP	d1-d2/a2
		rts

if_get_atval_sub:
		lea	(a0),a2
@@:
		tst.b	(a1)
		beq	@f
		cmpm.b	(a1)+,(a2)+
		beq	@b
		subq.l	#1,a2
@@:
		move.l	a2,d0
		sub.l	a0,d0			;v
		rts


if_ftst_error:
		moveq	#1<<0,d0		;Ή̃t@Cq
		bra	@f
if_ftst_error2:
		moveq	#1<<1,d0		;t@CȂ
@@:		movea.l	(q_ptr,pc),a5
		or.b	d0,(Q_abort,a5)
if_ftst_not_test:
		moveq	#-1,d0
		rts
* t@C
if_file_test::
		lea	(a0),a1
		cmpi.b	#'-',(a1)+
		bne	if_ftst_not_test	;t@Cqł͂Ȃ
		move.b	(a1)+,d0
		beq	if_ftst_error		;q̋Lq
		tst.b	(a1)+
		bne	if_ftst_error		;V

		lea	(file_opt_list+12,pc),a2
		moveq	#12-1,d1
@@:
		cmp.b	-(a2),d0
		dbeq	d1,@b
		bne	if_ftst_error		;Ή̌q
@@:
		lea	(a1),a0
@@:
		subq.l	#1,d7
		beq	if_ftst_error2		;t@CȂ
		tst.b	(a0)+
		beq	@b
		subq.l	#1,a0

* O '(' ȂA')' ܂łt@CƌȂ
		lea	(a0),a1			;t@CR[h폜
		lea	(a0),a3
		moveq	#0,d4
		bclr	#IF_FILE,d6
if_ftst_paren_loop:
		move.b	(a0)+,d0
		beq	if_ftst_paren_end
		cmpi.b	#TC_FILE,d0
		bne	@f
		bchg	#IF_FILE,d6
		bra	if_ftst_paren_loop
@@:
		cmpi.b	#TC_ESC,d0
		beq	1f
		tst.b	d6			;btst #IF_FILE,d6
		bmi	@f
		cmpi.b	#'(',d0
		beq	if_ftst_o_paren		;'(' 
		cmpi.b	#')',d0
		beq	if_ftst_c_paren		;')' 
@@:
		move.b	d0,(a1)+
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	if_ftst_paren_loop
1:		move.b	(a0)+,(a1)+
		bra	if_ftst_paren_loop
if_ftst_o_paren:
		addq.l	#1,d4			;'(' lXgJn
		bra	@b
if_ftst_c_paren:
		subq.l	#1,d4
		bcc	@b			;')' lXgI
		moveq	#0,d4
		btst	#IF_PAREN,d6
		beq	@b			;'(' Ȃ ')' ͂̂܂ܒʂ
if_ftst_paren_end:
		move.b	-(a0),d3
		clr.b	(a1)
		exg	a0,a3			;a3=̈

		lea	(tmp_buf),a2
		pea	(a2)
		pea	(a0)
		DOS	_NAMECK
		addq.l	#8,sp
		lea	(NAMECK_Drive,a2),a1
		STREND	a1			;pX
		tst.l	d0
		bmi	9f
		not.b	d0
		bne	8f			;t@C

* fBNg
		clr.b	-(a1)			;Ō̃pXf~^폜
		tst.b	(NAMECK_Path,a2)
		bne	7f

* hCû("d:")ɂȂꍇ
		pea	(NAMECK_Path+2,a2)
		pea	(NAMECK_Drive,a2)
		clr	-(sp)			;ASSIGN_GET
		DOS	_ASSIGN
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	9f

		move.b	(MINTSLASH),(a1)+
		moveq	#1<<DIRECTORY,d0
		bra	9f
* t@C
8:
		move.l	a1,-(sp)
		lea	(NAMECK_Name,a2),a0
		STRCPY	a0,a1
		subq.l	#1,a1
		lea	(NAMECK_Ext,a2),a0
		STRCPY	a0,a1
		movea.l	(sp)+,a1
7:
		lea	(NAMECK_Drive,a2),a0
		jsr	(to_mintslash)

		move	#-1,-(sp)
		pea	(a2)
		DOS	_CHMOD
		addq.l	#6,sp
9:
		lea	(a3),a0
		move.b	d3,-(a0)

		add	d1,d1
		move	(@f,pc,d1.w),d1
		tst.l	d0
		jmp	(@f,pc,d1.w)
@@:
		.dc	if_ftst_r-@b
		.dc	if_ftst_w-@b
		.dc	if_ftst_x-@b
		.dc	if_ftst_s-@b
		.dc	if_ftst_h-@b
		.dc	if_ftst_l-@b
		.dc	if_ftst_d-@b
		.dc	if_ftst_f-@b
		.dc	if_ftst_e-@b
		.dc	if_ftst_z-@b
		.dc	if_ftst_T-@b
		.dc	if_ftst_B-@b
file_opt_list:
		.dc.b	'rwxshldfezTB'
		.even

* -r : ǂݍ݉\(!DIRECTORY && !VOLUME)
if_ftst_r:
		moveq	#1<<DIRECTORY+1<<VOLUME,d1
		bra	@f

* -w : ݉\(!READONLY && !SYSTEM && !DIRECTORY && !VOLUME)
if_ftst_w:
		moveq	#1<<DIRECTORY+1<<VOLUME+1<<SYSTEM+1<<READONLY,d1
@@:		tst.l	d0
		bmi	if_ftst_false
		and.b	d0,d1
		beq	if_ftst_true
		bra	if_ftst_false

* -x : s\(EXEC)
if_ftst_x:
		add.b	d0,d0
		bra	@f

* -s : VXe(SYSTEM)
if_ftst_s:
		lsr.b	#SYSTEM+1,d0
		bra	@f

* -h : B(HIDDEN)
if_ftst_h:
		lsr.b	#HIDDEN+1,d0
		bra	@f

* -l : V{bNN(LINK)
if_ftst_l:
		lsl.b	#8-LINK,d0
		bra	@f

* -d : fBNg(DIRECTORY)
if_ftst_d:
		lsl.b	#8-DIRECTORY,d0
@@:
		bcc	if_ftst_false
		tst.l	d0
		bmi	if_ftst_false
		bra	if_ftst_true

* -f : ʏt@C(ARCHIVE ȊO==0)
if_ftst_f:
		moveq	#1<<ARCHIVE,d1
		cmp.l	d0,d1
		beq	if_ftst_true
		bra	if_ftst_false

* -e : t@C݂(ChJ[hΉ)
if_ftst_e:
		bpl	if_ftst_true

		lea	(256,a2),a3		;tmp_buf+256
		move	#$ff,-(sp)
		pea	(a2)
		pea	(a3)
		DOS	_FILES
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		bmi	if_ftst_false

		lea	(FILES_FileName,a3),a3
		STRCPY	a3,a1
		bra	if_ftst_true

* -z : t@CTCY==0(&& !DIRECTORY && !VOLUME)
if_ftst_z:
		bmi	if_ftst_false
		andi.b	#1<<DIRECTORY+1<<VOLUME,d0
		bne	if_ftst_false

		clr	-(sp)
		pea	(a2)
		DOS	_OPEN
		addq.l	#6,sp
		tst.l	d0
		bmi	if_ftst_false

		move	#SEEK_END,-(sp)		;t@CɈړ
		clr.l	-(sp)
		move	d0,-(sp)
		DOS	_SEEK
		move.l	d0,d1
		DOS	_CLOSE
		addq.l	#8,sp
		tst.l	d1
		beq	if_ftst_true
		bra	if_ftst_false

* -T : eLXgt@C(&& !DIRECTORY && !VOLUME)
if_ftst_T:
		moveq	#0,d1
		bra	@f

* -B : oCit@C(&& !DIRECTORY && !VOLUME)
if_ftst_B:
		moveq	#1,d1
@@:		tst.l	d0
		bmi	if_ftst_false
		andi.b	#1<<DIRECTORY+1<<VOLUME,d0
		bne	if_ftst_false

		clr	-(sp)
		pea	(a2)
		DOS	_OPEN
		addq.l	#6,sp
		tst.l	d0
		bmi	if_ftst_false

		lea	(1024),a1
		suba.l	a1,sp			;lea (-1024,sp),sp
		lea	(sp),a3

		move.l	a1,-(sp)		;move.l #1024,-(sp)
		pea	(a3)
		move	d0,-(sp)
		DOS	_READ
		move.l	d0,d2			;d2 = f[^TCY
		DOS	_CLOSE
		lea	(10,sp),sp
		move.l	d2,d0
		bmi	@f
		exg	a0,a3
		bsr	if_ftst_is_binary
		lea	(a3),a0
@@:
		adda.l	a1,sp			;lea (1024,sp),sp
		cmp.l	d0,d1
		beq	if_ftst_true
if_ftst_false:
		moveq	#0,d0
		rts
if_ftst_true:
		jsr	(set_user_value_match_a2)
		moveq	#1,d0
		rts


* eLXg/oCi
* in	d0.l	f[^TCY
*	a0.l	obt@AhX
* out	d0.l	0:eLXgt@C 1:oCit@C

if_ftst_is_binary::
		PUSH	d1-d3/a0
		move.l	d2,d0

		moveq	#$40+2,d0		;X `st@C̃`FbN
		cmp.l	d0,d2
		bcs	@f
		cmpi	#'HU',(a0)
		bne	@f
		cmpi	#2,(2,a0)
		bls	if_is_bin_file_true
@@:
		moveq	#0,d0
		moveq	#10-1,d1
		move.l	#1<<BS+1<<TAB+1<<LF+1<<CR+1<<ESC,d3
		bra	if_is_bin_file_next
if_is_bin_file_loop:
		move.b	(a0)+,d0
		bgt	@f			;ASCII
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	if_is_bin_file_next	;oCgЉ

		addq.l	#1,a0			;oCg
		dbra	d2,if_is_bin_file_next
		bra	if_is_bin_file_true
@@:
		subi.b	#$20,d0
		bcc	if_is_bin_file_next	;oCg
		btst	d0,d3
		bne	if_is_bin_file_next	;eLXgt@CɊ܂܂鐧L
if_is_bin_file_ctrl:
		dbra	d1,if_is_bin_file_next
if_is_bin_file_true:
		moveq	#1,d0
		bra	@f
if_is_bin_file_next:
		dbra	d2,if_is_bin_file_loop
		moveq	#0,d0
@@:		POP	d1-d3/a0
		rts


* R}hs
if_command::
* O '(' ȂA')' ܂łg[NƌȂ
		lea	(a0),a1
		moveq	#0,d4
		move.l	d7,d5
if_cmd_paren_loop:
		bclr	#IF_FILE,d6
if_cmd_paren_loop2:
		move.b	(a1)+,d0
		beq	if_cmd_paren_next
		cmpi.b	#TC_FILE,d0
		bne	@f
		bchg	#IF_FILE,d6
		bra	if_cmd_paren_loop2
@@:
		cmpi.b	#TC_ESC,d0
		beq	1f
		tst.b	d6			;btst #IF_FILE,d6
		bmi	@f
		cmpi.b	#'(',d0
		beq	if_cmd_o_paren		;'(' 
		cmpi.b	#')',d0
		beq	if_cmd_c_paren		;')' 
@@:
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	if_cmd_paren_loop2
1:		addq.l	#1,a1
		bra	if_cmd_paren_loop2
if_cmd_o_paren:
		addq.l	#1,d4			;'(' lXgJn
		bra	if_cmd_paren_loop2
if_cmd_c_paren:
		subq.l	#1,d4
		bcc	if_cmd_paren_loop2	;')' lXgI
		moveq	#0,d4
		btst	#IF_PAREN,d6
		beq	if_cmd_paren_loop2	;'(' Ȃ ')' ͂̂܂ܒʂ

		clr.b	-(a1)			;')'  NUL ɏĂ
		tst.b	(-1,a1)
		beq	@f
		addq.l	#1,d7
		bra	@f
if_cmd_paren_next:
		subq.l	#1,d5
		bne	if_cmd_paren_loop
		subq.l	#1,a1
@@:
* d5 = R}hp̃g[Nc̈̐(0`)
		sub.l	d5,d7			;g[N(1`)
		move.l	a1,d1
		sub.l	a0,d1
		addq.l	#1,d1			;g[Nobt@̃TCY

		move.l	d1,-(sp)
		move	#2,-(sp)		;malloc_mode
		DOS	_MALLOC2
		addq.l	#6,sp
		tst.l	d0
		bmi	if_cmd_memory_error

		movea.l	d0,a2
@@:		move.b	(a0)+,(a2)+		;g[Nobt@ɓ]
		cmpa.l	a0,a1
		bcc	@b

		movea.l	(q_ptr,pc),a5
**		move.b	(Q_if_next,a5),d1
		movea.l	(Q_funcname,a5),a2

		movea.l	d0,a0			;g[ÑAhX
		move.l	d7,d0			;g[N
		bsr	execute_command

		move.l	a2,(Q_funcname,a5)
**		move.b	d1,(Q_if_next,a5)

if_cmd_memory_error:
		lea	(a1),a0			;̈
		move.l	d5,d7
		beq	@f
		move.b	#')',(a0)		; ')' ɖ߂
@@:
		moveq	#0,d0
		move	(status,pc),d0
**		tst.l	d0
		rts


* ̎dl
*	<> := ! <> | <>
*	<> := <q> | <q> <Zq> <q>
*	<q> := ( <> ) | <>
*	<> := <萔> | <ϐ> | <t@C> | <R}h>


*************************************************
*		&foreach			*
*************************************************

foreach::
		bsr	block_check

		moveq	#0,d6			;-n
		lea	(str_ul,pc),a3		;ftHg̕ϐ
		suba.l	a4,a4			;P(NULL Ȃ疳[v)
foreach_arg_loop1:
		subq.l	#1,d7
		bcs	foreach_infinity	;&foreach { ... }
		move.b	(a0)+,d0
		beq	foreach_arg_loop1
		cmpi.b	#'(',d0
		beq	foreach_o_paren		;ϐȗ
		cmpi.b	#'-',d0
		bne	foreach_name		;ϐw肠
		cmpi.b	#'n',(a0)
		bne	foreach_name
		tst.b	(1,a0)
		bne	foreach_name
*foreach_opt_n:
		addq.l	#.sizeof.('-n')+1,a0	;-n : ͈͎w}
		moveq	#-1,d6
		bra	foreach_arg_loop1
foreach_name:
		lea	(-1,a0),a3
@@:		tst.b	(a0)+
		bne	@b
foreach_arg_loop2:
		subq.l	#1,d7
		bcs	foreach_infinity	;&foreach name { ... }
		move.b	(a0)+,d0
		beq	foreach_arg_loop2
		cmpi.b	#'(',d0
		beq	foreach_o_paren
*foreach_no_o_paren:
		subq.l	#1,a0			;擪̊ʂȂ
		bra	foreach_no_c_paren	;̂Ȃ̂ƌȂ
foreach_o_paren:
		tst.b	(a0)
		bne	@f
		addq.l	#1,a0			;ŏ̒Pꂪ '(' Ȃ΂
		subq.l	#1,d7
		bcs	foreach_infinity	;&foreach ( { ... }
@@:
		lea	(a0),a2
		move.l	d7,d2
		beq	1f			;ʂ܂߂āAP񂪒P̈
@@:
		tst.b	(a2)+			;Ō̈܂ňړ
		bne	@b
		subq.l	#1,d2
		bne	@b
1:
		cmpi.b	#')',(a2)		;Ō̒Pꂪ ')' Ȃ
		bne	@f			;ƍ폜
		tst.b	(1,a2)
		bne	@f
		subq.l	#1,d7
		bcs	foreach_infinity	;&foreach ( ) { ... }
@@:
foreach_arg_loop3:
		move.b	(a2)+,d0
		beq	foreach_no_c_paren	;̊ʂȂ
		cmpi.b	#')',d0
		beq	foreach_c_paren
		lsr.b	#5,d0
		btst	d0,#%10010000
		beq	foreach_arg_loop3
		addq.l	#1,a2
		bra	foreach_arg_loop3
foreach_c_paren:
		tst.b	(a2)
		bne	foreach_arg_loop3
		clr.b	-(a2)			;̊ʂ
foreach_no_c_paren:
		lea	(a0),a4
foreach_infinity:

		.offset	0
~fe_next_ptr:	.ds.l	1
~fe_macro:	.ds.l	1
~fe_buf_top:	.ds.l	1
~fe_buf_size:	.ds.l	1
sizeof_fe:
		.text

		movea.l	(q_ptr,pc),a5
		move.l	(Q_buf_size,a5),-(sp)
		move.l	(Q_buf_top,a5),-(sp)
		move.l	(Q_macro,a5),-(sp)
		move.l	(Q_next_ptr,a5),-(sp)
foreach_loop:
		clr.b	d6			;͈͎wtO
		move.l	a4,d0
		beq	foreach_inf1
		tst	d6
		bmi	foreach_regular_word	;͈͎w֎~

* A..Z Ƃ`ׂ
		lea	(a4),a0
		move.b	(a0)+,d0
		beq	foreach_regular_word
		lsr.b	#5,d0
		btst	d0,#%10010000
		bne	foreach_regular_word
		move.b	(a0)+,d0
		cmpi.b	#'.',d0
		bne	foreach_regular_word
		cmp.b	(a0)+,d0
		bne	foreach_regular_word
		move.b	(a0)+,d0
		beq	foreach_regular_word
		lsr.b	#5,d0
		btst	d0,#%10010000
		bne	foreach_regular_word
		tst.b	(a0)+
		bne	foreach_regular_word

* ͈͎w肾
		move.b	(a4)+,d6		;Jn
		addq.l	#.sizeof.('..'),a4
		move.b	(a4),d5			;I
foreach_loop2:
		move.b	d6,(a4)
foreach_regular_word:
		lea	(a3),a1
		lea	(a4),a2
		jsr	(set_user_value_a1_a2)	;ϐݒ
foreach_inf1:

		move.l	(~fe_buf_size,sp),d1
		move.l	d1,(Q_buf_size,a5)

		move.l	d1,-(sp)
		move	#2,-(sp)		;malloc_mode
		DOS	_MALLOC2
		addq.l	#6,sp
		move.l	d0,(Q_buf_top,a5)
		bmi	foreach_end

		movea.l	d0,a2
		movea.l	(~fe_buf_top,sp),a0
		sub.l	a0,d0
		STRCPY	a0,a2			;madoka 𕡐
		move.l	(~fe_macro,sp),d1
		beq	@f
		add.l	d0,d1
@@:		move.l	d1,(Q_macro,a5)		;}NʒuXV

		movea.l	(~fe_next_ptr,sp),a1
		adda.l	d0,a1
		move.l	a1,(Q_next_ptr,a5)	;sAhXXV

		bsr	execute_block

		move.l	(Q_buf_top,a5),-(sp)
		DOS	_MFREE
		addq.l	#4,sp

		tst.b	(Q_abort,a5)
		bne	foreach_end

		tst.b	(Q_skip,a5)
		beq	@f
		sf	(Q_skip,a5)		;&continue sꂽ
		bmi	foreach_end		;&break V
@@:
		move.l	a4,d0
		beq	foreach_inf2
		tst.b	d6
		beq	foreach_next
foreach_incdec:
		cmp.b	d6,d5
		beq	foreach_next		;͈͎w肪I
		bhi	1f
		subq.b	#1,d6
		bra	@f
1:		addq.b	#1,d6
@@:
		move.b	d6,d0
		lsr.b	#5,d0
		btst	d0,#%10010000
		bne	foreach_incdec		;oCg͒ʉ߂

		jsr	(break_check)
		beq	foreach_loop2
		bra	foreach_end
foreach_next:
		subq.l	#1,d7
		bcs	foreach_end		;PSď
@@:
		tst.b	(a4)+			;̒PɈړ
		bne	@b
foreach_inf2:
		jsr	(break_check)
		beq	foreach_loop
foreach_end:
		move.l	(sp)+,(Q_next_ptr,a5)
		move.l	(sp)+,(Q_macro,a5)
		move.l	(sp)+,(Q_buf_top,a5)
		move.l	(sp)+,(Q_buf_size,a5)

		movea.l	(Q_next_ptr,a5),a1
		bsr	skip_block
		move.l	a1,(Q_next_ptr,a5)
		rts


*************************************************
*		&continue=&next			*
*************************************************

continue::
		movea.l	(q_ptr,pc),a5
		move.b	#$01,(Q_skip,a5)
		rts


*************************************************
*		&break=&last			*
*************************************************

break::
		movea.l	(q_ptr,pc),a5
		st	(Q_skip,a5)
		rts


*************************************************
*		&prefix				*
*************************************************

prefix::
		move.l	d7,d0
		beq	prefix_end		;Ȃ

		move	#$8000,d5
		moveq	#1,d6
		bra	prefix_next
prefix_loop:
		lea	(a0),a1
		cmpi.b	#'-',(a1)+
		bne	@f
		cmpi.b	#'n',(a1)+
		bne	@f
		tst.b	(a1)
		bne	@f
*prefix_opt_n:
		moveq	#0,d5			;-n : ʏ}
		bra	prefix_skip
@@:
		jsr	(atoi_a0)
		bne	prefix_error
		tst.b	(a0)+
		bne	prefix_error

		subq.l	#1,d0			;1`8 -> bit0`7
		moveq	#8-1,d1
		cmp.l	d1,d0
		bhi	prefix_error

		bchg	d0,(prefix_flag)	;tO]
		bra	prefix_next
prefix_error:
		moveq	#0,d6
prefix_skip:
		tst.b	(a0)+
		bne	prefix_skip
prefix_next:
		subq.l	#1,d7
		bcc	prefix_loop

		or	d5,(init_sc_flag)
		move	d6,d0
prefix_end:
		jmp	(set_status)
**		rts


*************************************************
*		&set-opt			*
*************************************************

set_opt::
		movea.l	(q_ptr,pc),a5
		subq.l	#1,d7
		bcs	clear_cmd_sw		;ȗ̓NA
set_opt_loop:
		move.b	(a0),d0
		beq	set_opt_next
		moveq	#'-',d1
		cmpi.b	#'+',d0
		beq	set_opt_append		;擪 '+' Ȃ珉Ȃ
		cmp.b	d1,d0
		bne	set_opt_next
		bsr	clear_cmd_sw
set_opt_append:
		move.b	d1,(a0)			;'+'  '-' ɏ
		lea	(a0),a1
		bsr	analyze_cmd_sw
set_opt_next:
		tst.b	(a0)+
		bne	set_opt_next
		subq.l	#1,d7
		bcc	set_opt_loop
		rts


*************************************************
*		&command-history-menu		*
*************************************************

command_history_menu::
		bra	call_command_history
**		rts


call_command_history:
		moveq	#-1,d0
		neg	d0			;move.l #$ffff_0001,d0
call_command_history2:
		jsr	(command_history)
		movea.l	(q_ptr,pc),a5
		beq	@f
		st	(Q_abort,a5)
@@:		rts


*************************************************
*		&command-history		*
*************************************************

command_history::
		jsr	(command_history_menu)
		moveq	#0,d7			;Ȃ
		bra	call_command_history2
**		rts


* Data Section -------------------------------- *

**		.data
		.even

subwin_rl::	SUBWIN	8,8,80,1,NULL,NULL

str_mintshell:	.dc.b	'MINTSHELL',0
str_home:	.dc.b	'HOME',0
str_nul:	.dc.b	'NUL',0
str_0:		.dc.b	'0',0
str_1:		.dc.b	'1',0
str_ul:		.dc.b	'_',0

str_left:	.dc.b	'left',0
str_right:	.dc.b	'right',0
str_off:	.dc.b	'off',0
str_max:	.dc.b	'max',0
str_half:	.dc.b	'half',0

str_atexitcode:	.dc.b	'@exitcode',0
str_atbuildin:	.dc.b	'@buildin',0
str_atstatus:	.dc.b	'@status',0

str_argv0:	.dc.b	'argv0',0
str_argv:	.dc.b	'argv',0


* Block Storage Section ----------------------- *

**		.bss
		.even

q_ptr::		.ds.l	1

exitcode::	.ds	1
buildin::	.ds	1
status::	.ds	1

init_sc_flag::	.ds	1

debug_flag::	.ds.b	1
prefix_flag:	.ds.b	1


* Block Storage Section ----------------------- *

		.bss
		.even

tmp_buf:	.ds.b	512

schr_tbl:	.ds.b	128


		.end

* End of File --------------------------------- *
